{-# OPTIONS_GHC -Wall #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}
{-# OPTIONS_GHC -fno-warn-orphans #-}
{-# Language ForeignFunctionInterface #-}
{-# Language FlexibleInstances #-}
{-# Language MultiParamTypeClasses #-}

module Casadi.Core.Classes.GenericType
       (
         GenericType,
         GenericTypeClass(..),
         genericType__0,
         genericType__1,
         genericType__10,
         genericType__11,
         genericType__12,
         genericType__13,
         genericType__2,
         genericType__3,
         genericType__4,
         genericType__5,
         genericType__6,
         genericType__7,
         genericType__8,
         genericType__9,
         genericType_can_cast_to__0,
         genericType_can_cast_to__1,
         genericType_from_type,
         genericType_getType,
         genericType_get_description,
         genericType_get_type_description,
         genericType_isBool,
         genericType_isDictionary,
         genericType_isDouble,
         genericType_isDoubleVector,
         genericType_isEmptyVector,
         genericType_isFunction,
         genericType_isInt,
         genericType_isIntVector,
         genericType_isIntVectorVector,
         genericType_isSharedObject,
         genericType_isString,
         genericType_isStringVector,
         genericType_toBool,
         genericType_toDouble,
         genericType_toDoubleVector,
         genericType_toFunction,
         genericType_toInt,
         genericType_toIntVector,
         genericType_toIntVectorVector,
         genericType_toSharedObject,
         genericType_toString,
         genericType_toStringVector,
         genericType_toVoidPointer,
       ) where


import Prelude hiding ( Functor )

import Data.Vector ( Vector )
import Foreign.C.Types
import Foreign.Marshal ( new, free )
import Foreign.Storable ( peek )
import Foreign.Ptr ( Ptr, nullPtr )
import Foreign.ForeignPtr ( newForeignPtr )
import System.IO.Unsafe ( unsafePerformIO ) -- for show instances

import Casadi.Internal.CToolsInstances ( )
import Casadi.Internal.FormatException ( formatException )
import Casadi.Internal.MarshalTypes ( StdVec, StdString) -- StdPair StdOstream'
import Casadi.Internal.Marshal ( Marshal(..), withMarshal )
import Casadi.Internal.WrapReturn ( WrapReturn(..) )
import Casadi.Core.Data
import Casadi.Core.Enums
-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__CONSTRUCTOR__0" c_casadi__GenericType__CONSTRUCTOR__0
  :: Ptr (Ptr StdString) -> Ptr Callback' -> IO (Ptr GenericType')
casadi__GenericType__CONSTRUCTOR__0
  :: Callback -> IO GenericType
casadi__GenericType__CONSTRUCTOR__0 x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__CONSTRUCTOR__0 errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType__0 :: Callback -> IO GenericType
genericType__0 = casadi__GenericType__CONSTRUCTOR__0


-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__CONSTRUCTOR__1" c_casadi__GenericType__CONSTRUCTOR__1
  :: Ptr (Ptr StdString) -> Ptr DerivativeGenerator' -> IO (Ptr GenericType')
casadi__GenericType__CONSTRUCTOR__1
  :: DerivativeGenerator -> IO GenericType
casadi__GenericType__CONSTRUCTOR__1 x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__CONSTRUCTOR__1 errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType__1 :: DerivativeGenerator -> IO GenericType
genericType__1 = casadi__GenericType__CONSTRUCTOR__1


-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__CONSTRUCTOR__2" c_casadi__GenericType__CONSTRUCTOR__2
  :: Ptr (Ptr StdString) -> Ptr SharedObject' -> IO (Ptr GenericType')
casadi__GenericType__CONSTRUCTOR__2
  :: SharedObject -> IO GenericType
casadi__GenericType__CONSTRUCTOR__2 x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__CONSTRUCTOR__2 errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType__2 :: SharedObject -> IO GenericType
genericType__2 = casadi__GenericType__CONSTRUCTOR__2


-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__CONSTRUCTOR__3" c_casadi__GenericType__CONSTRUCTOR__3
  :: Ptr (Ptr StdString) -> Ptr Function' -> IO (Ptr GenericType')
casadi__GenericType__CONSTRUCTOR__3
  :: Function -> IO GenericType
casadi__GenericType__CONSTRUCTOR__3 x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__CONSTRUCTOR__3 errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType__3 :: Function -> IO GenericType
genericType__3 = casadi__GenericType__CONSTRUCTOR__3


-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__CONSTRUCTOR__4" c_casadi__GenericType__CONSTRUCTOR__4
  :: Ptr (Ptr StdString) -> Ptr (StdVec (Ptr StdString)) -> IO (Ptr GenericType')
casadi__GenericType__CONSTRUCTOR__4
  :: Vector String -> IO GenericType
casadi__GenericType__CONSTRUCTOR__4 x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__CONSTRUCTOR__4 errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType__4 :: Vector String -> IO GenericType
genericType__4 = casadi__GenericType__CONSTRUCTOR__4


-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__CONSTRUCTOR__5" c_casadi__GenericType__CONSTRUCTOR__5
  :: Ptr (Ptr StdString) -> Ptr (StdVec CDouble) -> IO (Ptr GenericType')
casadi__GenericType__CONSTRUCTOR__5
  :: Vector Double -> IO GenericType
casadi__GenericType__CONSTRUCTOR__5 x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__CONSTRUCTOR__5 errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType__5 :: Vector Double -> IO GenericType
genericType__5 = casadi__GenericType__CONSTRUCTOR__5


-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__CONSTRUCTOR__6" c_casadi__GenericType__CONSTRUCTOR__6
  :: Ptr (Ptr StdString) -> Ptr (StdVec (Ptr (StdVec CInt))) -> IO (Ptr GenericType')
casadi__GenericType__CONSTRUCTOR__6
  :: Vector (Vector Int) -> IO GenericType
casadi__GenericType__CONSTRUCTOR__6 x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__CONSTRUCTOR__6 errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType__6 :: Vector (Vector Int) -> IO GenericType
genericType__6 = casadi__GenericType__CONSTRUCTOR__6


-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__CONSTRUCTOR__7" c_casadi__GenericType__CONSTRUCTOR__7
  :: Ptr (Ptr StdString) -> Ptr (StdVec CInt) -> IO (Ptr GenericType')
casadi__GenericType__CONSTRUCTOR__7
  :: Vector Int -> IO GenericType
casadi__GenericType__CONSTRUCTOR__7 x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__CONSTRUCTOR__7 errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType__7 :: Vector Int -> IO GenericType
genericType__7 = casadi__GenericType__CONSTRUCTOR__7


-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__CONSTRUCTOR__8" c_casadi__GenericType__CONSTRUCTOR__8
  :: Ptr (Ptr StdString) -> Ptr (StdVec CInt) -> IO (Ptr GenericType')
casadi__GenericType__CONSTRUCTOR__8
  :: Vector Bool -> IO GenericType
casadi__GenericType__CONSTRUCTOR__8 x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__CONSTRUCTOR__8 errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType__8 :: Vector Bool -> IO GenericType
genericType__8 = casadi__GenericType__CONSTRUCTOR__8


-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__CONSTRUCTOR__9" c_casadi__GenericType__CONSTRUCTOR__9
  :: Ptr (Ptr StdString) -> Ptr StdString -> IO (Ptr GenericType')
casadi__GenericType__CONSTRUCTOR__9
  :: String -> IO GenericType
casadi__GenericType__CONSTRUCTOR__9 x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__CONSTRUCTOR__9 errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType__9 :: String -> IO GenericType
genericType__9 = casadi__GenericType__CONSTRUCTOR__9


-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__CONSTRUCTOR__10" c_casadi__GenericType__CONSTRUCTOR__10
  :: Ptr (Ptr StdString) -> CDouble -> IO (Ptr GenericType')
casadi__GenericType__CONSTRUCTOR__10
  :: Double -> IO GenericType
casadi__GenericType__CONSTRUCTOR__10 x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__CONSTRUCTOR__10 errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType__10 :: Double -> IO GenericType
genericType__10 = casadi__GenericType__CONSTRUCTOR__10


-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__CONSTRUCTOR__11" c_casadi__GenericType__CONSTRUCTOR__11
  :: Ptr (Ptr StdString) -> CInt -> IO (Ptr GenericType')
casadi__GenericType__CONSTRUCTOR__11
  :: Int -> IO GenericType
casadi__GenericType__CONSTRUCTOR__11 x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__CONSTRUCTOR__11 errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType__11 :: Int -> IO GenericType
genericType__11 = casadi__GenericType__CONSTRUCTOR__11


-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__CONSTRUCTOR__12" c_casadi__GenericType__CONSTRUCTOR__12
  :: Ptr (Ptr StdString) -> CInt -> IO (Ptr GenericType')
casadi__GenericType__CONSTRUCTOR__12
  :: Bool -> IO GenericType
casadi__GenericType__CONSTRUCTOR__12 x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__CONSTRUCTOR__12 errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType__12 :: Bool -> IO GenericType
genericType__12 = casadi__GenericType__CONSTRUCTOR__12


-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__CONSTRUCTOR__13" c_casadi__GenericType__CONSTRUCTOR__13
  :: Ptr (Ptr StdString) -> IO (Ptr GenericType')
casadi__GenericType__CONSTRUCTOR__13
  :: IO GenericType
casadi__GenericType__CONSTRUCTOR__13  =

  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__CONSTRUCTOR__13 errStrPtrP 
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType__13 :: IO GenericType
genericType__13 = casadi__GenericType__CONSTRUCTOR__13


-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__can_cast_to__0" c_casadi__GenericType__can_cast_to__0
  :: Ptr (Ptr StdString) -> Ptr GenericType' -> Ptr GenericType' -> IO CInt
casadi__GenericType__can_cast_to__0
  :: GenericType -> GenericType -> IO Bool
casadi__GenericType__can_cast_to__0 x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__can_cast_to__0 errStrPtrP x0' x1'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType_can_cast_to__0 :: GenericTypeClass a => a -> GenericType -> IO Bool
genericType_can_cast_to__0 x = casadi__GenericType__can_cast_to__0 (castGenericType x)


-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__can_cast_to__1" c_casadi__GenericType__can_cast_to__1
  :: Ptr (Ptr StdString) -> Ptr GenericType' -> CInt -> IO CInt
casadi__GenericType__can_cast_to__1
  :: GenericType -> Opt_type -> IO Bool
casadi__GenericType__can_cast_to__1 x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__can_cast_to__1 errStrPtrP x0' x1'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType_can_cast_to__1 :: GenericTypeClass a => a -> Opt_type -> IO Bool
genericType_can_cast_to__1 x = casadi__GenericType__can_cast_to__1 (castGenericType x)


-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__from_type" c_casadi__GenericType__from_type
  :: Ptr (Ptr StdString) -> CInt -> IO (Ptr GenericType')
casadi__GenericType__from_type
  :: Opt_type -> IO GenericType
casadi__GenericType__from_type x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__from_type errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType_from_type :: Opt_type -> IO GenericType
genericType_from_type = casadi__GenericType__from_type


-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__getType" c_casadi__GenericType__getType
  :: Ptr (Ptr StdString) -> Ptr GenericType' -> IO CInt
casadi__GenericType__getType
  :: GenericType -> IO Opt_type
casadi__GenericType__getType x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__getType errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType_getType :: GenericTypeClass a => a -> IO Opt_type
genericType_getType x = casadi__GenericType__getType (castGenericType x)


-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__get_description" c_casadi__GenericType__get_description
  :: Ptr (Ptr StdString) -> Ptr GenericType' -> IO (Ptr StdString)
casadi__GenericType__get_description
  :: GenericType -> IO String
casadi__GenericType__get_description x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__get_description errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType_get_description :: GenericTypeClass a => a -> IO String
genericType_get_description x = casadi__GenericType__get_description (castGenericType x)


-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__get_type_description" c_casadi__GenericType__get_type_description
  :: Ptr (Ptr StdString) -> CInt -> IO (Ptr StdString)
casadi__GenericType__get_type_description
  :: Opt_type -> IO String
casadi__GenericType__get_type_description x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__get_type_description errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType_get_type_description :: Opt_type -> IO String
genericType_get_type_description = casadi__GenericType__get_type_description


-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__isBool" c_casadi__GenericType__isBool
  :: Ptr (Ptr StdString) -> Ptr GenericType' -> IO CInt
casadi__GenericType__isBool
  :: GenericType -> IO Bool
casadi__GenericType__isBool x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__isBool errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType_isBool :: GenericTypeClass a => a -> IO Bool
genericType_isBool x = casadi__GenericType__isBool (castGenericType x)


-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__isDictionary" c_casadi__GenericType__isDictionary
  :: Ptr (Ptr StdString) -> Ptr GenericType' -> IO CInt
casadi__GenericType__isDictionary
  :: GenericType -> IO Bool
casadi__GenericType__isDictionary x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__isDictionary errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType_isDictionary :: GenericTypeClass a => a -> IO Bool
genericType_isDictionary x = casadi__GenericType__isDictionary (castGenericType x)


-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__isDouble" c_casadi__GenericType__isDouble
  :: Ptr (Ptr StdString) -> Ptr GenericType' -> IO CInt
casadi__GenericType__isDouble
  :: GenericType -> IO Bool
casadi__GenericType__isDouble x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__isDouble errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType_isDouble :: GenericTypeClass a => a -> IO Bool
genericType_isDouble x = casadi__GenericType__isDouble (castGenericType x)


-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__isDoubleVector" c_casadi__GenericType__isDoubleVector
  :: Ptr (Ptr StdString) -> Ptr GenericType' -> IO CInt
casadi__GenericType__isDoubleVector
  :: GenericType -> IO Bool
casadi__GenericType__isDoubleVector x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__isDoubleVector errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType_isDoubleVector :: GenericTypeClass a => a -> IO Bool
genericType_isDoubleVector x = casadi__GenericType__isDoubleVector (castGenericType x)


-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__isEmptyVector" c_casadi__GenericType__isEmptyVector
  :: Ptr (Ptr StdString) -> Ptr GenericType' -> IO CInt
casadi__GenericType__isEmptyVector
  :: GenericType -> IO Bool
casadi__GenericType__isEmptyVector x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__isEmptyVector errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType_isEmptyVector :: GenericTypeClass a => a -> IO Bool
genericType_isEmptyVector x = casadi__GenericType__isEmptyVector (castGenericType x)


-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__isFunction" c_casadi__GenericType__isFunction
  :: Ptr (Ptr StdString) -> Ptr GenericType' -> IO CInt
casadi__GenericType__isFunction
  :: GenericType -> IO Bool
casadi__GenericType__isFunction x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__isFunction errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType_isFunction :: GenericTypeClass a => a -> IO Bool
genericType_isFunction x = casadi__GenericType__isFunction (castGenericType x)


-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__isInt" c_casadi__GenericType__isInt
  :: Ptr (Ptr StdString) -> Ptr GenericType' -> IO CInt
casadi__GenericType__isInt
  :: GenericType -> IO Bool
casadi__GenericType__isInt x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__isInt errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType_isInt :: GenericTypeClass a => a -> IO Bool
genericType_isInt x = casadi__GenericType__isInt (castGenericType x)


-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__isIntVector" c_casadi__GenericType__isIntVector
  :: Ptr (Ptr StdString) -> Ptr GenericType' -> IO CInt
casadi__GenericType__isIntVector
  :: GenericType -> IO Bool
casadi__GenericType__isIntVector x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__isIntVector errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType_isIntVector :: GenericTypeClass a => a -> IO Bool
genericType_isIntVector x = casadi__GenericType__isIntVector (castGenericType x)


-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__isIntVectorVector" c_casadi__GenericType__isIntVectorVector
  :: Ptr (Ptr StdString) -> Ptr GenericType' -> IO CInt
casadi__GenericType__isIntVectorVector
  :: GenericType -> IO Bool
casadi__GenericType__isIntVectorVector x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__isIntVectorVector errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType_isIntVectorVector :: GenericTypeClass a => a -> IO Bool
genericType_isIntVectorVector x = casadi__GenericType__isIntVectorVector (castGenericType x)


-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__isSharedObject" c_casadi__GenericType__isSharedObject
  :: Ptr (Ptr StdString) -> Ptr GenericType' -> IO CInt
casadi__GenericType__isSharedObject
  :: GenericType -> IO Bool
casadi__GenericType__isSharedObject x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__isSharedObject errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType_isSharedObject :: GenericTypeClass a => a -> IO Bool
genericType_isSharedObject x = casadi__GenericType__isSharedObject (castGenericType x)


-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__isString" c_casadi__GenericType__isString
  :: Ptr (Ptr StdString) -> Ptr GenericType' -> IO CInt
casadi__GenericType__isString
  :: GenericType -> IO Bool
casadi__GenericType__isString x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__isString errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType_isString :: GenericTypeClass a => a -> IO Bool
genericType_isString x = casadi__GenericType__isString (castGenericType x)


-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__isStringVector" c_casadi__GenericType__isStringVector
  :: Ptr (Ptr StdString) -> Ptr GenericType' -> IO CInt
casadi__GenericType__isStringVector
  :: GenericType -> IO Bool
casadi__GenericType__isStringVector x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__isStringVector errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType_isStringVector :: GenericTypeClass a => a -> IO Bool
genericType_isStringVector x = casadi__GenericType__isStringVector (castGenericType x)


-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__toBool" c_casadi__GenericType__toBool
  :: Ptr (Ptr StdString) -> Ptr GenericType' -> IO CInt
casadi__GenericType__toBool
  :: GenericType -> IO Bool
casadi__GenericType__toBool x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__toBool errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType_toBool :: GenericTypeClass a => a -> IO Bool
genericType_toBool x = casadi__GenericType__toBool (castGenericType x)


-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__toDouble" c_casadi__GenericType__toDouble
  :: Ptr (Ptr StdString) -> Ptr GenericType' -> IO CDouble
casadi__GenericType__toDouble
  :: GenericType -> IO Double
casadi__GenericType__toDouble x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__toDouble errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType_toDouble :: GenericTypeClass a => a -> IO Double
genericType_toDouble x = casadi__GenericType__toDouble (castGenericType x)


-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__toDoubleVector" c_casadi__GenericType__toDoubleVector
  :: Ptr (Ptr StdString) -> Ptr GenericType' -> IO (Ptr (StdVec CDouble))
casadi__GenericType__toDoubleVector
  :: GenericType -> IO (Vector Double)
casadi__GenericType__toDoubleVector x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__toDoubleVector errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType_toDoubleVector :: GenericTypeClass a => a -> IO (Vector Double)
genericType_toDoubleVector x = casadi__GenericType__toDoubleVector (castGenericType x)


-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__toFunction" c_casadi__GenericType__toFunction
  :: Ptr (Ptr StdString) -> Ptr GenericType' -> IO (Ptr Function')
casadi__GenericType__toFunction
  :: GenericType -> IO Function
casadi__GenericType__toFunction x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__toFunction errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType_toFunction :: GenericTypeClass a => a -> IO Function
genericType_toFunction x = casadi__GenericType__toFunction (castGenericType x)


-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__toInt" c_casadi__GenericType__toInt
  :: Ptr (Ptr StdString) -> Ptr GenericType' -> IO CInt
casadi__GenericType__toInt
  :: GenericType -> IO Int
casadi__GenericType__toInt x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__toInt errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType_toInt :: GenericTypeClass a => a -> IO Int
genericType_toInt x = casadi__GenericType__toInt (castGenericType x)


-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__toIntVector" c_casadi__GenericType__toIntVector
  :: Ptr (Ptr StdString) -> Ptr GenericType' -> IO (Ptr (StdVec CInt))
casadi__GenericType__toIntVector
  :: GenericType -> IO (Vector Int)
casadi__GenericType__toIntVector x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__toIntVector errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType_toIntVector :: GenericTypeClass a => a -> IO (Vector Int)
genericType_toIntVector x = casadi__GenericType__toIntVector (castGenericType x)


-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__toIntVectorVector" c_casadi__GenericType__toIntVectorVector
  :: Ptr (Ptr StdString) -> Ptr GenericType' -> IO (Ptr (StdVec (Ptr (StdVec CInt))))
casadi__GenericType__toIntVectorVector
  :: GenericType -> IO (Vector (Vector Int))
casadi__GenericType__toIntVectorVector x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__toIntVectorVector errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType_toIntVectorVector :: GenericTypeClass a => a -> IO (Vector (Vector Int))
genericType_toIntVectorVector x = casadi__GenericType__toIntVectorVector (castGenericType x)


-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__toSharedObject" c_casadi__GenericType__toSharedObject
  :: Ptr (Ptr StdString) -> Ptr GenericType' -> IO (Ptr SharedObject')
casadi__GenericType__toSharedObject
  :: GenericType -> IO SharedObject
casadi__GenericType__toSharedObject x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__toSharedObject errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType_toSharedObject :: GenericTypeClass a => a -> IO SharedObject
genericType_toSharedObject x = casadi__GenericType__toSharedObject (castGenericType x)


-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__toString" c_casadi__GenericType__toString
  :: Ptr (Ptr StdString) -> Ptr GenericType' -> IO (Ptr StdString)
casadi__GenericType__toString
  :: GenericType -> IO String
casadi__GenericType__toString x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__toString errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType_toString :: GenericTypeClass a => a -> IO String
genericType_toString x = casadi__GenericType__toString (castGenericType x)


-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__toStringVector" c_casadi__GenericType__toStringVector
  :: Ptr (Ptr StdString) -> Ptr GenericType' -> IO (Ptr (StdVec (Ptr StdString)))
casadi__GenericType__toStringVector
  :: GenericType -> IO (Vector String)
casadi__GenericType__toStringVector x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__toStringVector errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType_toStringVector :: GenericTypeClass a => a -> IO (Vector String)
genericType_toStringVector x = casadi__GenericType__toStringVector (castGenericType x)


-- direct wrapper
foreign import ccall unsafe "casadi__GenericType__toVoidPointer" c_casadi__GenericType__toVoidPointer
  :: Ptr (Ptr StdString) -> Ptr GenericType' -> IO ()
casadi__GenericType__toVoidPointer
  :: GenericType -> IO ()
casadi__GenericType__toVoidPointer x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__GenericType__toVoidPointer errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
genericType_toVoidPointer :: GenericTypeClass a => a -> IO ()
genericType_toVoidPointer x = casadi__GenericType__toVoidPointer (castGenericType x)

