{-# OPTIONS_GHC -Wall #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}
{-# OPTIONS_GHC -fno-warn-orphans #-}
{-# Language ForeignFunctionInterface #-}
{-# Language FlexibleInstances #-}
{-# Language MultiParamTypeClasses #-}

module Casadi.Core.Classes.HomotopyNlpSolver
       (
         HomotopyNlpSolver,
         HomotopyNlpSolverClass(..),
         homotopyNlpSolver,
         homotopyNlpSolver_doc,
         homotopyNlpSolver_hasPlugin,
         homotopyNlpSolver_loadPlugin,
       ) where


import Prelude hiding ( Functor )

import Data.Vector ( Vector )
import Foreign.C.Types
import Foreign.Marshal ( new, free )
import Foreign.Storable ( peek )
import Foreign.Ptr ( Ptr, nullPtr )
import Foreign.ForeignPtr ( newForeignPtr )
import System.IO.Unsafe ( unsafePerformIO ) -- for show instances

import Casadi.Internal.CToolsInstances ( )
import Casadi.Internal.FormatException ( formatException )
import Casadi.Internal.MarshalTypes ( StdVec, StdString) -- StdPair StdOstream'
import Casadi.Internal.Marshal ( Marshal(..), withMarshal )
import Casadi.Internal.WrapReturn ( WrapReturn(..) )
import Casadi.Core.Data
import Casadi.Core.Enums
-- direct wrapper
foreign import ccall unsafe "casadi__HomotopyNlpSolver__CONSTRUCTOR" c_casadi__HomotopyNlpSolver__CONSTRUCTOR
  :: Ptr (Ptr StdString) -> IO (Ptr HomotopyNlpSolver')
casadi__HomotopyNlpSolver__CONSTRUCTOR
  :: IO HomotopyNlpSolver
casadi__HomotopyNlpSolver__CONSTRUCTOR  =

  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__HomotopyNlpSolver__CONSTRUCTOR errStrPtrP 
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
homotopyNlpSolver :: IO HomotopyNlpSolver
homotopyNlpSolver = casadi__HomotopyNlpSolver__CONSTRUCTOR


-- direct wrapper
foreign import ccall unsafe "casadi__HomotopyNlpSolver__doc" c_casadi__HomotopyNlpSolver__doc
  :: Ptr (Ptr StdString) -> Ptr StdString -> IO (Ptr StdString)
casadi__HomotopyNlpSolver__doc
  :: String -> IO String
casadi__HomotopyNlpSolver__doc x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__HomotopyNlpSolver__doc errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
homotopyNlpSolver_doc :: String -> IO String
homotopyNlpSolver_doc = casadi__HomotopyNlpSolver__doc


-- direct wrapper
foreign import ccall unsafe "casadi__HomotopyNlpSolver__hasPlugin" c_casadi__HomotopyNlpSolver__hasPlugin
  :: Ptr (Ptr StdString) -> Ptr StdString -> IO CInt
casadi__HomotopyNlpSolver__hasPlugin
  :: String -> IO Bool
casadi__HomotopyNlpSolver__hasPlugin x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__HomotopyNlpSolver__hasPlugin errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
homotopyNlpSolver_hasPlugin :: String -> IO Bool
homotopyNlpSolver_hasPlugin = casadi__HomotopyNlpSolver__hasPlugin


-- direct wrapper
foreign import ccall unsafe "casadi__HomotopyNlpSolver__loadPlugin" c_casadi__HomotopyNlpSolver__loadPlugin
  :: Ptr (Ptr StdString) -> Ptr StdString -> IO ()
casadi__HomotopyNlpSolver__loadPlugin
  :: String -> IO ()
casadi__HomotopyNlpSolver__loadPlugin x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__HomotopyNlpSolver__loadPlugin errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
homotopyNlpSolver_loadPlugin :: String -> IO ()
homotopyNlpSolver_loadPlugin = casadi__HomotopyNlpSolver__loadPlugin

