{-# OPTIONS_GHC -Wall #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}
{-# OPTIONS_GHC -fno-warn-orphans #-}
{-# Language ForeignFunctionInterface #-}
{-# Language FlexibleInstances #-}
{-# Language MultiParamTypeClasses #-}

module Casadi.Core.Classes.OptionsFunctionality
       (
         OptionsFunctionality,
         OptionsFunctionalityClass(..),
         optionsFunctionality,
         optionsFunctionality_copyOptions__0,
         optionsFunctionality_copyOptions__1,
         optionsFunctionality_getOption,
         optionsFunctionality_getOptionAllowed,
         optionsFunctionality_getOptionAllowedIndex,
         optionsFunctionality_getOptionDefault,
         optionsFunctionality_getOptionDescription,
         optionsFunctionality_getOptionEnumValue,
         optionsFunctionality_getOptionNames,
         optionsFunctionality_getOptionType,
         optionsFunctionality_getOptionTypeName,
         optionsFunctionality_hasOption,
         optionsFunctionality_hasSetOption,
         optionsFunctionality_printOptions,
         optionsFunctionality_setOption,
         optionsFunctionality_setOptionByAllowedIndex,
         optionsFunctionality_setOptionByEnumValue,
       ) where


import Prelude hiding ( Functor )

import Data.Vector ( Vector )
import Foreign.C.Types
import Foreign.Marshal ( new, free )
import Foreign.Storable ( peek )
import Foreign.Ptr ( Ptr, nullPtr )
import Foreign.ForeignPtr ( newForeignPtr )
import System.IO.Unsafe ( unsafePerformIO ) -- for show instances

import Casadi.Internal.CToolsInstances ( )
import Casadi.Internal.FormatException ( formatException )
import Casadi.Internal.MarshalTypes ( StdVec, StdString) -- StdPair StdOstream'
import Casadi.Internal.Marshal ( Marshal(..), withMarshal )
import Casadi.Internal.WrapReturn ( WrapReturn(..) )
import Casadi.Core.Data
import Casadi.Core.Enums
-- direct wrapper
foreign import ccall unsafe "casadi__OptionsFunctionality__CONSTRUCTOR" c_casadi__OptionsFunctionality__CONSTRUCTOR
  :: Ptr (Ptr StdString) -> IO (Ptr OptionsFunctionality')
casadi__OptionsFunctionality__CONSTRUCTOR
  :: IO OptionsFunctionality
casadi__OptionsFunctionality__CONSTRUCTOR  =

  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__OptionsFunctionality__CONSTRUCTOR errStrPtrP 
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
optionsFunctionality :: IO OptionsFunctionality
optionsFunctionality = casadi__OptionsFunctionality__CONSTRUCTOR


-- direct wrapper
foreign import ccall unsafe "casadi__OptionsFunctionality__copyOptions__0" c_casadi__OptionsFunctionality__copyOptions__0
  :: Ptr (Ptr StdString) -> Ptr OptionsFunctionality' -> Ptr OptionsFunctionality' -> IO ()
casadi__OptionsFunctionality__copyOptions__0
  :: OptionsFunctionality -> OptionsFunctionality -> IO ()
casadi__OptionsFunctionality__copyOptions__0 x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__OptionsFunctionality__copyOptions__0 errStrPtrP x0' x1'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
optionsFunctionality_copyOptions__0 :: OptionsFunctionalityClass a => a -> OptionsFunctionality -> IO ()
optionsFunctionality_copyOptions__0 x = casadi__OptionsFunctionality__copyOptions__0 (castOptionsFunctionality x)


-- direct wrapper
foreign import ccall unsafe "casadi__OptionsFunctionality__copyOptions__1" c_casadi__OptionsFunctionality__copyOptions__1
  :: Ptr (Ptr StdString) -> Ptr OptionsFunctionality' -> Ptr OptionsFunctionality' -> CInt -> IO ()
casadi__OptionsFunctionality__copyOptions__1
  :: OptionsFunctionality -> OptionsFunctionality -> Bool -> IO ()
casadi__OptionsFunctionality__copyOptions__1 x0 x1 x2 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__OptionsFunctionality__copyOptions__1 errStrPtrP x0' x1' x2'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
optionsFunctionality_copyOptions__1 :: OptionsFunctionalityClass a => a -> OptionsFunctionality -> Bool -> IO ()
optionsFunctionality_copyOptions__1 x = casadi__OptionsFunctionality__copyOptions__1 (castOptionsFunctionality x)


-- direct wrapper
foreign import ccall unsafe "casadi__OptionsFunctionality__getOption" c_casadi__OptionsFunctionality__getOption
  :: Ptr (Ptr StdString) -> Ptr OptionsFunctionality' -> Ptr StdString -> IO (Ptr GenericType')
casadi__OptionsFunctionality__getOption
  :: OptionsFunctionality -> String -> IO GenericType
casadi__OptionsFunctionality__getOption x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__OptionsFunctionality__getOption errStrPtrP x0' x1'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
optionsFunctionality_getOption :: OptionsFunctionalityClass a => a -> String -> IO GenericType
optionsFunctionality_getOption x = casadi__OptionsFunctionality__getOption (castOptionsFunctionality x)


-- direct wrapper
foreign import ccall unsafe "casadi__OptionsFunctionality__getOptionAllowed" c_casadi__OptionsFunctionality__getOptionAllowed
  :: Ptr (Ptr StdString) -> Ptr OptionsFunctionality' -> Ptr StdString -> IO (Ptr (StdVec (Ptr GenericType')))
casadi__OptionsFunctionality__getOptionAllowed
  :: OptionsFunctionality -> String -> IO (Vector GenericType)
casadi__OptionsFunctionality__getOptionAllowed x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__OptionsFunctionality__getOptionAllowed errStrPtrP x0' x1'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
optionsFunctionality_getOptionAllowed :: OptionsFunctionalityClass a => a -> String -> IO (Vector GenericType)
optionsFunctionality_getOptionAllowed x = casadi__OptionsFunctionality__getOptionAllowed (castOptionsFunctionality x)


-- direct wrapper
foreign import ccall unsafe "casadi__OptionsFunctionality__getOptionAllowedIndex" c_casadi__OptionsFunctionality__getOptionAllowedIndex
  :: Ptr (Ptr StdString) -> Ptr OptionsFunctionality' -> Ptr StdString -> IO CInt
casadi__OptionsFunctionality__getOptionAllowedIndex
  :: OptionsFunctionality -> String -> IO Int
casadi__OptionsFunctionality__getOptionAllowedIndex x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__OptionsFunctionality__getOptionAllowedIndex errStrPtrP x0' x1'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
optionsFunctionality_getOptionAllowedIndex :: OptionsFunctionalityClass a => a -> String -> IO Int
optionsFunctionality_getOptionAllowedIndex x = casadi__OptionsFunctionality__getOptionAllowedIndex (castOptionsFunctionality x)


-- direct wrapper
foreign import ccall unsafe "casadi__OptionsFunctionality__getOptionDefault" c_casadi__OptionsFunctionality__getOptionDefault
  :: Ptr (Ptr StdString) -> Ptr OptionsFunctionality' -> Ptr StdString -> IO (Ptr GenericType')
casadi__OptionsFunctionality__getOptionDefault
  :: OptionsFunctionality -> String -> IO GenericType
casadi__OptionsFunctionality__getOptionDefault x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__OptionsFunctionality__getOptionDefault errStrPtrP x0' x1'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
optionsFunctionality_getOptionDefault :: OptionsFunctionalityClass a => a -> String -> IO GenericType
optionsFunctionality_getOptionDefault x = casadi__OptionsFunctionality__getOptionDefault (castOptionsFunctionality x)


-- direct wrapper
foreign import ccall unsafe "casadi__OptionsFunctionality__getOptionDescription" c_casadi__OptionsFunctionality__getOptionDescription
  :: Ptr (Ptr StdString) -> Ptr OptionsFunctionality' -> Ptr StdString -> IO (Ptr StdString)
casadi__OptionsFunctionality__getOptionDescription
  :: OptionsFunctionality -> String -> IO String
casadi__OptionsFunctionality__getOptionDescription x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__OptionsFunctionality__getOptionDescription errStrPtrP x0' x1'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
optionsFunctionality_getOptionDescription :: OptionsFunctionalityClass a => a -> String -> IO String
optionsFunctionality_getOptionDescription x = casadi__OptionsFunctionality__getOptionDescription (castOptionsFunctionality x)


-- direct wrapper
foreign import ccall unsafe "casadi__OptionsFunctionality__getOptionEnumValue" c_casadi__OptionsFunctionality__getOptionEnumValue
  :: Ptr (Ptr StdString) -> Ptr OptionsFunctionality' -> Ptr StdString -> IO CInt
casadi__OptionsFunctionality__getOptionEnumValue
  :: OptionsFunctionality -> String -> IO Int
casadi__OptionsFunctionality__getOptionEnumValue x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__OptionsFunctionality__getOptionEnumValue errStrPtrP x0' x1'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
optionsFunctionality_getOptionEnumValue :: OptionsFunctionalityClass a => a -> String -> IO Int
optionsFunctionality_getOptionEnumValue x = casadi__OptionsFunctionality__getOptionEnumValue (castOptionsFunctionality x)


-- direct wrapper
foreign import ccall unsafe "casadi__OptionsFunctionality__getOptionNames" c_casadi__OptionsFunctionality__getOptionNames
  :: Ptr (Ptr StdString) -> Ptr OptionsFunctionality' -> IO (Ptr (StdVec (Ptr StdString)))
casadi__OptionsFunctionality__getOptionNames
  :: OptionsFunctionality -> IO (Vector String)
casadi__OptionsFunctionality__getOptionNames x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__OptionsFunctionality__getOptionNames errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
optionsFunctionality_getOptionNames :: OptionsFunctionalityClass a => a -> IO (Vector String)
optionsFunctionality_getOptionNames x = casadi__OptionsFunctionality__getOptionNames (castOptionsFunctionality x)


-- direct wrapper
foreign import ccall unsafe "casadi__OptionsFunctionality__getOptionType" c_casadi__OptionsFunctionality__getOptionType
  :: Ptr (Ptr StdString) -> Ptr OptionsFunctionality' -> Ptr StdString -> IO CInt
casadi__OptionsFunctionality__getOptionType
  :: OptionsFunctionality -> String -> IO Opt_type
casadi__OptionsFunctionality__getOptionType x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__OptionsFunctionality__getOptionType errStrPtrP x0' x1'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
optionsFunctionality_getOptionType :: OptionsFunctionalityClass a => a -> String -> IO Opt_type
optionsFunctionality_getOptionType x = casadi__OptionsFunctionality__getOptionType (castOptionsFunctionality x)


-- direct wrapper
foreign import ccall unsafe "casadi__OptionsFunctionality__getOptionTypeName" c_casadi__OptionsFunctionality__getOptionTypeName
  :: Ptr (Ptr StdString) -> Ptr OptionsFunctionality' -> Ptr StdString -> IO (Ptr StdString)
casadi__OptionsFunctionality__getOptionTypeName
  :: OptionsFunctionality -> String -> IO String
casadi__OptionsFunctionality__getOptionTypeName x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__OptionsFunctionality__getOptionTypeName errStrPtrP x0' x1'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
optionsFunctionality_getOptionTypeName :: OptionsFunctionalityClass a => a -> String -> IO String
optionsFunctionality_getOptionTypeName x = casadi__OptionsFunctionality__getOptionTypeName (castOptionsFunctionality x)


-- direct wrapper
foreign import ccall unsafe "casadi__OptionsFunctionality__hasOption" c_casadi__OptionsFunctionality__hasOption
  :: Ptr (Ptr StdString) -> Ptr OptionsFunctionality' -> Ptr StdString -> IO CInt
casadi__OptionsFunctionality__hasOption
  :: OptionsFunctionality -> String -> IO Bool
casadi__OptionsFunctionality__hasOption x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__OptionsFunctionality__hasOption errStrPtrP x0' x1'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
optionsFunctionality_hasOption :: OptionsFunctionalityClass a => a -> String -> IO Bool
optionsFunctionality_hasOption x = casadi__OptionsFunctionality__hasOption (castOptionsFunctionality x)


-- direct wrapper
foreign import ccall unsafe "casadi__OptionsFunctionality__hasSetOption" c_casadi__OptionsFunctionality__hasSetOption
  :: Ptr (Ptr StdString) -> Ptr OptionsFunctionality' -> Ptr StdString -> IO CInt
casadi__OptionsFunctionality__hasSetOption
  :: OptionsFunctionality -> String -> IO Bool
casadi__OptionsFunctionality__hasSetOption x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__OptionsFunctionality__hasSetOption errStrPtrP x0' x1'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
optionsFunctionality_hasSetOption :: OptionsFunctionalityClass a => a -> String -> IO Bool
optionsFunctionality_hasSetOption x = casadi__OptionsFunctionality__hasSetOption (castOptionsFunctionality x)


-- direct wrapper
foreign import ccall unsafe "casadi__OptionsFunctionality__printOptions" c_casadi__OptionsFunctionality__printOptions
  :: Ptr (Ptr StdString) -> Ptr OptionsFunctionality' -> IO ()
casadi__OptionsFunctionality__printOptions
  :: OptionsFunctionality -> IO ()
casadi__OptionsFunctionality__printOptions x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__OptionsFunctionality__printOptions errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
optionsFunctionality_printOptions :: OptionsFunctionalityClass a => a -> IO ()
optionsFunctionality_printOptions x = casadi__OptionsFunctionality__printOptions (castOptionsFunctionality x)


-- direct wrapper
foreign import ccall unsafe "casadi__OptionsFunctionality__setOption" c_casadi__OptionsFunctionality__setOption
  :: Ptr (Ptr StdString) -> Ptr OptionsFunctionality' -> Ptr StdString -> Ptr GenericType' -> IO ()
casadi__OptionsFunctionality__setOption
  :: OptionsFunctionality -> String -> GenericType -> IO ()
casadi__OptionsFunctionality__setOption x0 x1 x2 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__OptionsFunctionality__setOption errStrPtrP x0' x1' x2'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
optionsFunctionality_setOption :: OptionsFunctionalityClass a => a -> String -> GenericType -> IO ()
optionsFunctionality_setOption x = casadi__OptionsFunctionality__setOption (castOptionsFunctionality x)


-- direct wrapper
foreign import ccall unsafe "casadi__OptionsFunctionality__setOptionByAllowedIndex" c_casadi__OptionsFunctionality__setOptionByAllowedIndex
  :: Ptr (Ptr StdString) -> Ptr OptionsFunctionality' -> Ptr StdString -> CInt -> IO ()
casadi__OptionsFunctionality__setOptionByAllowedIndex
  :: OptionsFunctionality -> String -> Int -> IO ()
casadi__OptionsFunctionality__setOptionByAllowedIndex x0 x1 x2 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__OptionsFunctionality__setOptionByAllowedIndex errStrPtrP x0' x1' x2'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
optionsFunctionality_setOptionByAllowedIndex :: OptionsFunctionalityClass a => a -> String -> Int -> IO ()
optionsFunctionality_setOptionByAllowedIndex x = casadi__OptionsFunctionality__setOptionByAllowedIndex (castOptionsFunctionality x)


-- direct wrapper
foreign import ccall unsafe "casadi__OptionsFunctionality__setOptionByEnumValue" c_casadi__OptionsFunctionality__setOptionByEnumValue
  :: Ptr (Ptr StdString) -> Ptr OptionsFunctionality' -> Ptr StdString -> CInt -> IO ()
casadi__OptionsFunctionality__setOptionByEnumValue
  :: OptionsFunctionality -> String -> Int -> IO ()
casadi__OptionsFunctionality__setOptionByEnumValue x0 x1 x2 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__OptionsFunctionality__setOptionByEnumValue errStrPtrP x0' x1' x2'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
optionsFunctionality_setOptionByEnumValue :: OptionsFunctionalityClass a => a -> String -> Int -> IO ()
optionsFunctionality_setOptionByEnumValue x = casadi__OptionsFunctionality__setOptionByEnumValue (castOptionsFunctionality x)

