#include <casadi/casadi.hpp>
#include <cmath>
#include <stdexcept>
#include "../marshal.hpp"

// ================== function "casadi::cleIn" ===============
// cppName: "casadi::cleIn"
// cWrapperName: "cleIn__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* cleIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::cleIn(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* cleIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* cleIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::cleIn(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::cleIn" ===============
// cppName: "casadi::cleIn"
// cWrapperName: "cleIn__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* cleIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::cleIn(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* cleIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* cleIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::cleIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::cleIn" ===============
// cppName: "casadi::cleIn"
// cWrapperName: "cleIn__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* cleIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::cleIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* cleIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* cleIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::cleIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::cleIn" ===============
// cppName: "casadi::cleIn"
// cWrapperName: "cleIn__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* cleIn__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::cleIn(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* cleIn__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* cleIn__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::cleIn(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::cleIn" ===============
// cppName: "casadi::cleIn"
// cWrapperName: "cleIn__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* cleIn__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::cleIn(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* cleIn__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* cleIn__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::cleIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::cleIn" ===============
// cppName: "casadi::cleIn"
// cWrapperName: "cleIn__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* cleIn__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::cleIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::DMatrix* >* cleIn__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::DMatrix* >* cleIn__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::DMatrix > ret = casadi::cleIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::cleIn" ===============
// cppName: "casadi::cleIn"
// cWrapperName: "cleIn__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* cleIn__6(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::cleIn(x0_)"
extern "C"
std::vector< casadi::MX* >* cleIn__6(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* cleIn__6(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::cleIn(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::cleIn" ===============
// cppName: "casadi::cleIn"
// cWrapperName: "cleIn__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* cleIn__7(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::cleIn(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* cleIn__7(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* cleIn__7(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::cleIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::cleIn" ===============
// cppName: "casadi::cleIn"
// cWrapperName: "cleIn__8"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* cleIn__8(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::cleIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >* cleIn__8(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::MX* >* cleIn__8(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::MX > ret = casadi::cleIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::cleIn" ===============
// cppName: "casadi::cleIn"
// cWrapperName: "cleIn__9"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* cleIn__9(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::cleIn(x0_)"
extern "C"
std::vector< casadi::SX* >* cleIn__9(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* cleIn__9(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::cleIn(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::cleIn" ===============
// cppName: "casadi::cleIn"
// cWrapperName: "cleIn__10"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* cleIn__10(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::cleIn(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* cleIn__10(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* cleIn__10(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::cleIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::cleIn" ===============
// cppName: "casadi::cleIn"
// cWrapperName: "cleIn__11"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* cleIn__11(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::cleIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::SX* >* cleIn__11(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::SX* >* cleIn__11(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::SX > ret = casadi::cleIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::cleOut" ===============
// cppName: "casadi::cleOut"
// cWrapperName: "cleOut__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* cleOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::cleOut(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* cleOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* cleOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::cleOut(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::cleOut" ===============
// cppName: "casadi::cleOut"
// cWrapperName: "cleOut__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* cleOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::cleOut(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* cleOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* cleOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::cleOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::cleOut" ===============
// cppName: "casadi::cleOut"
// cWrapperName: "cleOut__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* cleOut__2(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::cleOut(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* cleOut__2(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* cleOut__2(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::cleOut(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::cleOut" ===============
// cppName: "casadi::cleOut"
// cWrapperName: "cleOut__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* cleOut__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::cleOut(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* cleOut__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* cleOut__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::cleOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::cleOut" ===============
// cppName: "casadi::cleOut"
// cWrapperName: "cleOut__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* cleOut__4(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::cleOut(x0_)"
extern "C"
std::vector< casadi::MX* >* cleOut__4(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* cleOut__4(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::cleOut(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::cleOut" ===============
// cppName: "casadi::cleOut"
// cWrapperName: "cleOut__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* cleOut__5(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::cleOut(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* cleOut__5(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* cleOut__5(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::cleOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::cleOut" ===============
// cppName: "casadi::cleOut"
// cWrapperName: "cleOut__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* cleOut__6(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::cleOut(x0_)"
extern "C"
std::vector< casadi::SX* >* cleOut__6(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* cleOut__6(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::cleOut(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::cleOut" ===============
// cppName: "casadi::cleOut"
// cWrapperName: "cleOut__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* cleOut__7(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::cleOut(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* cleOut__7(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* cleOut__7(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::cleOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::cleStruct" ===============
// cppName: "casadi::cleStruct"
// cWrapperName: "cleStruct__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* cleStruct__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::cleStruct(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* cleStruct__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* cleStruct__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::cleStruct(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::cleStruct" ===============
// cppName: "casadi::cleStruct"
// cWrapperName: "cleStruct__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* cleStruct__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::cleStruct(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* cleStruct__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* cleStruct__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::cleStruct(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::cleStruct" ===============
// cppName: "casadi::cleStruct"
// cWrapperName: "cleStruct__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* cleStruct__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::cleStruct(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* cleStruct__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* cleStruct__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::cleStruct(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::cleStruct" ===============
// cppName: "casadi::cleStruct"
// cWrapperName: "cleStruct__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* cleStruct__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::cleStruct(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::Sparsity* >* cleStruct__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::Sparsity* >* cleStruct__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::Sparsity > ret = casadi::cleStruct(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::collocationPoints" ===============
// cppName: "casadi::collocationPoints"
// cWrapperName: "collocationPoints__0"
// protoArgs: "(std::string ** err_msg, int x0)"
// params: [CInt]
// retType: StdVec CDouble
// args: "(x0_)"
// cWrapperRetType: "std::vector< double >*"
// proto: "std::vector< double >* collocationPoints__0(std::string ** err_msg, int x0)"
// call: "casadi::collocationPoints(x0_)"
extern "C"
std::vector< double >* collocationPoints__0(std::string ** err_msg, int x0);
std::vector< double >* collocationPoints__0(std::string ** err_msg, int x0){
    try {
        int x0_ = Marshaling<int,int>::marshal(x0);

        std::vector< double > ret = casadi::collocationPoints(x0_);
        return WrapReturn< std::vector< double >*, std::vector< double > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::collocationPoints" ===============
// cppName: "casadi::collocationPoints"
// cWrapperName: "collocationPoints__1"
// protoArgs: "(std::string ** err_msg, int x0, std::string* x1)"
// params: [CInt,Ref (Const StdString)]
// retType: StdVec CDouble
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< double >*"
// proto: "std::vector< double >* collocationPoints__1(std::string ** err_msg, int x0, std::string* x1)"
// call: "casadi::collocationPoints(x0_, x1_)"
extern "C"
std::vector< double >* collocationPoints__1(std::string ** err_msg, int x0, std::string* x1);
std::vector< double >* collocationPoints__1(std::string ** err_msg, int x0, std::string* x1){
    try {
        int x0_ = Marshaling<int,int>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< double > ret = casadi::collocationPoints(x0_, x1_);
        return WrapReturn< std::vector< double >*, std::vector< double > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::complement" ===============
// cppName: "casadi::complement"
// cWrapperName: "complement"
// protoArgs: "(std::string ** err_msg, std::vector< int >* x0, int x1)"
// params: [Ref (Const (StdVec CInt)),CInt]
// retType: StdVec CInt
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< int >*"
// proto: "std::vector< int >* complement(std::string ** err_msg, std::vector< int >* x0, int x1)"
// call: "casadi::complement(x0_, x1_)"
extern "C"
std::vector< int >* complement(std::string ** err_msg, std::vector< int >* x0, int x1);
std::vector< int >* complement(std::string ** err_msg, std::vector< int >* x0, int x1){
    try {
        std::vector< int > x0_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);

        std::vector< int > ret = casadi::complement(x0_, x1_);
        return WrapReturn< std::vector< int >*, std::vector< int > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* controldaeIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::controldaeIn(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* controldaeIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* controldaeIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::controldaeIn(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* controldaeIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::controldaeIn(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* controldaeIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* controldaeIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::controldaeIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* controldaeIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::controldaeIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* controldaeIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* controldaeIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::controldaeIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* controldaeIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::Sparsity* >* controldaeIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::Sparsity* >* controldaeIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::Sparsity > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* controldaeIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::Sparsity* >* controldaeIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::Sparsity* >* controldaeIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::Sparsity > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* controldaeIn__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::Sparsity* >* controldaeIn__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::Sparsity* >* controldaeIn__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::Sparsity > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* controldaeIn__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::Sparsity* >* controldaeIn__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::Sparsity* >* controldaeIn__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::Sparsity > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* controldaeIn__7(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::Sparsity* >* controldaeIn__7(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::Sparsity* >* controldaeIn__7(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::Sparsity > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__8"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* controldaeIn__8(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::vector< casadi::Sparsity* >* controldaeIn__8(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8);
std::vector< casadi::Sparsity* >* controldaeIn__8(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);

        std::vector< casadi::Sparsity > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__9"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* controldaeIn__9(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::vector< casadi::Sparsity* >* controldaeIn__9(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9);
std::vector< casadi::Sparsity* >* controldaeIn__9(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);

        std::vector< casadi::Sparsity > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__10"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* controldaeIn__10(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::controldaeIn(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* controldaeIn__10(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* controldaeIn__10(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::controldaeIn(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__11"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* controldaeIn__11(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::controldaeIn(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* controldaeIn__11(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* controldaeIn__11(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::controldaeIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__12"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* controldaeIn__12(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::controldaeIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::DMatrix* >* controldaeIn__12(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::DMatrix* >* controldaeIn__12(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::DMatrix > ret = casadi::controldaeIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__13"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* controldaeIn__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::DMatrix* >* controldaeIn__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::DMatrix* >* controldaeIn__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::DMatrix > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__14"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* controldaeIn__14(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::DMatrix* >* controldaeIn__14(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::DMatrix* >* controldaeIn__14(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::DMatrix > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__15"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* controldaeIn__15(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::DMatrix* >* controldaeIn__15(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::DMatrix* >* controldaeIn__15(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::DMatrix > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__16"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* controldaeIn__16(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::DMatrix* >* controldaeIn__16(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::DMatrix* >* controldaeIn__16(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::DMatrix > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__17"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* controldaeIn__17(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::DMatrix* >* controldaeIn__17(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::DMatrix* >* controldaeIn__17(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::DMatrix > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__18"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* controldaeIn__18(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::vector< casadi::DMatrix* >* controldaeIn__18(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8);
std::vector< casadi::DMatrix* >* controldaeIn__18(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);

        std::vector< casadi::DMatrix > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__19"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* controldaeIn__19(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::vector< casadi::DMatrix* >* controldaeIn__19(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9);
std::vector< casadi::DMatrix* >* controldaeIn__19(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);

        std::vector< casadi::DMatrix > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__20"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* controldaeIn__20(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::controldaeIn(x0_)"
extern "C"
std::vector< casadi::MX* >* controldaeIn__20(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* controldaeIn__20(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::controldaeIn(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__21"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* controldaeIn__21(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::controldaeIn(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* controldaeIn__21(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* controldaeIn__21(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::controldaeIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__22"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* controldaeIn__22(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::controldaeIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >* controldaeIn__22(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::MX* >* controldaeIn__22(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::MX > ret = casadi::controldaeIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__23"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* controldaeIn__23(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::MX* >* controldaeIn__23(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::MX* >* controldaeIn__23(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::MX > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__24"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* controldaeIn__24(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::MX* >* controldaeIn__24(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::MX* >* controldaeIn__24(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::MX > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__25"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* controldaeIn__25(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::MX* >* controldaeIn__25(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::MX* >* controldaeIn__25(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::MX > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__26"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* controldaeIn__26(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::MX* >* controldaeIn__26(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::MX* >* controldaeIn__26(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::MX > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__27"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* controldaeIn__27(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::MX* >* controldaeIn__27(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::MX* >* controldaeIn__27(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::MX > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__28"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* controldaeIn__28(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::vector< casadi::MX* >* controldaeIn__28(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8);
std::vector< casadi::MX* >* controldaeIn__28(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);

        std::vector< casadi::MX > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__29"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* controldaeIn__29(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::vector< casadi::MX* >* controldaeIn__29(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9);
std::vector< casadi::MX* >* controldaeIn__29(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);

        std::vector< casadi::MX > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__30"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* controldaeIn__30(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::controldaeIn(x0_)"
extern "C"
std::vector< casadi::SX* >* controldaeIn__30(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* controldaeIn__30(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::controldaeIn(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__31"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* controldaeIn__31(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::controldaeIn(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* controldaeIn__31(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* controldaeIn__31(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::controldaeIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__32"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* controldaeIn__32(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::controldaeIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::SX* >* controldaeIn__32(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::SX* >* controldaeIn__32(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::SX > ret = casadi::controldaeIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__33"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* controldaeIn__33(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::SX* >* controldaeIn__33(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::SX* >* controldaeIn__33(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::SX > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__34"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* controldaeIn__34(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::SX* >* controldaeIn__34(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::SX* >* controldaeIn__34(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::SX > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__35"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* controldaeIn__35(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::SX* >* controldaeIn__35(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::SX* >* controldaeIn__35(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::SX > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__36"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* controldaeIn__36(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::SX* >* controldaeIn__36(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::SX* >* controldaeIn__36(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::SX > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__37"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* controldaeIn__37(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::SX* >* controldaeIn__37(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::SX* >* controldaeIn__37(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::SX > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__38"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* controldaeIn__38(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::vector< casadi::SX* >* controldaeIn__38(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8);
std::vector< casadi::SX* >* controldaeIn__38(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);

        std::vector< casadi::SX > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controldaeIn" ===============
// cppName: "casadi::controldaeIn"
// cWrapperName: "controldaeIn__39"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* controldaeIn__39(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// call: "casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::vector< casadi::SX* >* controldaeIn__39(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9);
std::vector< casadi::SX* >* controldaeIn__39(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);

        std::vector< casadi::SX > ret = casadi::controldaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controlsimulatorIn" ===============
// cppName: "casadi::controlsimulatorIn"
// cWrapperName: "controlsimulatorIn__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* controlsimulatorIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::controlsimulatorIn(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* controlsimulatorIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* controlsimulatorIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::controlsimulatorIn(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controlsimulatorIn" ===============
// cppName: "casadi::controlsimulatorIn"
// cWrapperName: "controlsimulatorIn__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* controlsimulatorIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::controlsimulatorIn(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* controlsimulatorIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* controlsimulatorIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::controlsimulatorIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controlsimulatorIn" ===============
// cppName: "casadi::controlsimulatorIn"
// cWrapperName: "controlsimulatorIn__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* controlsimulatorIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::controlsimulatorIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* controlsimulatorIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* controlsimulatorIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::controlsimulatorIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controlsimulatorIn" ===============
// cppName: "casadi::controlsimulatorIn"
// cWrapperName: "controlsimulatorIn__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* controlsimulatorIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::controlsimulatorIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::Sparsity* >* controlsimulatorIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::Sparsity* >* controlsimulatorIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::Sparsity > ret = casadi::controlsimulatorIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controlsimulatorIn" ===============
// cppName: "casadi::controlsimulatorIn"
// cWrapperName: "controlsimulatorIn__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* controlsimulatorIn__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::controlsimulatorIn(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* controlsimulatorIn__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* controlsimulatorIn__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::controlsimulatorIn(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controlsimulatorIn" ===============
// cppName: "casadi::controlsimulatorIn"
// cWrapperName: "controlsimulatorIn__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* controlsimulatorIn__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::controlsimulatorIn(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* controlsimulatorIn__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* controlsimulatorIn__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::controlsimulatorIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controlsimulatorIn" ===============
// cppName: "casadi::controlsimulatorIn"
// cWrapperName: "controlsimulatorIn__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* controlsimulatorIn__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::controlsimulatorIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::DMatrix* >* controlsimulatorIn__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::DMatrix* >* controlsimulatorIn__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::DMatrix > ret = casadi::controlsimulatorIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controlsimulatorIn" ===============
// cppName: "casadi::controlsimulatorIn"
// cWrapperName: "controlsimulatorIn__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* controlsimulatorIn__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::controlsimulatorIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::DMatrix* >* controlsimulatorIn__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::DMatrix* >* controlsimulatorIn__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::DMatrix > ret = casadi::controlsimulatorIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controlsimulatorIn" ===============
// cppName: "casadi::controlsimulatorIn"
// cWrapperName: "controlsimulatorIn__8"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* controlsimulatorIn__8(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::controlsimulatorIn(x0_)"
extern "C"
std::vector< casadi::MX* >* controlsimulatorIn__8(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* controlsimulatorIn__8(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::controlsimulatorIn(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controlsimulatorIn" ===============
// cppName: "casadi::controlsimulatorIn"
// cWrapperName: "controlsimulatorIn__9"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* controlsimulatorIn__9(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::controlsimulatorIn(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* controlsimulatorIn__9(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* controlsimulatorIn__9(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::controlsimulatorIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controlsimulatorIn" ===============
// cppName: "casadi::controlsimulatorIn"
// cWrapperName: "controlsimulatorIn__10"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* controlsimulatorIn__10(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::controlsimulatorIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >* controlsimulatorIn__10(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::MX* >* controlsimulatorIn__10(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::MX > ret = casadi::controlsimulatorIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controlsimulatorIn" ===============
// cppName: "casadi::controlsimulatorIn"
// cWrapperName: "controlsimulatorIn__11"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* controlsimulatorIn__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::controlsimulatorIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::MX* >* controlsimulatorIn__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::MX* >* controlsimulatorIn__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::MX > ret = casadi::controlsimulatorIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controlsimulatorIn" ===============
// cppName: "casadi::controlsimulatorIn"
// cWrapperName: "controlsimulatorIn__12"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* controlsimulatorIn__12(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::controlsimulatorIn(x0_)"
extern "C"
std::vector< casadi::SX* >* controlsimulatorIn__12(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* controlsimulatorIn__12(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::controlsimulatorIn(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controlsimulatorIn" ===============
// cppName: "casadi::controlsimulatorIn"
// cWrapperName: "controlsimulatorIn__13"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* controlsimulatorIn__13(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::controlsimulatorIn(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* controlsimulatorIn__13(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* controlsimulatorIn__13(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::controlsimulatorIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controlsimulatorIn" ===============
// cppName: "casadi::controlsimulatorIn"
// cWrapperName: "controlsimulatorIn__14"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* controlsimulatorIn__14(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::controlsimulatorIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::SX* >* controlsimulatorIn__14(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::SX* >* controlsimulatorIn__14(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::SX > ret = casadi::controlsimulatorIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::controlsimulatorIn" ===============
// cppName: "casadi::controlsimulatorIn"
// cWrapperName: "controlsimulatorIn__15"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* controlsimulatorIn__15(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::controlsimulatorIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::SX* >* controlsimulatorIn__15(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::SX* >* controlsimulatorIn__15(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::SX > ret = casadi::controlsimulatorIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::countNodes" ===============
// cppName: "casadi::countNodes"
// cWrapperName: "countNodes__0"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: CInt
// args: "(x0_)"
// cWrapperRetType: "int"
// proto: "int countNodes__0(std::string ** err_msg, casadi::MX* x0)"
// call: "casadi::countNodes(x0_)"
extern "C"
int countNodes__0(std::string ** err_msg, casadi::MX* x0);
int countNodes__0(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX x0_ = Marshaling<casadi::MX,casadi::MX*>::marshal(x0);

        int ret = casadi::countNodes(x0_);
        return WrapReturn< int, int >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::countNodes" ===============
// cppName: "casadi::countNodes"
// cWrapperName: "countNodes__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: CInt
// args: "(x0_)"
// cWrapperRetType: "int"
// proto: "int countNodes__1(std::string ** err_msg, casadi::SX* x0)"
// call: "casadi::countNodes(x0_)"
extern "C"
int countNodes__1(std::string ** err_msg, casadi::SX* x0);
int countNodes__1(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);

        int ret = casadi::countNodes(x0_);
        return WrapReturn< int, int >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::createParent" ===============
// cppName: "casadi::createParent"
// cWrapperName: "createParent__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::vector< casadi::MX* >* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX* createParent__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::vector< casadi::MX* >* x1)"
// call: "casadi::createParent(x0_, x1_)"
extern "C"
casadi::MX* createParent__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::vector< casadi::MX* >* x1);
casadi::MX* createParent__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::vector< casadi::MX* >* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::vector< casadi::MX > x1_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x1);

        casadi::MX ret = casadi::createParent(x0_, x1_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::createParent" ===============
// cppName: "casadi::createParent"
// cWrapperName: "createParent__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX* createParent__1(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1)"
// call: "casadi::createParent(x0_, x1_)"
extern "C"
casadi::MX* createParent__1(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1);
casadi::MX* createParent__1(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::vector< casadi::MX > x1_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x1);

        casadi::MX ret = casadi::createParent(x0_, x1_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::createParent" ===============
// cppName: "casadi::createParent"
// cWrapperName: "createParent__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX* createParent__2(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::createParent(x0_)"
extern "C"
casadi::MX* createParent__2(std::string ** err_msg, std::vector< casadi::MX* >* x0);
casadi::MX* createParent__2(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        casadi::MX ret = casadi::createParent(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* daeIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::daeIn(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* daeIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* daeIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::daeIn(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* daeIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::daeIn(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* daeIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* daeIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::daeIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* daeIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::daeIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* daeIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* daeIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::daeIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* daeIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::daeIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::Sparsity* >* daeIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::Sparsity* >* daeIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::Sparsity > ret = casadi::daeIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* daeIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::daeIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::Sparsity* >* daeIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::Sparsity* >* daeIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::Sparsity > ret = casadi::daeIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* daeIn__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::daeIn(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* daeIn__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* daeIn__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::daeIn(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* daeIn__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::daeIn(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* daeIn__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* daeIn__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::daeIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* daeIn__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::daeIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::DMatrix* >* daeIn__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::DMatrix* >* daeIn__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::DMatrix > ret = casadi::daeIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__8"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* daeIn__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::daeIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::DMatrix* >* daeIn__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::DMatrix* >* daeIn__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::DMatrix > ret = casadi::daeIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__9"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* daeIn__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::daeIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::DMatrix* >* daeIn__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::DMatrix* >* daeIn__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::DMatrix > ret = casadi::daeIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__10"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* daeIn__10(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::daeIn(x0_)"
extern "C"
std::vector< casadi::MX* >* daeIn__10(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* daeIn__10(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::daeIn(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__11"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* daeIn__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::daeIn(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* daeIn__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* daeIn__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::daeIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__12"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* daeIn__12(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::daeIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >* daeIn__12(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::MX* >* daeIn__12(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::MX > ret = casadi::daeIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__13"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* daeIn__13(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::daeIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::MX* >* daeIn__13(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::MX* >* daeIn__13(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::MX > ret = casadi::daeIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__14"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* daeIn__14(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::daeIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::MX* >* daeIn__14(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::MX* >* daeIn__14(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::MX > ret = casadi::daeIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__15"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* daeIn__15(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::daeIn(x0_)"
extern "C"
std::vector< casadi::SX* >* daeIn__15(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* daeIn__15(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::daeIn(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__16"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* daeIn__16(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::daeIn(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* daeIn__16(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* daeIn__16(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::daeIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__17"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* daeIn__17(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::daeIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::SX* >* daeIn__17(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::SX* >* daeIn__17(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::SX > ret = casadi::daeIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__18"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* daeIn__18(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::daeIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::SX* >* daeIn__18(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::SX* >* daeIn__18(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::SX > ret = casadi::daeIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeIn" ===============
// cppName: "casadi::daeIn"
// cWrapperName: "daeIn__19"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* daeIn__19(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::daeIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::SX* >* daeIn__19(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::SX* >* daeIn__19(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::SX > ret = casadi::daeIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeOut" ===============
// cppName: "casadi::daeOut"
// cWrapperName: "daeOut__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* daeOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::daeOut(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* daeOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* daeOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::daeOut(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeOut" ===============
// cppName: "casadi::daeOut"
// cWrapperName: "daeOut__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* daeOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::daeOut(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* daeOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* daeOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::daeOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeOut" ===============
// cppName: "casadi::daeOut"
// cWrapperName: "daeOut__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* daeOut__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::daeOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* daeOut__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* daeOut__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::daeOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeOut" ===============
// cppName: "casadi::daeOut"
// cWrapperName: "daeOut__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* daeOut__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::daeOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::Sparsity* >* daeOut__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::Sparsity* >* daeOut__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::Sparsity > ret = casadi::daeOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeOut" ===============
// cppName: "casadi::daeOut"
// cWrapperName: "daeOut__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* daeOut__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::daeOut(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* daeOut__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* daeOut__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::daeOut(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeOut" ===============
// cppName: "casadi::daeOut"
// cWrapperName: "daeOut__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* daeOut__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::daeOut(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* daeOut__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* daeOut__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::daeOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeOut" ===============
// cppName: "casadi::daeOut"
// cWrapperName: "daeOut__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* daeOut__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::daeOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::DMatrix* >* daeOut__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::DMatrix* >* daeOut__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::DMatrix > ret = casadi::daeOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeOut" ===============
// cppName: "casadi::daeOut"
// cWrapperName: "daeOut__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* daeOut__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::daeOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::DMatrix* >* daeOut__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::DMatrix* >* daeOut__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::DMatrix > ret = casadi::daeOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeOut" ===============
// cppName: "casadi::daeOut"
// cWrapperName: "daeOut__8"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* daeOut__8(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::daeOut(x0_)"
extern "C"
std::vector< casadi::MX* >* daeOut__8(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* daeOut__8(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::daeOut(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeOut" ===============
// cppName: "casadi::daeOut"
// cWrapperName: "daeOut__9"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* daeOut__9(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::daeOut(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* daeOut__9(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* daeOut__9(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::daeOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeOut" ===============
// cppName: "casadi::daeOut"
// cWrapperName: "daeOut__10"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* daeOut__10(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::daeOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >* daeOut__10(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::MX* >* daeOut__10(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::MX > ret = casadi::daeOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeOut" ===============
// cppName: "casadi::daeOut"
// cWrapperName: "daeOut__11"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* daeOut__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::daeOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::MX* >* daeOut__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::MX* >* daeOut__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::MX > ret = casadi::daeOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeOut" ===============
// cppName: "casadi::daeOut"
// cWrapperName: "daeOut__12"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* daeOut__12(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::daeOut(x0_)"
extern "C"
std::vector< casadi::SX* >* daeOut__12(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* daeOut__12(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::daeOut(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeOut" ===============
// cppName: "casadi::daeOut"
// cWrapperName: "daeOut__13"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* daeOut__13(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::daeOut(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* daeOut__13(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* daeOut__13(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::daeOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeOut" ===============
// cppName: "casadi::daeOut"
// cWrapperName: "daeOut__14"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* daeOut__14(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::daeOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::SX* >* daeOut__14(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::SX* >* daeOut__14(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::SX > ret = casadi::daeOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::daeOut" ===============
// cppName: "casadi::daeOut"
// cWrapperName: "daeOut__15"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* daeOut__15(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::daeOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::SX* >* daeOut__15(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::SX* >* daeOut__15(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::SX > ret = casadi::daeOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dependsOn" ===============
// cppName: "casadi::dependsOn"
// cWrapperName: "dependsOn__0"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, std::vector< casadi::MX* >* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: CBool
// args: "(x0_, x1_)"
// cWrapperRetType: "int"
// proto: "int dependsOn__0(std::string ** err_msg, casadi::MX* x0, std::vector< casadi::MX* >* x1)"
// call: "casadi::dependsOn(x0_, x1_)"
extern "C"
int dependsOn__0(std::string ** err_msg, casadi::MX* x0, std::vector< casadi::MX* >* x1);
int dependsOn__0(std::string ** err_msg, casadi::MX* x0, std::vector< casadi::MX* >* x1){
    try {
        casadi::MX x0_ = Marshaling<casadi::MX,casadi::MX*>::marshal(x0);
        std::vector< casadi::MX > x1_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x1);

        bool ret = casadi::dependsOn(x0_, x1_);
        return WrapReturn< int, bool >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dependsOn" ===============
// cppName: "casadi::dependsOn"
// cWrapperName: "dependsOn__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: CBool
// args: "(x0_, x1_)"
// cWrapperRetType: "int"
// proto: "int dependsOn__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// call: "casadi::dependsOn(x0_, x1_)"
extern "C"
int dependsOn__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
int dependsOn__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);
        casadi::SX x1_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x1);

        bool ret = casadi::dependsOn(x0_, x1_);
        return WrapReturn< int, bool >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dleIn" ===============
// cppName: "casadi::dleIn"
// cWrapperName: "dleIn__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* dleIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::dleIn(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* dleIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* dleIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::dleIn(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dleIn" ===============
// cppName: "casadi::dleIn"
// cWrapperName: "dleIn__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* dleIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::dleIn(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* dleIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* dleIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::dleIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dleIn" ===============
// cppName: "casadi::dleIn"
// cWrapperName: "dleIn__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* dleIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::dleIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* dleIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* dleIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::dleIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dleIn" ===============
// cppName: "casadi::dleIn"
// cWrapperName: "dleIn__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* dleIn__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::dleIn(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* dleIn__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* dleIn__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::dleIn(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dleIn" ===============
// cppName: "casadi::dleIn"
// cWrapperName: "dleIn__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* dleIn__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::dleIn(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* dleIn__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* dleIn__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::dleIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dleIn" ===============
// cppName: "casadi::dleIn"
// cWrapperName: "dleIn__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* dleIn__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::dleIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::DMatrix* >* dleIn__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::DMatrix* >* dleIn__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::DMatrix > ret = casadi::dleIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dleIn" ===============
// cppName: "casadi::dleIn"
// cWrapperName: "dleIn__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* dleIn__6(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::dleIn(x0_)"
extern "C"
std::vector< casadi::MX* >* dleIn__6(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* dleIn__6(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::dleIn(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dleIn" ===============
// cppName: "casadi::dleIn"
// cWrapperName: "dleIn__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* dleIn__7(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::dleIn(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* dleIn__7(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* dleIn__7(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::dleIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dleIn" ===============
// cppName: "casadi::dleIn"
// cWrapperName: "dleIn__8"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* dleIn__8(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::dleIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >* dleIn__8(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::MX* >* dleIn__8(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::MX > ret = casadi::dleIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dleIn" ===============
// cppName: "casadi::dleIn"
// cWrapperName: "dleIn__9"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* dleIn__9(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::dleIn(x0_)"
extern "C"
std::vector< casadi::SX* >* dleIn__9(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* dleIn__9(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::dleIn(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dleIn" ===============
// cppName: "casadi::dleIn"
// cWrapperName: "dleIn__10"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* dleIn__10(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::dleIn(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* dleIn__10(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* dleIn__10(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::dleIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dleIn" ===============
// cppName: "casadi::dleIn"
// cWrapperName: "dleIn__11"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* dleIn__11(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::dleIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::SX* >* dleIn__11(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::SX* >* dleIn__11(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::SX > ret = casadi::dleIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dleOut" ===============
// cppName: "casadi::dleOut"
// cWrapperName: "dleOut__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* dleOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::dleOut(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* dleOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* dleOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::dleOut(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dleOut" ===============
// cppName: "casadi::dleOut"
// cWrapperName: "dleOut__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* dleOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::dleOut(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* dleOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* dleOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::dleOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dleOut" ===============
// cppName: "casadi::dleOut"
// cWrapperName: "dleOut__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* dleOut__2(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::dleOut(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* dleOut__2(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* dleOut__2(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::dleOut(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dleOut" ===============
// cppName: "casadi::dleOut"
// cWrapperName: "dleOut__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* dleOut__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::dleOut(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* dleOut__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* dleOut__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::dleOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dleOut" ===============
// cppName: "casadi::dleOut"
// cWrapperName: "dleOut__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* dleOut__4(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::dleOut(x0_)"
extern "C"
std::vector< casadi::MX* >* dleOut__4(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* dleOut__4(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::dleOut(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dleOut" ===============
// cppName: "casadi::dleOut"
// cWrapperName: "dleOut__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* dleOut__5(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::dleOut(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* dleOut__5(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* dleOut__5(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::dleOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dleOut" ===============
// cppName: "casadi::dleOut"
// cWrapperName: "dleOut__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* dleOut__6(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::dleOut(x0_)"
extern "C"
std::vector< casadi::SX* >* dleOut__6(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* dleOut__6(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::dleOut(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dleOut" ===============
// cppName: "casadi::dleOut"
// cWrapperName: "dleOut__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* dleOut__7(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::dleOut(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* dleOut__7(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* dleOut__7(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::dleOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dleStruct" ===============
// cppName: "casadi::dleStruct"
// cWrapperName: "dleStruct__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* dleStruct__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::dleStruct(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* dleStruct__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* dleStruct__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::dleStruct(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dleStruct" ===============
// cppName: "casadi::dleStruct"
// cWrapperName: "dleStruct__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* dleStruct__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::dleStruct(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* dleStruct__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* dleStruct__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::dleStruct(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dleStruct" ===============
// cppName: "casadi::dleStruct"
// cWrapperName: "dleStruct__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* dleStruct__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::dleStruct(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* dleStruct__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* dleStruct__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::dleStruct(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dpleIn" ===============
// cppName: "casadi::dpleIn"
// cWrapperName: "dpleIn__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* dpleIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::dpleIn(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* dpleIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* dpleIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::dpleIn(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dpleIn" ===============
// cppName: "casadi::dpleIn"
// cWrapperName: "dpleIn__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* dpleIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::dpleIn(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* dpleIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* dpleIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::dpleIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dpleIn" ===============
// cppName: "casadi::dpleIn"
// cWrapperName: "dpleIn__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* dpleIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::dpleIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* dpleIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* dpleIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::dpleIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dpleIn" ===============
// cppName: "casadi::dpleIn"
// cWrapperName: "dpleIn__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* dpleIn__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::dpleIn(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* dpleIn__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* dpleIn__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::dpleIn(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dpleIn" ===============
// cppName: "casadi::dpleIn"
// cWrapperName: "dpleIn__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* dpleIn__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::dpleIn(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* dpleIn__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* dpleIn__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::dpleIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dpleIn" ===============
// cppName: "casadi::dpleIn"
// cWrapperName: "dpleIn__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* dpleIn__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::dpleIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::DMatrix* >* dpleIn__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::DMatrix* >* dpleIn__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::DMatrix > ret = casadi::dpleIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dpleIn" ===============
// cppName: "casadi::dpleIn"
// cWrapperName: "dpleIn__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* dpleIn__6(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::dpleIn(x0_)"
extern "C"
std::vector< casadi::MX* >* dpleIn__6(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* dpleIn__6(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::dpleIn(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dpleIn" ===============
// cppName: "casadi::dpleIn"
// cWrapperName: "dpleIn__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* dpleIn__7(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::dpleIn(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* dpleIn__7(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* dpleIn__7(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::dpleIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dpleIn" ===============
// cppName: "casadi::dpleIn"
// cWrapperName: "dpleIn__8"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* dpleIn__8(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::dpleIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >* dpleIn__8(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::MX* >* dpleIn__8(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::MX > ret = casadi::dpleIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dpleIn" ===============
// cppName: "casadi::dpleIn"
// cWrapperName: "dpleIn__9"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* dpleIn__9(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::dpleIn(x0_)"
extern "C"
std::vector< casadi::SX* >* dpleIn__9(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* dpleIn__9(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::dpleIn(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dpleIn" ===============
// cppName: "casadi::dpleIn"
// cWrapperName: "dpleIn__10"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* dpleIn__10(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::dpleIn(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* dpleIn__10(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* dpleIn__10(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::dpleIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dpleIn" ===============
// cppName: "casadi::dpleIn"
// cWrapperName: "dpleIn__11"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* dpleIn__11(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::dpleIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::SX* >* dpleIn__11(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::SX* >* dpleIn__11(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::SX > ret = casadi::dpleIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dpleOut" ===============
// cppName: "casadi::dpleOut"
// cWrapperName: "dpleOut__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* dpleOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::dpleOut(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* dpleOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* dpleOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::dpleOut(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dpleOut" ===============
// cppName: "casadi::dpleOut"
// cWrapperName: "dpleOut__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* dpleOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::dpleOut(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* dpleOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* dpleOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::dpleOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dpleOut" ===============
// cppName: "casadi::dpleOut"
// cWrapperName: "dpleOut__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* dpleOut__2(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::dpleOut(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* dpleOut__2(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* dpleOut__2(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::dpleOut(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dpleOut" ===============
// cppName: "casadi::dpleOut"
// cWrapperName: "dpleOut__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* dpleOut__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::dpleOut(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* dpleOut__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* dpleOut__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::dpleOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dpleOut" ===============
// cppName: "casadi::dpleOut"
// cWrapperName: "dpleOut__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* dpleOut__4(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::dpleOut(x0_)"
extern "C"
std::vector< casadi::MX* >* dpleOut__4(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* dpleOut__4(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::dpleOut(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dpleOut" ===============
// cppName: "casadi::dpleOut"
// cWrapperName: "dpleOut__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* dpleOut__5(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::dpleOut(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* dpleOut__5(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* dpleOut__5(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::dpleOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dpleOut" ===============
// cppName: "casadi::dpleOut"
// cWrapperName: "dpleOut__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* dpleOut__6(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::dpleOut(x0_)"
extern "C"
std::vector< casadi::SX* >* dpleOut__6(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* dpleOut__6(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::dpleOut(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dpleOut" ===============
// cppName: "casadi::dpleOut"
// cWrapperName: "dpleOut__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* dpleOut__7(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::dpleOut(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* dpleOut__7(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* dpleOut__7(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::dpleOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dpleStruct" ===============
// cppName: "casadi::dpleStruct"
// cWrapperName: "dpleStruct__0"
// protoArgs: "(std::string ** err_msg, std::vector< std::vector< casadi::Sparsity* >* >* x0)"
// params: [Ref (Const (StdVec (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))))]
// retType: StdVec (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))
// args: "(x0_)"
// cWrapperRetType: "std::vector< std::vector< casadi::Sparsity* >* >*"
// proto: "std::vector< std::vector< casadi::Sparsity* >* >* dpleStruct__0(std::string ** err_msg, std::vector< std::vector< casadi::Sparsity* >* >* x0)"
// call: "casadi::dpleStruct(x0_)"
extern "C"
std::vector< std::vector< casadi::Sparsity* >* >* dpleStruct__0(std::string ** err_msg, std::vector< std::vector< casadi::Sparsity* >* >* x0);
std::vector< std::vector< casadi::Sparsity* >* >* dpleStruct__0(std::string ** err_msg, std::vector< std::vector< casadi::Sparsity* >* >* x0){
    try {
        std::vector< std::vector< casadi::Sparsity > > x0_ = Marshaling<std::vector< std::vector< casadi::Sparsity > >,std::vector< std::vector< casadi::Sparsity* >* >*>::marshal(x0);

        std::vector< std::vector< casadi::Sparsity > > ret = casadi::dpleStruct(x0_);
        return WrapReturn< std::vector< std::vector< casadi::Sparsity* >* >*, std::vector< std::vector< casadi::Sparsity > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dpleStruct" ===============
// cppName: "casadi::dpleStruct"
// cWrapperName: "dpleStruct__1"
// protoArgs: "(std::string ** err_msg, std::vector< std::vector< casadi::Sparsity* >* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))),Ref (Const StdString)]
// retType: StdVec (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< std::vector< casadi::Sparsity* >* >*"
// proto: "std::vector< std::vector< casadi::Sparsity* >* >* dpleStruct__1(std::string ** err_msg, std::vector< std::vector< casadi::Sparsity* >* >* x0, std::string* x1)"
// call: "casadi::dpleStruct(x0_, x1_)"
extern "C"
std::vector< std::vector< casadi::Sparsity* >* >* dpleStruct__1(std::string ** err_msg, std::vector< std::vector< casadi::Sparsity* >* >* x0, std::string* x1);
std::vector< std::vector< casadi::Sparsity* >* >* dpleStruct__1(std::string ** err_msg, std::vector< std::vector< casadi::Sparsity* >* >* x0, std::string* x1){
    try {
        std::vector< std::vector< casadi::Sparsity > > x0_ = Marshaling<std::vector< std::vector< casadi::Sparsity > >,std::vector< std::vector< casadi::Sparsity* >* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< std::vector< casadi::Sparsity > > ret = casadi::dpleStruct(x0_, x1_);
        return WrapReturn< std::vector< std::vector< casadi::Sparsity* >* >*, std::vector< std::vector< casadi::Sparsity > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::dpleStruct" ===============
// cppName: "casadi::dpleStruct"
// cWrapperName: "dpleStruct__2"
// protoArgs: "(std::string ** err_msg, std::vector< std::vector< casadi::Sparsity* >* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< std::vector< casadi::Sparsity* >* >*"
// proto: "std::vector< std::vector< casadi::Sparsity* >* >* dpleStruct__2(std::string ** err_msg, std::vector< std::vector< casadi::Sparsity* >* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::dpleStruct(x0_, x1_, x2_)"
extern "C"
std::vector< std::vector< casadi::Sparsity* >* >* dpleStruct__2(std::string ** err_msg, std::vector< std::vector< casadi::Sparsity* >* >* x0, std::string* x1, std::string* x2);
std::vector< std::vector< casadi::Sparsity* >* >* dpleStruct__2(std::string ** err_msg, std::vector< std::vector< casadi::Sparsity* >* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< std::vector< casadi::Sparsity > > x0_ = Marshaling<std::vector< std::vector< casadi::Sparsity > >,std::vector< std::vector< casadi::Sparsity* >* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< std::vector< casadi::Sparsity > > ret = casadi::dpleStruct(x0_, x1_, x2_);
        return WrapReturn< std::vector< std::vector< casadi::Sparsity* >* >*, std::vector< std::vector< casadi::Sparsity > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::eig_symbolic" ===============
// cppName: "casadi::eig_symbolic"
// cWrapperName: "eig_symbolic"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX* eig_symbolic(std::string ** err_msg, casadi::SX* x0)"
// call: "casadi::eig_symbolic(x0_)"
extern "C"
casadi::SX* eig_symbolic(std::string ** err_msg, casadi::SX* x0);
casadi::SX* eig_symbolic(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);

        casadi::SX ret = casadi::eig_symbolic(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::evalf" ===============
// cppName: "casadi::evalf"
// cWrapperName: "evalf__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::DMatrix* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix* evalf__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::DMatrix* x2)"
// call: "casadi::evalf(x0_, x1_, x2_)"
extern "C"
casadi::DMatrix* evalf__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::DMatrix* x2);
casadi::DMatrix* evalf__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::DMatrix* x2){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);
        casadi::SX x1_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x1);
        casadi::DMatrix x2_ = Marshaling<casadi::DMatrix,casadi::DMatrix*>::marshal(x2);

        casadi::DMatrix ret = casadi::evalf(x0_, x1_, x2_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::evalf" ===============
// cppName: "casadi::evalf"
// cWrapperName: "evalf__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix* evalf__1(std::string ** err_msg, casadi::SX* x0)"
// call: "casadi::evalf(x0_)"
extern "C"
casadi::DMatrix* evalf__1(std::string ** err_msg, casadi::SX* x0);
casadi::DMatrix* evalf__1(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);

        casadi::DMatrix ret = casadi::evalf(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::expand" ===============
// cppName: "casadi::expand"
// cWrapperName: "expand"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (UserType (Namespace ["casadi"]) (Name "SX")),Ref (UserType (Namespace ["casadi"]) (Name "SX"))]
// retType: CVoid
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "void"
// proto: "void expand(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2)"
// call: "casadi::expand(x0_, x1_, x2_)"
extern "C"
void expand(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2);
void expand(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);
        casadi::SX x1_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x1);
        casadi::SX x2_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x2);

        casadi::expand(x0_, x1_, x2_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::explicitRK" ===============
// cppName: "casadi::explicitRK"
// cWrapperName: "explicitRK__0"
// protoArgs: "(std::string ** err_msg, casadi::Function* x0)"
// params: [Ref (UserType (Namespace ["casadi"]) (Name "Function"))]
// retType: UserType (Namespace ["casadi"]) (Name "Function")
// args: "(x0_)"
// cWrapperRetType: "casadi::Function*"
// proto: "casadi::Function* explicitRK__0(std::string ** err_msg, casadi::Function* x0)"
// call: "casadi::explicitRK(x0_)"
extern "C"
casadi::Function* explicitRK__0(std::string ** err_msg, casadi::Function* x0);
casadi::Function* explicitRK__0(std::string ** err_msg, casadi::Function* x0){
    try {
        casadi::Function x0_ = Marshaling<casadi::Function,casadi::Function*>::marshal(x0);

        casadi::Function ret = casadi::explicitRK(x0_);
        return WrapReturn< casadi::Function*, casadi::Function >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::explicitRK" ===============
// cppName: "casadi::explicitRK"
// cWrapperName: "explicitRK__1"
// protoArgs: "(std::string ** err_msg, casadi::Function* x0, casadi::MX* x1)"
// params: [Ref (UserType (Namespace ["casadi"]) (Name "Function")),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "Function")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::Function*"
// proto: "casadi::Function* explicitRK__1(std::string ** err_msg, casadi::Function* x0, casadi::MX* x1)"
// call: "casadi::explicitRK(x0_, x1_)"
extern "C"
casadi::Function* explicitRK__1(std::string ** err_msg, casadi::Function* x0, casadi::MX* x1);
casadi::Function* explicitRK__1(std::string ** err_msg, casadi::Function* x0, casadi::MX* x1){
    try {
        casadi::Function x0_ = Marshaling<casadi::Function,casadi::Function*>::marshal(x0);
        casadi::MX x1_ = Marshaling<casadi::MX,casadi::MX*>::marshal(x1);

        casadi::Function ret = casadi::explicitRK(x0_, x1_);
        return WrapReturn< casadi::Function*, casadi::Function >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::explicitRK" ===============
// cppName: "casadi::explicitRK"
// cWrapperName: "explicitRK__2"
// protoArgs: "(std::string ** err_msg, casadi::Function* x0, casadi::MX* x1, int x2)"
// params: [Ref (UserType (Namespace ["casadi"]) (Name "Function")),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),CInt]
// retType: UserType (Namespace ["casadi"]) (Name "Function")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::Function*"
// proto: "casadi::Function* explicitRK__2(std::string ** err_msg, casadi::Function* x0, casadi::MX* x1, int x2)"
// call: "casadi::explicitRK(x0_, x1_, x2_)"
extern "C"
casadi::Function* explicitRK__2(std::string ** err_msg, casadi::Function* x0, casadi::MX* x1, int x2);
casadi::Function* explicitRK__2(std::string ** err_msg, casadi::Function* x0, casadi::MX* x1, int x2){
    try {
        casadi::Function x0_ = Marshaling<casadi::Function,casadi::Function*>::marshal(x0);
        casadi::MX x1_ = Marshaling<casadi::MX,casadi::MX*>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);

        casadi::Function ret = casadi::explicitRK(x0_, x1_, x2_);
        return WrapReturn< casadi::Function*, casadi::Function >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::explicitRK" ===============
// cppName: "casadi::explicitRK"
// cWrapperName: "explicitRK__3"
// protoArgs: "(std::string ** err_msg, casadi::Function* x0, casadi::MX* x1, int x2, int x3)"
// params: [Ref (UserType (Namespace ["casadi"]) (Name "Function")),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),CInt,CInt]
// retType: UserType (Namespace ["casadi"]) (Name "Function")
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "casadi::Function*"
// proto: "casadi::Function* explicitRK__3(std::string ** err_msg, casadi::Function* x0, casadi::MX* x1, int x2, int x3)"
// call: "casadi::explicitRK(x0_, x1_, x2_, x3_)"
extern "C"
casadi::Function* explicitRK__3(std::string ** err_msg, casadi::Function* x0, casadi::MX* x1, int x2, int x3);
casadi::Function* explicitRK__3(std::string ** err_msg, casadi::Function* x0, casadi::MX* x1, int x2, int x3){
    try {
        casadi::Function x0_ = Marshaling<casadi::Function,casadi::Function*>::marshal(x0);
        casadi::MX x1_ = Marshaling<casadi::MX,casadi::MX*>::marshal(x1);
        int x2_ = Marshaling<int,int>::marshal(x2);
        int x3_ = Marshaling<int,int>::marshal(x3);

        casadi::Function ret = casadi::explicitRK(x0_, x1_, x2_, x3_);
        return WrapReturn< casadi::Function*, casadi::Function >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::extractShared" ===============
// cppName: "casadi::extractShared"
// cWrapperName: "extractShared__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2)"
// params: [Ref (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: CVoid
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "void"
// proto: "void extractShared__0(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2)"
// call: "casadi::extractShared(x0_, x1_, x2_)"
extern "C"
void extractShared__0(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2);
void extractShared__0(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::vector< casadi::MX > x1_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x1);
        std::vector< casadi::MX > x2_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x2);

        casadi::extractShared(x0_, x1_, x2_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::extractShared" ===============
// cppName: "casadi::extractShared"
// cWrapperName: "extractShared__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2, std::string* x3)"
// params: [Ref (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: CVoid
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "void"
// proto: "void extractShared__1(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2, std::string* x3)"
// call: "casadi::extractShared(x0_, x1_, x2_, x3_)"
extern "C"
void extractShared__1(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2, std::string* x3);
void extractShared__1(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2, std::string* x3){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::vector< casadi::MX > x1_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x1);
        std::vector< casadi::MX > x2_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        casadi::extractShared(x0_, x1_, x2_, x3_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::extractShared" ===============
// cppName: "casadi::extractShared"
// cWrapperName: "extractShared__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2, std::string* x3, std::string* x4)"
// params: [Ref (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString),Ref (Const StdString)]
// retType: CVoid
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "void"
// proto: "void extractShared__2(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2, std::string* x3, std::string* x4)"
// call: "casadi::extractShared(x0_, x1_, x2_, x3_, x4_)"
extern "C"
void extractShared__2(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2, std::string* x3, std::string* x4);
void extractShared__2(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::vector< casadi::MX > x1_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x1);
        std::vector< casadi::MX > x2_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        casadi::extractShared(x0_, x1_, x2_, x3_, x4_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::extractShared" ===============
// cppName: "casadi::extractShared"
// cWrapperName: "extractShared__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2)"
// params: [Ref (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: CVoid
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "void"
// proto: "void extractShared__3(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2)"
// call: "casadi::extractShared(x0_, x1_, x2_)"
extern "C"
void extractShared__3(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2);
void extractShared__3(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::vector< casadi::SX > x1_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x1);
        std::vector< casadi::SX > x2_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x2);

        casadi::extractShared(x0_, x1_, x2_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::extractShared" ===============
// cppName: "casadi::extractShared"
// cWrapperName: "extractShared__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2, std::string* x3)"
// params: [Ref (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString)]
// retType: CVoid
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "void"
// proto: "void extractShared__4(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2, std::string* x3)"
// call: "casadi::extractShared(x0_, x1_, x2_, x3_)"
extern "C"
void extractShared__4(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2, std::string* x3);
void extractShared__4(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2, std::string* x3){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::vector< casadi::SX > x1_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x1);
        std::vector< casadi::SX > x2_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        casadi::extractShared(x0_, x1_, x2_, x3_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::extractShared" ===============
// cppName: "casadi::extractShared"
// cWrapperName: "extractShared__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2, std::string* x3, std::string* x4)"
// params: [Ref (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const StdString),Ref (Const StdString)]
// retType: CVoid
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "void"
// proto: "void extractShared__5(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2, std::string* x3, std::string* x4)"
// call: "casadi::extractShared(x0_, x1_, x2_, x3_, x4_)"
extern "C"
void extractShared__5(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2, std::string* x3, std::string* x4);
void extractShared__5(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::vector< casadi::SX > x1_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x1);
        std::vector< casadi::SX > x2_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        casadi::extractShared(x0_, x1_, x2_, x3_, x4_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::gauss_quadrature" ===============
// cppName: "casadi::gauss_quadrature"
// cWrapperName: "gauss_quadrature__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, casadi::SX* x3)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX* gauss_quadrature__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, casadi::SX* x3)"
// call: "casadi::gauss_quadrature(x0_, x1_, x2_, x3_)"
extern "C"
casadi::SX* gauss_quadrature__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, casadi::SX* x3);
casadi::SX* gauss_quadrature__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, casadi::SX* x3){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);
        casadi::SX x1_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x1);
        casadi::SX x2_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x2);
        casadi::SX x3_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x3);

        casadi::SX ret = casadi::gauss_quadrature(x0_, x1_, x2_, x3_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gauss_quadrature" ===============
// cppName: "casadi::gauss_quadrature"
// cWrapperName: "gauss_quadrature__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, casadi::SX* x3, int x4)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),CInt]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX* gauss_quadrature__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, casadi::SX* x3, int x4)"
// call: "casadi::gauss_quadrature(x0_, x1_, x2_, x3_, x4_)"
extern "C"
casadi::SX* gauss_quadrature__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, casadi::SX* x3, int x4);
casadi::SX* gauss_quadrature__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, casadi::SX* x3, int x4){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);
        casadi::SX x1_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x1);
        casadi::SX x2_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x2);
        casadi::SX x3_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x3);
        int x4_ = Marshaling<int,int>::marshal(x4);

        casadi::SX ret = casadi::gauss_quadrature(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gauss_quadrature" ===============
// cppName: "casadi::gauss_quadrature"
// cWrapperName: "gauss_quadrature__2"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, casadi::SX* x3, int x4, casadi::SX* x5)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),CInt,Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX* gauss_quadrature__2(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, casadi::SX* x3, int x4, casadi::SX* x5)"
// call: "casadi::gauss_quadrature(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
casadi::SX* gauss_quadrature__2(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, casadi::SX* x3, int x4, casadi::SX* x5);
casadi::SX* gauss_quadrature__2(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, casadi::SX* x3, int x4, casadi::SX* x5){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);
        casadi::SX x1_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x1);
        casadi::SX x2_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x2);
        casadi::SX x3_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x3);
        int x4_ = Marshaling<int,int>::marshal(x4);
        casadi::SX x5_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x5);

        casadi::SX ret = casadi::gauss_quadrature(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::getFree" ===============
// cppName: "casadi::getFree"
// cWrapperName: "getFree"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX* getFree(std::string ** err_msg, casadi::SX* x0)"
// call: "casadi::getFree(x0_)"
extern "C"
casadi::SX* getFree(std::string ** err_msg, casadi::SX* x0);
casadi::SX* getFree(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);

        casadi::SX ret = casadi::getFree(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::getOperatorRepresentation" ===============
// cppName: "casadi::getOperatorRepresentation"
// cWrapperName: "getOperatorRepresentation__0"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, std::vector< std::string* >* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (StdVec StdString))]
// retType: StdString
// args: "(x0_, x1_)"
// cWrapperRetType: "std::string*"
// proto: "std::string* getOperatorRepresentation__0(std::string ** err_msg, casadi::MX* x0, std::vector< std::string* >* x1)"
// call: "casadi::getOperatorRepresentation(x0_, x1_)"
extern "C"
std::string* getOperatorRepresentation__0(std::string ** err_msg, casadi::MX* x0, std::vector< std::string* >* x1);
std::string* getOperatorRepresentation__0(std::string ** err_msg, casadi::MX* x0, std::vector< std::string* >* x1){
    try {
        casadi::MX x0_ = Marshaling<casadi::MX,casadi::MX*>::marshal(x0);
        std::vector< std::string > x1_ = Marshaling<std::vector< std::string >,std::vector< std::string* >*>::marshal(x1);

        std::string ret = casadi::getOperatorRepresentation(x0_, x1_);
        return WrapReturn< std::string*, std::string >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::getOperatorRepresentation" ===============
// cppName: "casadi::getOperatorRepresentation"
// cWrapperName: "getOperatorRepresentation__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, std::vector< std::string* >* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (StdVec StdString))]
// retType: StdString
// args: "(x0_, x1_)"
// cWrapperRetType: "std::string*"
// proto: "std::string* getOperatorRepresentation__1(std::string ** err_msg, casadi::SX* x0, std::vector< std::string* >* x1)"
// call: "casadi::getOperatorRepresentation(x0_, x1_)"
extern "C"
std::string* getOperatorRepresentation__1(std::string ** err_msg, casadi::SX* x0, std::vector< std::string* >* x1);
std::string* getOperatorRepresentation__1(std::string ** err_msg, casadi::SX* x0, std::vector< std::string* >* x1){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);
        std::vector< std::string > x1_ = Marshaling<std::vector< std::string >,std::vector< std::string* >*>::marshal(x1);

        std::string ret = casadi::getOperatorRepresentation(x0_, x1_);
        return WrapReturn< std::string*, std::string >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::getSchemeEntryDoc" ===============
// cppName: "casadi::getSchemeEntryDoc"
// cWrapperName: "getSchemeEntryDoc"
// protoArgs: "(std::string ** err_msg, int x0, int x1)"
// params: [CEnum (Namespace ["casadi"]) (Name "InputOutputScheme"),CInt]
// retType: StdString
// args: "(x0_, x1_)"
// cWrapperRetType: "std::string*"
// proto: "std::string* getSchemeEntryDoc(std::string ** err_msg, int x0, int x1)"
// call: "casadi::getSchemeEntryDoc(x0_, x1_)"
extern "C"
std::string* getSchemeEntryDoc(std::string ** err_msg, int x0, int x1);
std::string* getSchemeEntryDoc(std::string ** err_msg, int x0, int x1){
    try {
        casadi::InputOutputScheme x0_ = Marshaling<casadi::InputOutputScheme,int>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);

        std::string ret = casadi::getSchemeEntryDoc(x0_, x1_);
        return WrapReturn< std::string*, std::string >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::getSchemeEntryEnum" ===============
// cppName: "casadi::getSchemeEntryEnum"
// cWrapperName: "getSchemeEntryEnum"
// protoArgs: "(std::string ** err_msg, int x0, std::string* x1)"
// params: [CEnum (Namespace ["casadi"]) (Name "InputOutputScheme"),Ref (Const StdString)]
// retType: CInt
// args: "(x0_, x1_)"
// cWrapperRetType: "int"
// proto: "int getSchemeEntryEnum(std::string ** err_msg, int x0, std::string* x1)"
// call: "casadi::getSchemeEntryEnum(x0_, x1_)"
extern "C"
int getSchemeEntryEnum(std::string ** err_msg, int x0, std::string* x1);
int getSchemeEntryEnum(std::string ** err_msg, int x0, std::string* x1){
    try {
        casadi::InputOutputScheme x0_ = Marshaling<casadi::InputOutputScheme,int>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        int ret = casadi::getSchemeEntryEnum(x0_, x1_);
        return WrapReturn< int, int >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::getSchemeEntryEnumName" ===============
// cppName: "casadi::getSchemeEntryEnumName"
// cWrapperName: "getSchemeEntryEnumName"
// protoArgs: "(std::string ** err_msg, int x0, int x1)"
// params: [CEnum (Namespace ["casadi"]) (Name "InputOutputScheme"),CInt]
// retType: StdString
// args: "(x0_, x1_)"
// cWrapperRetType: "std::string*"
// proto: "std::string* getSchemeEntryEnumName(std::string ** err_msg, int x0, int x1)"
// call: "casadi::getSchemeEntryEnumName(x0_, x1_)"
extern "C"
std::string* getSchemeEntryEnumName(std::string ** err_msg, int x0, int x1);
std::string* getSchemeEntryEnumName(std::string ** err_msg, int x0, int x1){
    try {
        casadi::InputOutputScheme x0_ = Marshaling<casadi::InputOutputScheme,int>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);

        std::string ret = casadi::getSchemeEntryEnumName(x0_, x1_);
        return WrapReturn< std::string*, std::string >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::getSchemeEntryName" ===============
// cppName: "casadi::getSchemeEntryName"
// cWrapperName: "getSchemeEntryName"
// protoArgs: "(std::string ** err_msg, int x0, int x1)"
// params: [CEnum (Namespace ["casadi"]) (Name "InputOutputScheme"),CInt]
// retType: StdString
// args: "(x0_, x1_)"
// cWrapperRetType: "std::string*"
// proto: "std::string* getSchemeEntryName(std::string ** err_msg, int x0, int x1)"
// call: "casadi::getSchemeEntryName(x0_, x1_)"
extern "C"
std::string* getSchemeEntryName(std::string ** err_msg, int x0, int x1);
std::string* getSchemeEntryName(std::string ** err_msg, int x0, int x1){
    try {
        casadi::InputOutputScheme x0_ = Marshaling<casadi::InputOutputScheme,int>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);

        std::string ret = casadi::getSchemeEntryName(x0_, x1_);
        return WrapReturn< std::string*, std::string >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::getSchemeEntryNames" ===============
// cppName: "casadi::getSchemeEntryNames"
// cWrapperName: "getSchemeEntryNames"
// protoArgs: "(std::string ** err_msg, int x0)"
// params: [CEnum (Namespace ["casadi"]) (Name "InputOutputScheme")]
// retType: StdString
// args: "(x0_)"
// cWrapperRetType: "std::string*"
// proto: "std::string* getSchemeEntryNames(std::string ** err_msg, int x0)"
// call: "casadi::getSchemeEntryNames(x0_)"
extern "C"
std::string* getSchemeEntryNames(std::string ** err_msg, int x0);
std::string* getSchemeEntryNames(std::string ** err_msg, int x0){
    try {
        casadi::InputOutputScheme x0_ = Marshaling<casadi::InputOutputScheme,int>::marshal(x0);

        std::string ret = casadi::getSchemeEntryNames(x0_);
        return WrapReturn< std::string*, std::string >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::getSchemeName" ===============
// cppName: "casadi::getSchemeName"
// cWrapperName: "getSchemeName"
// protoArgs: "(std::string ** err_msg, int x0)"
// params: [CEnum (Namespace ["casadi"]) (Name "InputOutputScheme")]
// retType: StdString
// args: "(x0_)"
// cWrapperRetType: "std::string*"
// proto: "std::string* getSchemeName(std::string ** err_msg, int x0)"
// call: "casadi::getSchemeName(x0_)"
extern "C"
std::string* getSchemeName(std::string ** err_msg, int x0);
std::string* getSchemeName(std::string ** err_msg, int x0){
    try {
        casadi::InputOutputScheme x0_ = Marshaling<casadi::InputOutputScheme,int>::marshal(x0);

        std::string ret = casadi::getSchemeName(x0_);
        return WrapReturn< std::string*, std::string >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::getSchemeSize" ===============
// cppName: "casadi::getSchemeSize"
// cWrapperName: "getSchemeSize"
// protoArgs: "(std::string ** err_msg, int x0)"
// params: [CEnum (Namespace ["casadi"]) (Name "InputOutputScheme")]
// retType: CInt
// args: "(x0_)"
// cWrapperRetType: "int"
// proto: "int getSchemeSize(std::string ** err_msg, int x0)"
// call: "casadi::getSchemeSize(x0_)"
extern "C"
int getSchemeSize(std::string ** err_msg, int x0);
int getSchemeSize(std::string ** err_msg, int x0){
    try {
        casadi::InputOutputScheme x0_ = Marshaling<casadi::InputOutputScheme,int>::marshal(x0);

        int ret = casadi::getSchemeSize(x0_);
        return WrapReturn< int, int >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::getSymbols" ===============
// cppName: "casadi::getSymbols"
// cWrapperName: "getSymbols__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* getSymbols__0(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::getSymbols(x0_)"
extern "C"
std::vector< casadi::MX* >* getSymbols__0(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* getSymbols__0(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::getSymbols(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::getSymbols" ===============
// cppName: "casadi::getSymbols"
// cWrapperName: "getSymbols__1"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* getSymbols__1(std::string ** err_msg, casadi::MX* x0)"
// call: "casadi::getSymbols(x0_)"
extern "C"
std::vector< casadi::MX* >* getSymbols__1(std::string ** err_msg, casadi::MX* x0);
std::vector< casadi::MX* >* getSymbols__1(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX x0_ = Marshaling<casadi::MX,casadi::MX*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::getSymbols(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::getSymbols" ===============
// cppName: "casadi::getSymbols"
// cWrapperName: "getSymbols__2"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX* getSymbols__2(std::string ** err_msg, casadi::SX* x0)"
// call: "casadi::getSymbols(x0_)"
extern "C"
casadi::SX* getSymbols__2(std::string ** err_msg, casadi::SX* x0);
casadi::SX* getSymbols__2(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);

        casadi::SX ret = casadi::getSymbols(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFIn" ===============
// cppName: "casadi::gradFIn"
// cWrapperName: "gradFIn__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* gradFIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::gradFIn(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* gradFIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* gradFIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::gradFIn(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFIn" ===============
// cppName: "casadi::gradFIn"
// cWrapperName: "gradFIn__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* gradFIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::gradFIn(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* gradFIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* gradFIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::gradFIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFIn" ===============
// cppName: "casadi::gradFIn"
// cWrapperName: "gradFIn__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* gradFIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::gradFIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* gradFIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* gradFIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::gradFIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFIn" ===============
// cppName: "casadi::gradFIn"
// cWrapperName: "gradFIn__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* gradFIn__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::gradFIn(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* gradFIn__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* gradFIn__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::gradFIn(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFIn" ===============
// cppName: "casadi::gradFIn"
// cWrapperName: "gradFIn__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* gradFIn__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::gradFIn(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* gradFIn__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* gradFIn__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::gradFIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFIn" ===============
// cppName: "casadi::gradFIn"
// cWrapperName: "gradFIn__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* gradFIn__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::gradFIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::DMatrix* >* gradFIn__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::DMatrix* >* gradFIn__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::DMatrix > ret = casadi::gradFIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFIn" ===============
// cppName: "casadi::gradFIn"
// cWrapperName: "gradFIn__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* gradFIn__6(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::gradFIn(x0_)"
extern "C"
std::vector< casadi::MX* >* gradFIn__6(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* gradFIn__6(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::gradFIn(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFIn" ===============
// cppName: "casadi::gradFIn"
// cWrapperName: "gradFIn__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* gradFIn__7(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::gradFIn(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* gradFIn__7(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* gradFIn__7(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::gradFIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFIn" ===============
// cppName: "casadi::gradFIn"
// cWrapperName: "gradFIn__8"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* gradFIn__8(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::gradFIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >* gradFIn__8(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::MX* >* gradFIn__8(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::MX > ret = casadi::gradFIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFIn" ===============
// cppName: "casadi::gradFIn"
// cWrapperName: "gradFIn__9"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* gradFIn__9(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::gradFIn(x0_)"
extern "C"
std::vector< casadi::SX* >* gradFIn__9(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* gradFIn__9(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::gradFIn(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFIn" ===============
// cppName: "casadi::gradFIn"
// cWrapperName: "gradFIn__10"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* gradFIn__10(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::gradFIn(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* gradFIn__10(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* gradFIn__10(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::gradFIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFIn" ===============
// cppName: "casadi::gradFIn"
// cWrapperName: "gradFIn__11"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* gradFIn__11(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::gradFIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::SX* >* gradFIn__11(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::SX* >* gradFIn__11(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::SX > ret = casadi::gradFIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFOut" ===============
// cppName: "casadi::gradFOut"
// cWrapperName: "gradFOut__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* gradFOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::gradFOut(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* gradFOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* gradFOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::gradFOut(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFOut" ===============
// cppName: "casadi::gradFOut"
// cWrapperName: "gradFOut__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* gradFOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::gradFOut(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* gradFOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* gradFOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::gradFOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFOut" ===============
// cppName: "casadi::gradFOut"
// cWrapperName: "gradFOut__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* gradFOut__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::gradFOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* gradFOut__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* gradFOut__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::gradFOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFOut" ===============
// cppName: "casadi::gradFOut"
// cWrapperName: "gradFOut__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* gradFOut__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::gradFOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::Sparsity* >* gradFOut__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::Sparsity* >* gradFOut__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::Sparsity > ret = casadi::gradFOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFOut" ===============
// cppName: "casadi::gradFOut"
// cWrapperName: "gradFOut__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* gradFOut__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::gradFOut(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* gradFOut__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* gradFOut__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::gradFOut(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFOut" ===============
// cppName: "casadi::gradFOut"
// cWrapperName: "gradFOut__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* gradFOut__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::gradFOut(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* gradFOut__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* gradFOut__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::gradFOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFOut" ===============
// cppName: "casadi::gradFOut"
// cWrapperName: "gradFOut__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* gradFOut__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::gradFOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::DMatrix* >* gradFOut__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::DMatrix* >* gradFOut__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::DMatrix > ret = casadi::gradFOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFOut" ===============
// cppName: "casadi::gradFOut"
// cWrapperName: "gradFOut__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* gradFOut__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::gradFOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::DMatrix* >* gradFOut__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::DMatrix* >* gradFOut__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::DMatrix > ret = casadi::gradFOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFOut" ===============
// cppName: "casadi::gradFOut"
// cWrapperName: "gradFOut__8"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* gradFOut__8(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::gradFOut(x0_)"
extern "C"
std::vector< casadi::MX* >* gradFOut__8(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* gradFOut__8(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::gradFOut(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFOut" ===============
// cppName: "casadi::gradFOut"
// cWrapperName: "gradFOut__9"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* gradFOut__9(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::gradFOut(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* gradFOut__9(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* gradFOut__9(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::gradFOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFOut" ===============
// cppName: "casadi::gradFOut"
// cWrapperName: "gradFOut__10"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* gradFOut__10(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::gradFOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >* gradFOut__10(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::MX* >* gradFOut__10(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::MX > ret = casadi::gradFOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFOut" ===============
// cppName: "casadi::gradFOut"
// cWrapperName: "gradFOut__11"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* gradFOut__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::gradFOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::MX* >* gradFOut__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::MX* >* gradFOut__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::MX > ret = casadi::gradFOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFOut" ===============
// cppName: "casadi::gradFOut"
// cWrapperName: "gradFOut__12"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* gradFOut__12(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::gradFOut(x0_)"
extern "C"
std::vector< casadi::SX* >* gradFOut__12(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* gradFOut__12(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::gradFOut(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFOut" ===============
// cppName: "casadi::gradFOut"
// cWrapperName: "gradFOut__13"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* gradFOut__13(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::gradFOut(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* gradFOut__13(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* gradFOut__13(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::gradFOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFOut" ===============
// cppName: "casadi::gradFOut"
// cWrapperName: "gradFOut__14"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* gradFOut__14(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::gradFOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::SX* >* gradFOut__14(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::SX* >* gradFOut__14(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::SX > ret = casadi::gradFOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradFOut" ===============
// cppName: "casadi::gradFOut"
// cWrapperName: "gradFOut__15"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* gradFOut__15(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::gradFOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::SX* >* gradFOut__15(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::SX* >* gradFOut__15(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::SX > ret = casadi::gradFOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradient" ===============
// cppName: "casadi::gradient"
// cWrapperName: "gradient__0"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX* gradient__0(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// call: "casadi::gradient(x0_, x1_)"
extern "C"
casadi::MX* gradient__0(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
casadi::MX* gradient__0(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX x0_ = Marshaling<casadi::MX,casadi::MX*>::marshal(x0);
        casadi::MX x1_ = Marshaling<casadi::MX,casadi::MX*>::marshal(x1);

        casadi::MX ret = casadi::gradient(x0_, x1_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::gradient" ===============
// cppName: "casadi::gradient"
// cWrapperName: "gradient__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX* gradient__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// call: "casadi::gradient(x0_, x1_)"
extern "C"
casadi::SX* gradient__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX* gradient__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);
        casadi::SX x1_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x1);

        casadi::SX ret = casadi::gradient(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::graph_substitute" ===============
// cppName: "casadi::graph_substitute"
// cWrapperName: "graph_substitute__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* graph_substitute__0(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2)"
// call: "casadi::graph_substitute(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >* graph_substitute__0(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2);
std::vector< casadi::MX* >* graph_substitute__0(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::vector< casadi::MX > x1_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x1);
        std::vector< casadi::MX > x2_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x2);

        std::vector< casadi::MX > ret = casadi::graph_substitute(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::graph_substitute" ===============
// cppName: "casadi::graph_substitute"
// cWrapperName: "graph_substitute__1"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX* graph_substitute__1(std::string ** err_msg, casadi::MX* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2)"
// call: "casadi::graph_substitute(x0_, x1_, x2_)"
extern "C"
casadi::MX* graph_substitute__1(std::string ** err_msg, casadi::MX* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2);
casadi::MX* graph_substitute__1(std::string ** err_msg, casadi::MX* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2){
    try {
        casadi::MX x0_ = Marshaling<casadi::MX,casadi::MX*>::marshal(x0);
        std::vector< casadi::MX > x1_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x1);
        std::vector< casadi::MX > x2_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x2);

        casadi::MX ret = casadi::graph_substitute(x0_, x1_, x2_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::heaviside" ===============
// cppName: "casadi::heaviside"
// cWrapperName: "heaviside"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX* heaviside(std::string ** err_msg, casadi::SX* x0)"
// call: "casadi::heaviside(x0_)"
extern "C"
casadi::SX* heaviside(std::string ** err_msg, casadi::SX* x0);
casadi::SX* heaviside(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);

        casadi::SX ret = casadi::heaviside(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* hessLagIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::hessLagIn(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* hessLagIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* hessLagIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::hessLagIn(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* hessLagIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::hessLagIn(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* hessLagIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* hessLagIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::hessLagIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* hessLagIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::hessLagIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* hessLagIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* hessLagIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::hessLagIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* hessLagIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::hessLagIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::Sparsity* >* hessLagIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::Sparsity* >* hessLagIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::Sparsity > ret = casadi::hessLagIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* hessLagIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::hessLagIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::Sparsity* >* hessLagIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::Sparsity* >* hessLagIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::Sparsity > ret = casadi::hessLagIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* hessLagIn__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::hessLagIn(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* hessLagIn__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* hessLagIn__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::hessLagIn(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* hessLagIn__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::hessLagIn(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* hessLagIn__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* hessLagIn__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::hessLagIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* hessLagIn__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::hessLagIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::DMatrix* >* hessLagIn__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::DMatrix* >* hessLagIn__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::DMatrix > ret = casadi::hessLagIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__8"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* hessLagIn__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::hessLagIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::DMatrix* >* hessLagIn__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::DMatrix* >* hessLagIn__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::DMatrix > ret = casadi::hessLagIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__9"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* hessLagIn__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::hessLagIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::DMatrix* >* hessLagIn__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::DMatrix* >* hessLagIn__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::DMatrix > ret = casadi::hessLagIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__10"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* hessLagIn__10(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::hessLagIn(x0_)"
extern "C"
std::vector< casadi::MX* >* hessLagIn__10(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* hessLagIn__10(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::hessLagIn(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__11"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* hessLagIn__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::hessLagIn(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* hessLagIn__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* hessLagIn__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::hessLagIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__12"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* hessLagIn__12(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::hessLagIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >* hessLagIn__12(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::MX* >* hessLagIn__12(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::MX > ret = casadi::hessLagIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__13"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* hessLagIn__13(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::hessLagIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::MX* >* hessLagIn__13(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::MX* >* hessLagIn__13(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::MX > ret = casadi::hessLagIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__14"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* hessLagIn__14(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::hessLagIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::MX* >* hessLagIn__14(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::MX* >* hessLagIn__14(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::MX > ret = casadi::hessLagIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__15"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* hessLagIn__15(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::hessLagIn(x0_)"
extern "C"
std::vector< casadi::SX* >* hessLagIn__15(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* hessLagIn__15(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::hessLagIn(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__16"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* hessLagIn__16(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::hessLagIn(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* hessLagIn__16(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* hessLagIn__16(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::hessLagIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__17"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* hessLagIn__17(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::hessLagIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::SX* >* hessLagIn__17(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::SX* >* hessLagIn__17(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::SX > ret = casadi::hessLagIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__18"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* hessLagIn__18(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::hessLagIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::SX* >* hessLagIn__18(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::SX* >* hessLagIn__18(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::SX > ret = casadi::hessLagIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagIn" ===============
// cppName: "casadi::hessLagIn"
// cWrapperName: "hessLagIn__19"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* hessLagIn__19(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::hessLagIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::SX* >* hessLagIn__19(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::SX* >* hessLagIn__19(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::SX > ret = casadi::hessLagIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* hessLagOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::hessLagOut(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* hessLagOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* hessLagOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::hessLagOut(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* hessLagOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::hessLagOut(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* hessLagOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* hessLagOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::hessLagOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* hessLagOut__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::hessLagOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* hessLagOut__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* hessLagOut__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::hessLagOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* hessLagOut__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::hessLagOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::Sparsity* >* hessLagOut__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::Sparsity* >* hessLagOut__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::Sparsity > ret = casadi::hessLagOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* hessLagOut__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::Sparsity* >* hessLagOut__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::Sparsity* >* hessLagOut__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::Sparsity > ret = casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* hessLagOut__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::Sparsity* >* hessLagOut__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::Sparsity* >* hessLagOut__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::Sparsity > ret = casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* hessLagOut__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::hessLagOut(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* hessLagOut__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* hessLagOut__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::hessLagOut(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* hessLagOut__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::hessLagOut(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* hessLagOut__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* hessLagOut__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::hessLagOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__8"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* hessLagOut__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::hessLagOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::DMatrix* >* hessLagOut__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::DMatrix* >* hessLagOut__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::DMatrix > ret = casadi::hessLagOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__9"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* hessLagOut__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::hessLagOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::DMatrix* >* hessLagOut__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::DMatrix* >* hessLagOut__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::DMatrix > ret = casadi::hessLagOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__10"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* hessLagOut__10(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::DMatrix* >* hessLagOut__10(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::DMatrix* >* hessLagOut__10(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::DMatrix > ret = casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__11"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* hessLagOut__11(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::DMatrix* >* hessLagOut__11(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::DMatrix* >* hessLagOut__11(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::DMatrix > ret = casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__12"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* hessLagOut__12(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::hessLagOut(x0_)"
extern "C"
std::vector< casadi::MX* >* hessLagOut__12(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* hessLagOut__12(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::hessLagOut(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__13"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* hessLagOut__13(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::hessLagOut(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* hessLagOut__13(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* hessLagOut__13(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::hessLagOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__14"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* hessLagOut__14(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::hessLagOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >* hessLagOut__14(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::MX* >* hessLagOut__14(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::MX > ret = casadi::hessLagOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__15"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* hessLagOut__15(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::hessLagOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::MX* >* hessLagOut__15(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::MX* >* hessLagOut__15(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::MX > ret = casadi::hessLagOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__16"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* hessLagOut__16(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::MX* >* hessLagOut__16(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::MX* >* hessLagOut__16(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::MX > ret = casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__17"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* hessLagOut__17(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::MX* >* hessLagOut__17(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::MX* >* hessLagOut__17(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::MX > ret = casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__18"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* hessLagOut__18(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::hessLagOut(x0_)"
extern "C"
std::vector< casadi::SX* >* hessLagOut__18(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* hessLagOut__18(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::hessLagOut(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__19"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* hessLagOut__19(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::hessLagOut(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* hessLagOut__19(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* hessLagOut__19(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::hessLagOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__20"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* hessLagOut__20(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::hessLagOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::SX* >* hessLagOut__20(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::SX* >* hessLagOut__20(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::SX > ret = casadi::hessLagOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__21"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* hessLagOut__21(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::hessLagOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::SX* >* hessLagOut__21(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::SX* >* hessLagOut__21(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::SX > ret = casadi::hessLagOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__22"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* hessLagOut__22(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::SX* >* hessLagOut__22(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::SX* >* hessLagOut__22(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::SX > ret = casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessLagOut" ===============
// cppName: "casadi::hessLagOut"
// cWrapperName: "hessLagOut__23"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* hessLagOut__23(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::SX* >* hessLagOut__23(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::SX* >* hessLagOut__23(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::SX > ret = casadi::hessLagOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hessian" ===============
// cppName: "casadi::hessian"
// cWrapperName: "hessian__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, casadi::SX* x3)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (UserType (Namespace ["casadi"]) (Name "SX")),Ref (UserType (Namespace ["casadi"]) (Name "SX"))]
// retType: CVoid
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "void"
// proto: "void hessian__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, casadi::SX* x3)"
// call: "casadi::hessian(x0_, x1_, x2_, x3_)"
extern "C"
void hessian__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, casadi::SX* x3);
void hessian__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, casadi::SX* x3){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);
        casadi::SX x1_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x1);
        casadi::SX x2_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x2);
        casadi::SX x3_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x3);

        casadi::hessian(x0_, x1_, x2_, x3_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::hessian" ===============
// cppName: "casadi::hessian"
// cWrapperName: "hessian__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX* hessian__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// call: "casadi::hessian(x0_, x1_)"
extern "C"
casadi::SX* hessian__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX* hessian__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);
        casadi::SX x1_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x1);

        casadi::SX ret = casadi::hessian(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hnlpIn" ===============
// cppName: "casadi::hnlpIn"
// cWrapperName: "hnlpIn__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* hnlpIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::hnlpIn(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* hnlpIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* hnlpIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::hnlpIn(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hnlpIn" ===============
// cppName: "casadi::hnlpIn"
// cWrapperName: "hnlpIn__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* hnlpIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::hnlpIn(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* hnlpIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* hnlpIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::hnlpIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hnlpIn" ===============
// cppName: "casadi::hnlpIn"
// cWrapperName: "hnlpIn__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* hnlpIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::hnlpIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* hnlpIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* hnlpIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::hnlpIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hnlpIn" ===============
// cppName: "casadi::hnlpIn"
// cWrapperName: "hnlpIn__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* hnlpIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::hnlpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::Sparsity* >* hnlpIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::Sparsity* >* hnlpIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::Sparsity > ret = casadi::hnlpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hnlpIn" ===============
// cppName: "casadi::hnlpIn"
// cWrapperName: "hnlpIn__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* hnlpIn__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::hnlpIn(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* hnlpIn__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* hnlpIn__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::hnlpIn(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hnlpIn" ===============
// cppName: "casadi::hnlpIn"
// cWrapperName: "hnlpIn__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* hnlpIn__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::hnlpIn(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* hnlpIn__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* hnlpIn__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::hnlpIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hnlpIn" ===============
// cppName: "casadi::hnlpIn"
// cWrapperName: "hnlpIn__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* hnlpIn__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::hnlpIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::DMatrix* >* hnlpIn__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::DMatrix* >* hnlpIn__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::DMatrix > ret = casadi::hnlpIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hnlpIn" ===============
// cppName: "casadi::hnlpIn"
// cWrapperName: "hnlpIn__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* hnlpIn__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::hnlpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::DMatrix* >* hnlpIn__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::DMatrix* >* hnlpIn__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::DMatrix > ret = casadi::hnlpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hnlpIn" ===============
// cppName: "casadi::hnlpIn"
// cWrapperName: "hnlpIn__8"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* hnlpIn__8(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::hnlpIn(x0_)"
extern "C"
std::vector< casadi::MX* >* hnlpIn__8(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* hnlpIn__8(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::hnlpIn(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hnlpIn" ===============
// cppName: "casadi::hnlpIn"
// cWrapperName: "hnlpIn__9"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* hnlpIn__9(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::hnlpIn(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* hnlpIn__9(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* hnlpIn__9(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::hnlpIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hnlpIn" ===============
// cppName: "casadi::hnlpIn"
// cWrapperName: "hnlpIn__10"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* hnlpIn__10(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::hnlpIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >* hnlpIn__10(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::MX* >* hnlpIn__10(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::MX > ret = casadi::hnlpIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hnlpIn" ===============
// cppName: "casadi::hnlpIn"
// cWrapperName: "hnlpIn__11"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* hnlpIn__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::hnlpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::MX* >* hnlpIn__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::MX* >* hnlpIn__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::MX > ret = casadi::hnlpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hnlpIn" ===============
// cppName: "casadi::hnlpIn"
// cWrapperName: "hnlpIn__12"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* hnlpIn__12(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::hnlpIn(x0_)"
extern "C"
std::vector< casadi::SX* >* hnlpIn__12(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* hnlpIn__12(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::hnlpIn(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hnlpIn" ===============
// cppName: "casadi::hnlpIn"
// cWrapperName: "hnlpIn__13"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* hnlpIn__13(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::hnlpIn(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* hnlpIn__13(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* hnlpIn__13(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::hnlpIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hnlpIn" ===============
// cppName: "casadi::hnlpIn"
// cWrapperName: "hnlpIn__14"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* hnlpIn__14(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::hnlpIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::SX* >* hnlpIn__14(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::SX* >* hnlpIn__14(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::SX > ret = casadi::hnlpIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::hnlpIn" ===============
// cppName: "casadi::hnlpIn"
// cWrapperName: "hnlpIn__15"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* hnlpIn__15(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::hnlpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::SX* >* hnlpIn__15(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::SX* >* hnlpIn__15(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::SX > ret = casadi::hnlpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::if_else" ===============
// cppName: "casadi::if_else"
// cWrapperName: "if_else__0"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, casadi::MX* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX* if_else__0(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, casadi::MX* x2)"
// call: "casadi::if_else(x0_, x1_, x2_)"
extern "C"
casadi::MX* if_else__0(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, casadi::MX* x2);
casadi::MX* if_else__0(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, casadi::MX* x2){
    try {
        casadi::MX x0_ = Marshaling<casadi::MX,casadi::MX*>::marshal(x0);
        casadi::MX x1_ = Marshaling<casadi::MX,casadi::MX*>::marshal(x1);
        casadi::MX x2_ = Marshaling<casadi::MX,casadi::MX*>::marshal(x2);

        casadi::MX ret = casadi::if_else(x0_, x1_, x2_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::if_else" ===============
// cppName: "casadi::if_else"
// cWrapperName: "if_else__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX* if_else__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2)"
// call: "casadi::if_else(x0_, x1_, x2_)"
extern "C"
casadi::SX* if_else__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2);
casadi::SX* if_else__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);
        casadi::SX x1_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x1);
        casadi::SX x2_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x2);

        casadi::SX ret = casadi::if_else(x0_, x1_, x2_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::implicitRK" ===============
// cppName: "casadi::implicitRK"
// cWrapperName: "implicitRK"
// protoArgs: "(std::string ** err_msg, casadi::Function* x0, std::string* x1)"
// params: [Ref (UserType (Namespace ["casadi"]) (Name "Function")),Ref (Const StdString)]
// retType: UserType (Namespace ["casadi"]) (Name "Function")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::Function*"
// proto: "casadi::Function* implicitRK(std::string ** err_msg, casadi::Function* x0, std::string* x1)"
// call: "casadi::implicitRK(x0_, x1_)"
extern "C"
casadi::Function* implicitRK(std::string ** err_msg, casadi::Function* x0, std::string* x1);
casadi::Function* implicitRK(std::string ** err_msg, casadi::Function* x0, std::string* x1){
    try {
        casadi::Function x0_ = Marshaling<casadi::Function,casadi::Function*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        casadi::Function ret = casadi::implicitRK(x0_, x1_);
        return WrapReturn< casadi::Function*, casadi::Function >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* integratorIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::integratorIn(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* integratorIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* integratorIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::integratorIn(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* integratorIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::integratorIn(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* integratorIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* integratorIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::integratorIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* integratorIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::integratorIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* integratorIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* integratorIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::integratorIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* integratorIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::Sparsity* >* integratorIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::Sparsity* >* integratorIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::Sparsity > ret = casadi::integratorIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* integratorIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::Sparsity* >* integratorIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::Sparsity* >* integratorIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::Sparsity > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* integratorIn__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::Sparsity* >* integratorIn__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::Sparsity* >* integratorIn__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::Sparsity > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* integratorIn__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::Sparsity* >* integratorIn__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::Sparsity* >* integratorIn__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::Sparsity > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* integratorIn__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::integratorIn(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* integratorIn__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* integratorIn__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::integratorIn(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__8"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* integratorIn__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::integratorIn(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* integratorIn__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* integratorIn__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::integratorIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__9"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* integratorIn__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::integratorIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::DMatrix* >* integratorIn__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::DMatrix* >* integratorIn__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::DMatrix > ret = casadi::integratorIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__10"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* integratorIn__10(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::DMatrix* >* integratorIn__10(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::DMatrix* >* integratorIn__10(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::DMatrix > ret = casadi::integratorIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__11"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* integratorIn__11(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::DMatrix* >* integratorIn__11(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::DMatrix* >* integratorIn__11(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::DMatrix > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__12"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* integratorIn__12(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::DMatrix* >* integratorIn__12(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::DMatrix* >* integratorIn__12(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::DMatrix > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__13"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* integratorIn__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::DMatrix* >* integratorIn__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::DMatrix* >* integratorIn__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::DMatrix > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__14"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* integratorIn__14(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::integratorIn(x0_)"
extern "C"
std::vector< casadi::MX* >* integratorIn__14(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* integratorIn__14(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::integratorIn(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__15"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* integratorIn__15(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::integratorIn(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* integratorIn__15(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* integratorIn__15(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::integratorIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__16"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* integratorIn__16(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::integratorIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >* integratorIn__16(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::MX* >* integratorIn__16(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::MX > ret = casadi::integratorIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__17"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* integratorIn__17(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::MX* >* integratorIn__17(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::MX* >* integratorIn__17(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::MX > ret = casadi::integratorIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__18"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* integratorIn__18(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::MX* >* integratorIn__18(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::MX* >* integratorIn__18(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::MX > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__19"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* integratorIn__19(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::MX* >* integratorIn__19(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::MX* >* integratorIn__19(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::MX > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__20"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* integratorIn__20(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::MX* >* integratorIn__20(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::MX* >* integratorIn__20(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::MX > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__21"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* integratorIn__21(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::integratorIn(x0_)"
extern "C"
std::vector< casadi::SX* >* integratorIn__21(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* integratorIn__21(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::integratorIn(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__22"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* integratorIn__22(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::integratorIn(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* integratorIn__22(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* integratorIn__22(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::integratorIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__23"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* integratorIn__23(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::integratorIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::SX* >* integratorIn__23(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::SX* >* integratorIn__23(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::SX > ret = casadi::integratorIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__24"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* integratorIn__24(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::SX* >* integratorIn__24(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::SX* >* integratorIn__24(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::SX > ret = casadi::integratorIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__25"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* integratorIn__25(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::SX* >* integratorIn__25(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::SX* >* integratorIn__25(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::SX > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__26"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* integratorIn__26(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::SX* >* integratorIn__26(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::SX* >* integratorIn__26(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::SX > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorIn" ===============
// cppName: "casadi::integratorIn"
// cWrapperName: "integratorIn__27"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* integratorIn__27(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::SX* >* integratorIn__27(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::SX* >* integratorIn__27(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::SX > ret = casadi::integratorIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* integratorOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::integratorOut(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* integratorOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* integratorOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::integratorOut(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* integratorOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::integratorOut(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* integratorOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* integratorOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::integratorOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* integratorOut__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::integratorOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* integratorOut__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* integratorOut__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::integratorOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* integratorOut__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::Sparsity* >* integratorOut__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::Sparsity* >* integratorOut__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::Sparsity > ret = casadi::integratorOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* integratorOut__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::Sparsity* >* integratorOut__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::Sparsity* >* integratorOut__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::Sparsity > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* integratorOut__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::Sparsity* >* integratorOut__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::Sparsity* >* integratorOut__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::Sparsity > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* integratorOut__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::Sparsity* >* integratorOut__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::Sparsity* >* integratorOut__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::Sparsity > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* integratorOut__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::integratorOut(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* integratorOut__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* integratorOut__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::integratorOut(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__8"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* integratorOut__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::integratorOut(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* integratorOut__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* integratorOut__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::integratorOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__9"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* integratorOut__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::integratorOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::DMatrix* >* integratorOut__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::DMatrix* >* integratorOut__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::DMatrix > ret = casadi::integratorOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__10"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* integratorOut__10(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::DMatrix* >* integratorOut__10(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::DMatrix* >* integratorOut__10(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::DMatrix > ret = casadi::integratorOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__11"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* integratorOut__11(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::DMatrix* >* integratorOut__11(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::DMatrix* >* integratorOut__11(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::DMatrix > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__12"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* integratorOut__12(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::DMatrix* >* integratorOut__12(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::DMatrix* >* integratorOut__12(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::DMatrix > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__13"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* integratorOut__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::DMatrix* >* integratorOut__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::DMatrix* >* integratorOut__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::DMatrix > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__14"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* integratorOut__14(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::integratorOut(x0_)"
extern "C"
std::vector< casadi::MX* >* integratorOut__14(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* integratorOut__14(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::integratorOut(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__15"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* integratorOut__15(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::integratorOut(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* integratorOut__15(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* integratorOut__15(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::integratorOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__16"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* integratorOut__16(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::integratorOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >* integratorOut__16(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::MX* >* integratorOut__16(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::MX > ret = casadi::integratorOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__17"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* integratorOut__17(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::MX* >* integratorOut__17(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::MX* >* integratorOut__17(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::MX > ret = casadi::integratorOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__18"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* integratorOut__18(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::MX* >* integratorOut__18(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::MX* >* integratorOut__18(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::MX > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__19"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* integratorOut__19(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::MX* >* integratorOut__19(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::MX* >* integratorOut__19(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::MX > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__20"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* integratorOut__20(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::MX* >* integratorOut__20(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::MX* >* integratorOut__20(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::MX > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__21"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* integratorOut__21(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::integratorOut(x0_)"
extern "C"
std::vector< casadi::SX* >* integratorOut__21(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* integratorOut__21(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::integratorOut(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__22"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* integratorOut__22(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::integratorOut(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* integratorOut__22(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* integratorOut__22(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::integratorOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__23"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* integratorOut__23(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::integratorOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::SX* >* integratorOut__23(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::SX* >* integratorOut__23(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::SX > ret = casadi::integratorOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__24"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* integratorOut__24(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::SX* >* integratorOut__24(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::SX* >* integratorOut__24(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::SX > ret = casadi::integratorOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__25"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* integratorOut__25(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::SX* >* integratorOut__25(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::SX* >* integratorOut__25(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::SX > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__26"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* integratorOut__26(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::SX* >* integratorOut__26(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::SX* >* integratorOut__26(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::SX > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::integratorOut" ===============
// cppName: "casadi::integratorOut"
// cWrapperName: "integratorOut__27"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* integratorOut__27(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::SX* >* integratorOut__27(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::SX* >* integratorOut__27(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::SX > ret = casadi::integratorOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::isDecreasing" ===============
// cppName: "casadi::isDecreasing"
// cWrapperName: "isDecreasing__0"
// protoArgs: "(std::string ** err_msg, std::vector< double >* x0)"
// params: [Ref (Const (StdVec CDouble))]
// retType: CBool
// args: "(x0_)"
// cWrapperRetType: "int"
// proto: "int isDecreasing__0(std::string ** err_msg, std::vector< double >* x0)"
// call: "casadi::isDecreasing(x0_)"
extern "C"
int isDecreasing__0(std::string ** err_msg, std::vector< double >* x0);
int isDecreasing__0(std::string ** err_msg, std::vector< double >* x0){
    try {
        std::vector< double > x0_ = Marshaling<std::vector< double >,std::vector< double >*>::marshal(x0);

        bool ret = casadi::isDecreasing(x0_);
        return WrapReturn< int, bool >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::isDecreasing" ===============
// cppName: "casadi::isDecreasing"
// cWrapperName: "isDecreasing__1"
// protoArgs: "(std::string ** err_msg, std::vector< int >* x0)"
// params: [Ref (Const (StdVec CInt))]
// retType: CBool
// args: "(x0_)"
// cWrapperRetType: "int"
// proto: "int isDecreasing__1(std::string ** err_msg, std::vector< int >* x0)"
// call: "casadi::isDecreasing(x0_)"
extern "C"
int isDecreasing__1(std::string ** err_msg, std::vector< int >* x0);
int isDecreasing__1(std::string ** err_msg, std::vector< int >* x0){
    try {
        std::vector< int > x0_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x0);

        bool ret = casadi::isDecreasing(x0_);
        return WrapReturn< int, bool >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::isIncreasing" ===============
// cppName: "casadi::isIncreasing"
// cWrapperName: "isIncreasing__0"
// protoArgs: "(std::string ** err_msg, std::vector< double >* x0)"
// params: [Ref (Const (StdVec CDouble))]
// retType: CBool
// args: "(x0_)"
// cWrapperRetType: "int"
// proto: "int isIncreasing__0(std::string ** err_msg, std::vector< double >* x0)"
// call: "casadi::isIncreasing(x0_)"
extern "C"
int isIncreasing__0(std::string ** err_msg, std::vector< double >* x0);
int isIncreasing__0(std::string ** err_msg, std::vector< double >* x0){
    try {
        std::vector< double > x0_ = Marshaling<std::vector< double >,std::vector< double >*>::marshal(x0);

        bool ret = casadi::isIncreasing(x0_);
        return WrapReturn< int, bool >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::isIncreasing" ===============
// cppName: "casadi::isIncreasing"
// cWrapperName: "isIncreasing__1"
// protoArgs: "(std::string ** err_msg, std::vector< int >* x0)"
// params: [Ref (Const (StdVec CInt))]
// retType: CBool
// args: "(x0_)"
// cWrapperRetType: "int"
// proto: "int isIncreasing__1(std::string ** err_msg, std::vector< int >* x0)"
// call: "casadi::isIncreasing(x0_)"
extern "C"
int isIncreasing__1(std::string ** err_msg, std::vector< int >* x0);
int isIncreasing__1(std::string ** err_msg, std::vector< int >* x0){
    try {
        std::vector< int > x0_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x0);

        bool ret = casadi::isIncreasing(x0_);
        return WrapReturn< int, bool >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::isMonotone" ===============
// cppName: "casadi::isMonotone"
// cWrapperName: "isMonotone__0"
// protoArgs: "(std::string ** err_msg, std::vector< double >* x0)"
// params: [Ref (Const (StdVec CDouble))]
// retType: CBool
// args: "(x0_)"
// cWrapperRetType: "int"
// proto: "int isMonotone__0(std::string ** err_msg, std::vector< double >* x0)"
// call: "casadi::isMonotone(x0_)"
extern "C"
int isMonotone__0(std::string ** err_msg, std::vector< double >* x0);
int isMonotone__0(std::string ** err_msg, std::vector< double >* x0){
    try {
        std::vector< double > x0_ = Marshaling<std::vector< double >,std::vector< double >*>::marshal(x0);

        bool ret = casadi::isMonotone(x0_);
        return WrapReturn< int, bool >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::isMonotone" ===============
// cppName: "casadi::isMonotone"
// cWrapperName: "isMonotone__1"
// protoArgs: "(std::string ** err_msg, std::vector< int >* x0)"
// params: [Ref (Const (StdVec CInt))]
// retType: CBool
// args: "(x0_)"
// cWrapperRetType: "int"
// proto: "int isMonotone__1(std::string ** err_msg, std::vector< int >* x0)"
// call: "casadi::isMonotone(x0_)"
extern "C"
int isMonotone__1(std::string ** err_msg, std::vector< int >* x0);
int isMonotone__1(std::string ** err_msg, std::vector< int >* x0){
    try {
        std::vector< int > x0_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x0);

        bool ret = casadi::isMonotone(x0_);
        return WrapReturn< int, bool >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::isNonDecreasing" ===============
// cppName: "casadi::isNonDecreasing"
// cWrapperName: "isNonDecreasing__0"
// protoArgs: "(std::string ** err_msg, std::vector< double >* x0)"
// params: [Ref (Const (StdVec CDouble))]
// retType: CBool
// args: "(x0_)"
// cWrapperRetType: "int"
// proto: "int isNonDecreasing__0(std::string ** err_msg, std::vector< double >* x0)"
// call: "casadi::isNonDecreasing(x0_)"
extern "C"
int isNonDecreasing__0(std::string ** err_msg, std::vector< double >* x0);
int isNonDecreasing__0(std::string ** err_msg, std::vector< double >* x0){
    try {
        std::vector< double > x0_ = Marshaling<std::vector< double >,std::vector< double >*>::marshal(x0);

        bool ret = casadi::isNonDecreasing(x0_);
        return WrapReturn< int, bool >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::isNonDecreasing" ===============
// cppName: "casadi::isNonDecreasing"
// cWrapperName: "isNonDecreasing__1"
// protoArgs: "(std::string ** err_msg, std::vector< int >* x0)"
// params: [Ref (Const (StdVec CInt))]
// retType: CBool
// args: "(x0_)"
// cWrapperRetType: "int"
// proto: "int isNonDecreasing__1(std::string ** err_msg, std::vector< int >* x0)"
// call: "casadi::isNonDecreasing(x0_)"
extern "C"
int isNonDecreasing__1(std::string ** err_msg, std::vector< int >* x0);
int isNonDecreasing__1(std::string ** err_msg, std::vector< int >* x0){
    try {
        std::vector< int > x0_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x0);

        bool ret = casadi::isNonDecreasing(x0_);
        return WrapReturn< int, bool >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::isNonIncreasing" ===============
// cppName: "casadi::isNonIncreasing"
// cWrapperName: "isNonIncreasing__0"
// protoArgs: "(std::string ** err_msg, std::vector< double >* x0)"
// params: [Ref (Const (StdVec CDouble))]
// retType: CBool
// args: "(x0_)"
// cWrapperRetType: "int"
// proto: "int isNonIncreasing__0(std::string ** err_msg, std::vector< double >* x0)"
// call: "casadi::isNonIncreasing(x0_)"
extern "C"
int isNonIncreasing__0(std::string ** err_msg, std::vector< double >* x0);
int isNonIncreasing__0(std::string ** err_msg, std::vector< double >* x0){
    try {
        std::vector< double > x0_ = Marshaling<std::vector< double >,std::vector< double >*>::marshal(x0);

        bool ret = casadi::isNonIncreasing(x0_);
        return WrapReturn< int, bool >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::isNonIncreasing" ===============
// cppName: "casadi::isNonIncreasing"
// cWrapperName: "isNonIncreasing__1"
// protoArgs: "(std::string ** err_msg, std::vector< int >* x0)"
// params: [Ref (Const (StdVec CInt))]
// retType: CBool
// args: "(x0_)"
// cWrapperRetType: "int"
// proto: "int isNonIncreasing__1(std::string ** err_msg, std::vector< int >* x0)"
// call: "casadi::isNonIncreasing(x0_)"
extern "C"
int isNonIncreasing__1(std::string ** err_msg, std::vector< int >* x0);
int isNonIncreasing__1(std::string ** err_msg, std::vector< int >* x0){
    try {
        std::vector< int > x0_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x0);

        bool ret = casadi::isNonIncreasing(x0_);
        return WrapReturn< int, bool >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::isRegular" ===============
// cppName: "casadi::isRegular"
// cWrapperName: "isRegular__0"
// protoArgs: "(std::string ** err_msg, std::vector< double >* x0)"
// params: [Ref (Const (StdVec CDouble))]
// retType: CBool
// args: "(x0_)"
// cWrapperRetType: "int"
// proto: "int isRegular__0(std::string ** err_msg, std::vector< double >* x0)"
// call: "casadi::isRegular(x0_)"
extern "C"
int isRegular__0(std::string ** err_msg, std::vector< double >* x0);
int isRegular__0(std::string ** err_msg, std::vector< double >* x0){
    try {
        std::vector< double > x0_ = Marshaling<std::vector< double >,std::vector< double >*>::marshal(x0);

        bool ret = casadi::isRegular(x0_);
        return WrapReturn< int, bool >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::isRegular" ===============
// cppName: "casadi::isRegular"
// cWrapperName: "isRegular__1"
// protoArgs: "(std::string ** err_msg, std::vector< int >* x0)"
// params: [Ref (Const (StdVec CInt))]
// retType: CBool
// args: "(x0_)"
// cWrapperRetType: "int"
// proto: "int isRegular__1(std::string ** err_msg, std::vector< int >* x0)"
// call: "casadi::isRegular(x0_)"
extern "C"
int isRegular__1(std::string ** err_msg, std::vector< int >* x0);
int isRegular__1(std::string ** err_msg, std::vector< int >* x0){
    try {
        std::vector< int > x0_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x0);

        bool ret = casadi::isRegular(x0_);
        return WrapReturn< int, bool >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::isStrictlyMonotone" ===============
// cppName: "casadi::isStrictlyMonotone"
// cWrapperName: "isStrictlyMonotone__0"
// protoArgs: "(std::string ** err_msg, std::vector< double >* x0)"
// params: [Ref (Const (StdVec CDouble))]
// retType: CBool
// args: "(x0_)"
// cWrapperRetType: "int"
// proto: "int isStrictlyMonotone__0(std::string ** err_msg, std::vector< double >* x0)"
// call: "casadi::isStrictlyMonotone(x0_)"
extern "C"
int isStrictlyMonotone__0(std::string ** err_msg, std::vector< double >* x0);
int isStrictlyMonotone__0(std::string ** err_msg, std::vector< double >* x0){
    try {
        std::vector< double > x0_ = Marshaling<std::vector< double >,std::vector< double >*>::marshal(x0);

        bool ret = casadi::isStrictlyMonotone(x0_);
        return WrapReturn< int, bool >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::isStrictlyMonotone" ===============
// cppName: "casadi::isStrictlyMonotone"
// cWrapperName: "isStrictlyMonotone__1"
// protoArgs: "(std::string ** err_msg, std::vector< int >* x0)"
// params: [Ref (Const (StdVec CInt))]
// retType: CBool
// args: "(x0_)"
// cWrapperRetType: "int"
// proto: "int isStrictlyMonotone__1(std::string ** err_msg, std::vector< int >* x0)"
// call: "casadi::isStrictlyMonotone(x0_)"
extern "C"
int isStrictlyMonotone__1(std::string ** err_msg, std::vector< int >* x0);
int isStrictlyMonotone__1(std::string ** err_msg, std::vector< int >* x0){
    try {
        std::vector< int > x0_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x0);

        bool ret = casadi::isStrictlyMonotone(x0_);
        return WrapReturn< int, bool >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGIn" ===============
// cppName: "casadi::jacGIn"
// cWrapperName: "jacGIn__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* jacGIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::jacGIn(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* jacGIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* jacGIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::jacGIn(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGIn" ===============
// cppName: "casadi::jacGIn"
// cWrapperName: "jacGIn__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* jacGIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::jacGIn(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* jacGIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* jacGIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::jacGIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGIn" ===============
// cppName: "casadi::jacGIn"
// cWrapperName: "jacGIn__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* jacGIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::jacGIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* jacGIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* jacGIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::jacGIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGIn" ===============
// cppName: "casadi::jacGIn"
// cWrapperName: "jacGIn__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* jacGIn__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::jacGIn(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* jacGIn__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* jacGIn__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::jacGIn(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGIn" ===============
// cppName: "casadi::jacGIn"
// cWrapperName: "jacGIn__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* jacGIn__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::jacGIn(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* jacGIn__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* jacGIn__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::jacGIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGIn" ===============
// cppName: "casadi::jacGIn"
// cWrapperName: "jacGIn__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* jacGIn__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::jacGIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::DMatrix* >* jacGIn__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::DMatrix* >* jacGIn__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::DMatrix > ret = casadi::jacGIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGIn" ===============
// cppName: "casadi::jacGIn"
// cWrapperName: "jacGIn__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* jacGIn__6(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::jacGIn(x0_)"
extern "C"
std::vector< casadi::MX* >* jacGIn__6(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* jacGIn__6(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::jacGIn(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGIn" ===============
// cppName: "casadi::jacGIn"
// cWrapperName: "jacGIn__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* jacGIn__7(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::jacGIn(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* jacGIn__7(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* jacGIn__7(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::jacGIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGIn" ===============
// cppName: "casadi::jacGIn"
// cWrapperName: "jacGIn__8"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* jacGIn__8(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::jacGIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >* jacGIn__8(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::MX* >* jacGIn__8(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::MX > ret = casadi::jacGIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGIn" ===============
// cppName: "casadi::jacGIn"
// cWrapperName: "jacGIn__9"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* jacGIn__9(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::jacGIn(x0_)"
extern "C"
std::vector< casadi::SX* >* jacGIn__9(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* jacGIn__9(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::jacGIn(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGIn" ===============
// cppName: "casadi::jacGIn"
// cWrapperName: "jacGIn__10"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* jacGIn__10(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::jacGIn(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* jacGIn__10(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* jacGIn__10(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::jacGIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGIn" ===============
// cppName: "casadi::jacGIn"
// cWrapperName: "jacGIn__11"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* jacGIn__11(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::jacGIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::SX* >* jacGIn__11(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::SX* >* jacGIn__11(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::SX > ret = casadi::jacGIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGOut" ===============
// cppName: "casadi::jacGOut"
// cWrapperName: "jacGOut__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* jacGOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::jacGOut(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* jacGOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* jacGOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::jacGOut(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGOut" ===============
// cppName: "casadi::jacGOut"
// cWrapperName: "jacGOut__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* jacGOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::jacGOut(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* jacGOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* jacGOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::jacGOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGOut" ===============
// cppName: "casadi::jacGOut"
// cWrapperName: "jacGOut__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* jacGOut__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::jacGOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* jacGOut__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* jacGOut__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::jacGOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGOut" ===============
// cppName: "casadi::jacGOut"
// cWrapperName: "jacGOut__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* jacGOut__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::jacGOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::Sparsity* >* jacGOut__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::Sparsity* >* jacGOut__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::Sparsity > ret = casadi::jacGOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGOut" ===============
// cppName: "casadi::jacGOut"
// cWrapperName: "jacGOut__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* jacGOut__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::jacGOut(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* jacGOut__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* jacGOut__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::jacGOut(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGOut" ===============
// cppName: "casadi::jacGOut"
// cWrapperName: "jacGOut__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* jacGOut__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::jacGOut(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* jacGOut__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* jacGOut__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::jacGOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGOut" ===============
// cppName: "casadi::jacGOut"
// cWrapperName: "jacGOut__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* jacGOut__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::jacGOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::DMatrix* >* jacGOut__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::DMatrix* >* jacGOut__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::DMatrix > ret = casadi::jacGOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGOut" ===============
// cppName: "casadi::jacGOut"
// cWrapperName: "jacGOut__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* jacGOut__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::jacGOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::DMatrix* >* jacGOut__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::DMatrix* >* jacGOut__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::DMatrix > ret = casadi::jacGOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGOut" ===============
// cppName: "casadi::jacGOut"
// cWrapperName: "jacGOut__8"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* jacGOut__8(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::jacGOut(x0_)"
extern "C"
std::vector< casadi::MX* >* jacGOut__8(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* jacGOut__8(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::jacGOut(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGOut" ===============
// cppName: "casadi::jacGOut"
// cWrapperName: "jacGOut__9"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* jacGOut__9(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::jacGOut(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* jacGOut__9(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* jacGOut__9(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::jacGOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGOut" ===============
// cppName: "casadi::jacGOut"
// cWrapperName: "jacGOut__10"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* jacGOut__10(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::jacGOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >* jacGOut__10(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::MX* >* jacGOut__10(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::MX > ret = casadi::jacGOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGOut" ===============
// cppName: "casadi::jacGOut"
// cWrapperName: "jacGOut__11"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* jacGOut__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::jacGOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::MX* >* jacGOut__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::MX* >* jacGOut__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::MX > ret = casadi::jacGOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGOut" ===============
// cppName: "casadi::jacGOut"
// cWrapperName: "jacGOut__12"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* jacGOut__12(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::jacGOut(x0_)"
extern "C"
std::vector< casadi::SX* >* jacGOut__12(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* jacGOut__12(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::jacGOut(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGOut" ===============
// cppName: "casadi::jacGOut"
// cWrapperName: "jacGOut__13"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* jacGOut__13(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::jacGOut(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* jacGOut__13(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* jacGOut__13(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::jacGOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGOut" ===============
// cppName: "casadi::jacGOut"
// cWrapperName: "jacGOut__14"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* jacGOut__14(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::jacGOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::SX* >* jacGOut__14(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::SX* >* jacGOut__14(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::SX > ret = casadi::jacGOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacGOut" ===============
// cppName: "casadi::jacGOut"
// cWrapperName: "jacGOut__15"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* jacGOut__15(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::jacGOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::SX* >* jacGOut__15(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::SX* >* jacGOut__15(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::SX > ret = casadi::jacGOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacobian" ===============
// cppName: "casadi::jacobian"
// cWrapperName: "jacobian__0"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX* jacobian__0(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// call: "casadi::jacobian(x0_, x1_)"
extern "C"
casadi::MX* jacobian__0(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
casadi::MX* jacobian__0(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX x0_ = Marshaling<casadi::MX,casadi::MX*>::marshal(x0);
        casadi::MX x1_ = Marshaling<casadi::MX,casadi::MX*>::marshal(x1);

        casadi::MX ret = casadi::jacobian(x0_, x1_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacobian" ===============
// cppName: "casadi::jacobian"
// cWrapperName: "jacobian__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX* jacobian__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// call: "casadi::jacobian(x0_, x1_)"
extern "C"
casadi::SX* jacobian__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX* jacobian__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);
        casadi::SX x1_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x1);

        casadi::SX ret = casadi::jacobian(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacobianTimesVector" ===============
// cppName: "casadi::jacobianTimesVector"
// cWrapperName: "jacobianTimesVector__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX* jacobianTimesVector__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2)"
// call: "casadi::jacobianTimesVector(x0_, x1_, x2_)"
extern "C"
casadi::SX* jacobianTimesVector__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2);
casadi::SX* jacobianTimesVector__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);
        casadi::SX x1_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x1);
        casadi::SX x2_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x2);

        casadi::SX ret = casadi::jacobianTimesVector(x0_, x1_, x2_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::jacobianTimesVector" ===============
// cppName: "casadi::jacobianTimesVector"
// cWrapperName: "jacobianTimesVector__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, int x3)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),CBool]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX* jacobianTimesVector__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, int x3)"
// call: "casadi::jacobianTimesVector(x0_, x1_, x2_, x3_)"
extern "C"
casadi::SX* jacobianTimesVector__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, int x3);
casadi::SX* jacobianTimesVector__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, int x3){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);
        casadi::SX x1_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x1);
        casadi::SX x2_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x2);
        bool x3_ = Marshaling<bool,int>::marshal(x3);

        casadi::SX ret = casadi::jacobianTimesVector(x0_, x1_, x2_, x3_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::linsolIn" ===============
// cppName: "casadi::linsolIn"
// cWrapperName: "linsolIn__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* linsolIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::linsolIn(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* linsolIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* linsolIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::linsolIn(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::linsolIn" ===============
// cppName: "casadi::linsolIn"
// cWrapperName: "linsolIn__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* linsolIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::linsolIn(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* linsolIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* linsolIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::linsolIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::linsolIn" ===============
// cppName: "casadi::linsolIn"
// cWrapperName: "linsolIn__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* linsolIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::linsolIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* linsolIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* linsolIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::linsolIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::linsolIn" ===============
// cppName: "casadi::linsolIn"
// cWrapperName: "linsolIn__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* linsolIn__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::linsolIn(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* linsolIn__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* linsolIn__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::linsolIn(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::linsolIn" ===============
// cppName: "casadi::linsolIn"
// cWrapperName: "linsolIn__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* linsolIn__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::linsolIn(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* linsolIn__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* linsolIn__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::linsolIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::linsolIn" ===============
// cppName: "casadi::linsolIn"
// cWrapperName: "linsolIn__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* linsolIn__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::linsolIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::DMatrix* >* linsolIn__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::DMatrix* >* linsolIn__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::DMatrix > ret = casadi::linsolIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::linsolIn" ===============
// cppName: "casadi::linsolIn"
// cWrapperName: "linsolIn__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* linsolIn__6(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::linsolIn(x0_)"
extern "C"
std::vector< casadi::MX* >* linsolIn__6(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* linsolIn__6(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::linsolIn(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::linsolIn" ===============
// cppName: "casadi::linsolIn"
// cWrapperName: "linsolIn__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* linsolIn__7(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::linsolIn(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* linsolIn__7(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* linsolIn__7(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::linsolIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::linsolIn" ===============
// cppName: "casadi::linsolIn"
// cWrapperName: "linsolIn__8"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* linsolIn__8(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::linsolIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >* linsolIn__8(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::MX* >* linsolIn__8(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::MX > ret = casadi::linsolIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::linsolIn" ===============
// cppName: "casadi::linsolIn"
// cWrapperName: "linsolIn__9"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* linsolIn__9(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::linsolIn(x0_)"
extern "C"
std::vector< casadi::SX* >* linsolIn__9(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* linsolIn__9(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::linsolIn(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::linsolIn" ===============
// cppName: "casadi::linsolIn"
// cWrapperName: "linsolIn__10"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* linsolIn__10(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::linsolIn(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* linsolIn__10(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* linsolIn__10(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::linsolIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::linsolIn" ===============
// cppName: "casadi::linsolIn"
// cWrapperName: "linsolIn__11"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* linsolIn__11(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::linsolIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::SX* >* linsolIn__11(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::SX* >* linsolIn__11(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::SX > ret = casadi::linsolIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::linsolOut" ===============
// cppName: "casadi::linsolOut"
// cWrapperName: "linsolOut__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* linsolOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::linsolOut(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* linsolOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* linsolOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::linsolOut(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::linsolOut" ===============
// cppName: "casadi::linsolOut"
// cWrapperName: "linsolOut__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* linsolOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::linsolOut(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* linsolOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* linsolOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::linsolOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::linsolOut" ===============
// cppName: "casadi::linsolOut"
// cWrapperName: "linsolOut__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* linsolOut__2(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::linsolOut(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* linsolOut__2(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* linsolOut__2(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::linsolOut(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::linsolOut" ===============
// cppName: "casadi::linsolOut"
// cWrapperName: "linsolOut__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* linsolOut__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::linsolOut(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* linsolOut__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* linsolOut__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::linsolOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::linsolOut" ===============
// cppName: "casadi::linsolOut"
// cWrapperName: "linsolOut__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* linsolOut__4(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::linsolOut(x0_)"
extern "C"
std::vector< casadi::MX* >* linsolOut__4(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* linsolOut__4(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::linsolOut(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::linsolOut" ===============
// cppName: "casadi::linsolOut"
// cWrapperName: "linsolOut__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* linsolOut__5(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::linsolOut(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* linsolOut__5(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* linsolOut__5(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::linsolOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::linsolOut" ===============
// cppName: "casadi::linsolOut"
// cWrapperName: "linsolOut__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* linsolOut__6(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::linsolOut(x0_)"
extern "C"
std::vector< casadi::SX* >* linsolOut__6(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* linsolOut__6(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::linsolOut(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::linsolOut" ===============
// cppName: "casadi::linsolOut"
// cWrapperName: "linsolOut__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* linsolOut__7(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::linsolOut(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* linsolOut__7(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* linsolOut__7(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::linsolOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::logic_and" ===============
// cppName: "casadi::logic_and"
// cWrapperName: "logic_and__0"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX* logic_and__0(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// call: "casadi::logic_and(x0_, x1_)"
extern "C"
casadi::MX* logic_and__0(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
casadi::MX* logic_and__0(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX x0_ = Marshaling<casadi::MX,casadi::MX*>::marshal(x0);
        casadi::MX x1_ = Marshaling<casadi::MX,casadi::MX*>::marshal(x1);

        casadi::MX ret = casadi::logic_and(x0_, x1_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::logic_and" ===============
// cppName: "casadi::logic_and"
// cWrapperName: "logic_and__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX* logic_and__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// call: "casadi::logic_and(x0_, x1_)"
extern "C"
casadi::SX* logic_and__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX* logic_and__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);
        casadi::SX x1_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x1);

        casadi::SX ret = casadi::logic_and(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::logic_and" ===============
// cppName: "casadi::logic_and"
// cWrapperName: "logic_and__2"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix* logic_and__2(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// call: "casadi::logic_and(x0_, x1_)"
extern "C"
casadi::DMatrix* logic_and__2(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
casadi::DMatrix* logic_and__2(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix x0_ = Marshaling<casadi::DMatrix,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix x1_ = Marshaling<casadi::DMatrix,casadi::DMatrix*>::marshal(x1);

        casadi::DMatrix ret = casadi::logic_and(x0_, x1_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::logic_and" ===============
// cppName: "casadi::logic_and"
// cWrapperName: "logic_and__3"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix* logic_and__3(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// call: "casadi::logic_and(x0_, x1_)"
extern "C"
casadi::IMatrix* logic_and__3(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
casadi::IMatrix* logic_and__3(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix x0_ = Marshaling<casadi::IMatrix,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix x1_ = Marshaling<casadi::IMatrix,casadi::IMatrix*>::marshal(x1);

        casadi::IMatrix ret = casadi::logic_and(x0_, x1_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::logic_and" ===============
// cppName: "casadi::logic_and"
// cWrapperName: "logic_and__4"
// protoArgs: "(std::string ** err_msg, double* x0, double* x1)"
// params: [Ref (Const CDouble),Ref (Const CDouble)]
// retType: CDouble
// args: "(x0_, x1_)"
// cWrapperRetType: "double"
// proto: "double logic_and__4(std::string ** err_msg, double* x0, double* x1)"
// call: "casadi::logic_and(x0_, x1_)"
extern "C"
double logic_and__4(std::string ** err_msg, double* x0, double* x1);
double logic_and__4(std::string ** err_msg, double* x0, double* x1){
    try {
        double x0_ = Marshaling<double,double*>::marshal(x0);
        double x1_ = Marshaling<double,double*>::marshal(x1);

        double ret = casadi::logic_and(x0_, x1_);
        return WrapReturn< double, double >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::logic_and" ===============
// cppName: "casadi::logic_and"
// cWrapperName: "logic_and__5"
// protoArgs: "(std::string ** err_msg, int* x0, int* x1)"
// params: [Ref (Const CInt),Ref (Const CInt)]
// retType: CInt
// args: "(x0_, x1_)"
// cWrapperRetType: "int"
// proto: "int logic_and__5(std::string ** err_msg, int* x0, int* x1)"
// call: "casadi::logic_and(x0_, x1_)"
extern "C"
int logic_and__5(std::string ** err_msg, int* x0, int* x1);
int logic_and__5(std::string ** err_msg, int* x0, int* x1){
    try {
        int x0_ = Marshaling<int,int*>::marshal(x0);
        int x1_ = Marshaling<int,int*>::marshal(x1);

        int ret = casadi::logic_and(x0_, x1_);
        return WrapReturn< int, int >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::logic_not" ===============
// cppName: "casadi::logic_not"
// cWrapperName: "logic_not__0"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX* logic_not__0(std::string ** err_msg, casadi::MX* x0)"
// call: "casadi::logic_not(x0_)"
extern "C"
casadi::MX* logic_not__0(std::string ** err_msg, casadi::MX* x0);
casadi::MX* logic_not__0(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX x0_ = Marshaling<casadi::MX,casadi::MX*>::marshal(x0);

        casadi::MX ret = casadi::logic_not(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::logic_not" ===============
// cppName: "casadi::logic_not"
// cWrapperName: "logic_not__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX* logic_not__1(std::string ** err_msg, casadi::SX* x0)"
// call: "casadi::logic_not(x0_)"
extern "C"
casadi::SX* logic_not__1(std::string ** err_msg, casadi::SX* x0);
casadi::SX* logic_not__1(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);

        casadi::SX ret = casadi::logic_not(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::logic_not" ===============
// cppName: "casadi::logic_not"
// cWrapperName: "logic_not__2"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix* logic_not__2(std::string ** err_msg, casadi::DMatrix* x0)"
// call: "casadi::logic_not(x0_)"
extern "C"
casadi::DMatrix* logic_not__2(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix* logic_not__2(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix x0_ = Marshaling<casadi::DMatrix,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = casadi::logic_not(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::logic_not" ===============
// cppName: "casadi::logic_not"
// cWrapperName: "logic_not__3"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix* logic_not__3(std::string ** err_msg, casadi::IMatrix* x0)"
// call: "casadi::logic_not(x0_)"
extern "C"
casadi::IMatrix* logic_not__3(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix* logic_not__3(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix x0_ = Marshaling<casadi::IMatrix,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = casadi::logic_not(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::logic_not" ===============
// cppName: "casadi::logic_not"
// cWrapperName: "logic_not__4"
// protoArgs: "(std::string ** err_msg, double* x0)"
// params: [Ref (Const CDouble)]
// retType: CDouble
// args: "(x0_)"
// cWrapperRetType: "double"
// proto: "double logic_not__4(std::string ** err_msg, double* x0)"
// call: "casadi::logic_not(x0_)"
extern "C"
double logic_not__4(std::string ** err_msg, double* x0);
double logic_not__4(std::string ** err_msg, double* x0){
    try {
        double x0_ = Marshaling<double,double*>::marshal(x0);

        double ret = casadi::logic_not(x0_);
        return WrapReturn< double, double >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::logic_not" ===============
// cppName: "casadi::logic_not"
// cWrapperName: "logic_not__5"
// protoArgs: "(std::string ** err_msg, int* x0)"
// params: [Ref (Const CInt)]
// retType: CInt
// args: "(x0_)"
// cWrapperRetType: "int"
// proto: "int logic_not__5(std::string ** err_msg, int* x0)"
// call: "casadi::logic_not(x0_)"
extern "C"
int logic_not__5(std::string ** err_msg, int* x0);
int logic_not__5(std::string ** err_msg, int* x0){
    try {
        int x0_ = Marshaling<int,int*>::marshal(x0);

        int ret = casadi::logic_not(x0_);
        return WrapReturn< int, int >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::logic_or" ===============
// cppName: "casadi::logic_or"
// cWrapperName: "logic_or__0"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX* logic_or__0(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// call: "casadi::logic_or(x0_, x1_)"
extern "C"
casadi::MX* logic_or__0(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
casadi::MX* logic_or__0(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX x0_ = Marshaling<casadi::MX,casadi::MX*>::marshal(x0);
        casadi::MX x1_ = Marshaling<casadi::MX,casadi::MX*>::marshal(x1);

        casadi::MX ret = casadi::logic_or(x0_, x1_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::logic_or" ===============
// cppName: "casadi::logic_or"
// cWrapperName: "logic_or__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX* logic_or__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// call: "casadi::logic_or(x0_, x1_)"
extern "C"
casadi::SX* logic_or__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX* logic_or__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);
        casadi::SX x1_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x1);

        casadi::SX ret = casadi::logic_or(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::logic_or" ===============
// cppName: "casadi::logic_or"
// cWrapperName: "logic_or__2"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix* logic_or__2(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// call: "casadi::logic_or(x0_, x1_)"
extern "C"
casadi::DMatrix* logic_or__2(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
casadi::DMatrix* logic_or__2(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix x0_ = Marshaling<casadi::DMatrix,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix x1_ = Marshaling<casadi::DMatrix,casadi::DMatrix*>::marshal(x1);

        casadi::DMatrix ret = casadi::logic_or(x0_, x1_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::logic_or" ===============
// cppName: "casadi::logic_or"
// cWrapperName: "logic_or__3"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix* logic_or__3(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// call: "casadi::logic_or(x0_, x1_)"
extern "C"
casadi::IMatrix* logic_or__3(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
casadi::IMatrix* logic_or__3(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix x0_ = Marshaling<casadi::IMatrix,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix x1_ = Marshaling<casadi::IMatrix,casadi::IMatrix*>::marshal(x1);

        casadi::IMatrix ret = casadi::logic_or(x0_, x1_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::logic_or" ===============
// cppName: "casadi::logic_or"
// cWrapperName: "logic_or__4"
// protoArgs: "(std::string ** err_msg, double* x0, double* x1)"
// params: [Ref (Const CDouble),Ref (Const CDouble)]
// retType: CDouble
// args: "(x0_, x1_)"
// cWrapperRetType: "double"
// proto: "double logic_or__4(std::string ** err_msg, double* x0, double* x1)"
// call: "casadi::logic_or(x0_, x1_)"
extern "C"
double logic_or__4(std::string ** err_msg, double* x0, double* x1);
double logic_or__4(std::string ** err_msg, double* x0, double* x1){
    try {
        double x0_ = Marshaling<double,double*>::marshal(x0);
        double x1_ = Marshaling<double,double*>::marshal(x1);

        double ret = casadi::logic_or(x0_, x1_);
        return WrapReturn< double, double >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::logic_or" ===============
// cppName: "casadi::logic_or"
// cWrapperName: "logic_or__5"
// protoArgs: "(std::string ** err_msg, int* x0, int* x1)"
// params: [Ref (Const CInt),Ref (Const CInt)]
// retType: CInt
// args: "(x0_, x1_)"
// cWrapperRetType: "int"
// proto: "int logic_or__5(std::string ** err_msg, int* x0, int* x1)"
// call: "casadi::logic_or(x0_, x1_)"
extern "C"
int logic_or__5(std::string ** err_msg, int* x0, int* x1);
int logic_or__5(std::string ** err_msg, int* x0, int* x1){
    try {
        int x0_ = Marshaling<int,int*>::marshal(x0);
        int x1_ = Marshaling<int,int*>::marshal(x1);

        int ret = casadi::logic_or(x0_, x1_);
        return WrapReturn< int, int >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lookupvector" ===============
// cppName: "casadi::lookupvector"
// cWrapperName: "lookupvector"
// protoArgs: "(std::string ** err_msg, std::vector< int >* x0, int x1)"
// params: [Ref (Const (StdVec CInt)),CInt]
// retType: StdVec CInt
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< int >*"
// proto: "std::vector< int >* lookupvector(std::string ** err_msg, std::vector< int >* x0, int x1)"
// call: "casadi::lookupvector(x0_, x1_)"
extern "C"
std::vector< int >* lookupvector(std::string ** err_msg, std::vector< int >* x0, int x1);
std::vector< int >* lookupvector(std::string ** err_msg, std::vector< int >* x0, int x1){
    try {
        std::vector< int > x0_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x0);
        int x1_ = Marshaling<int,int>::marshal(x1);

        std::vector< int > ret = casadi::lookupvector(x0_, x1_);
        return WrapReturn< std::vector< int >*, std::vector< int > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* lpIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::lpIn(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* lpIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* lpIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::lpIn(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* lpIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::lpIn(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* lpIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* lpIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::lpIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* lpIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::lpIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* lpIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* lpIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::lpIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* lpIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::Sparsity* >* lpIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::Sparsity* >* lpIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::Sparsity > ret = casadi::lpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* lpIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::Sparsity* >* lpIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::Sparsity* >* lpIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::Sparsity > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* lpIn__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::Sparsity* >* lpIn__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::Sparsity* >* lpIn__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::Sparsity > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* lpIn__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::Sparsity* >* lpIn__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::Sparsity* >* lpIn__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::Sparsity > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* lpIn__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::lpIn(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* lpIn__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* lpIn__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::lpIn(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__8"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* lpIn__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::lpIn(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* lpIn__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* lpIn__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::lpIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__9"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* lpIn__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::lpIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::DMatrix* >* lpIn__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::DMatrix* >* lpIn__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::DMatrix > ret = casadi::lpIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__10"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* lpIn__10(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::DMatrix* >* lpIn__10(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::DMatrix* >* lpIn__10(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::DMatrix > ret = casadi::lpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__11"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* lpIn__11(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::DMatrix* >* lpIn__11(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::DMatrix* >* lpIn__11(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::DMatrix > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__12"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* lpIn__12(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::DMatrix* >* lpIn__12(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::DMatrix* >* lpIn__12(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::DMatrix > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__13"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* lpIn__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::DMatrix* >* lpIn__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::DMatrix* >* lpIn__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::DMatrix > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__14"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* lpIn__14(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::lpIn(x0_)"
extern "C"
std::vector< casadi::MX* >* lpIn__14(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* lpIn__14(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::lpIn(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__15"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* lpIn__15(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::lpIn(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* lpIn__15(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* lpIn__15(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::lpIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__16"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* lpIn__16(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::lpIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >* lpIn__16(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::MX* >* lpIn__16(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::MX > ret = casadi::lpIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__17"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* lpIn__17(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::MX* >* lpIn__17(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::MX* >* lpIn__17(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::MX > ret = casadi::lpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__18"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* lpIn__18(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::MX* >* lpIn__18(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::MX* >* lpIn__18(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::MX > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__19"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* lpIn__19(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::MX* >* lpIn__19(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::MX* >* lpIn__19(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::MX > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__20"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* lpIn__20(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::MX* >* lpIn__20(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::MX* >* lpIn__20(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::MX > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__21"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* lpIn__21(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::lpIn(x0_)"
extern "C"
std::vector< casadi::SX* >* lpIn__21(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* lpIn__21(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::lpIn(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__22"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* lpIn__22(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::lpIn(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* lpIn__22(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* lpIn__22(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::lpIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__23"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* lpIn__23(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::lpIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::SX* >* lpIn__23(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::SX* >* lpIn__23(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::SX > ret = casadi::lpIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__24"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* lpIn__24(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::SX* >* lpIn__24(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::SX* >* lpIn__24(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::SX > ret = casadi::lpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__25"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* lpIn__25(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::SX* >* lpIn__25(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::SX* >* lpIn__25(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::SX > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__26"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* lpIn__26(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::SX* >* lpIn__26(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::SX* >* lpIn__26(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::SX > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpIn" ===============
// cppName: "casadi::lpIn"
// cWrapperName: "lpIn__27"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* lpIn__27(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::SX* >* lpIn__27(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::SX* >* lpIn__27(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::SX > ret = casadi::lpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* lpOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::lpOut(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* lpOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* lpOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::lpOut(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* lpOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::lpOut(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* lpOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* lpOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::lpOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* lpOut__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::lpOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* lpOut__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* lpOut__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::lpOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* lpOut__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::lpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::Sparsity* >* lpOut__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::Sparsity* >* lpOut__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::Sparsity > ret = casadi::lpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* lpOut__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::lpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::Sparsity* >* lpOut__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::Sparsity* >* lpOut__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::Sparsity > ret = casadi::lpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* lpOut__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::lpOut(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* lpOut__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* lpOut__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::lpOut(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* lpOut__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::lpOut(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* lpOut__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* lpOut__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::lpOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* lpOut__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::lpOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::DMatrix* >* lpOut__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::DMatrix* >* lpOut__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::DMatrix > ret = casadi::lpOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__8"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* lpOut__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::lpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::DMatrix* >* lpOut__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::DMatrix* >* lpOut__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::DMatrix > ret = casadi::lpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__9"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* lpOut__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::lpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::DMatrix* >* lpOut__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::DMatrix* >* lpOut__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::DMatrix > ret = casadi::lpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__10"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* lpOut__10(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::lpOut(x0_)"
extern "C"
std::vector< casadi::MX* >* lpOut__10(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* lpOut__10(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::lpOut(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__11"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* lpOut__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::lpOut(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* lpOut__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* lpOut__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::lpOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__12"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* lpOut__12(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::lpOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >* lpOut__12(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::MX* >* lpOut__12(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::MX > ret = casadi::lpOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__13"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* lpOut__13(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::lpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::MX* >* lpOut__13(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::MX* >* lpOut__13(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::MX > ret = casadi::lpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__14"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* lpOut__14(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::lpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::MX* >* lpOut__14(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::MX* >* lpOut__14(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::MX > ret = casadi::lpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__15"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* lpOut__15(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::lpOut(x0_)"
extern "C"
std::vector< casadi::SX* >* lpOut__15(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* lpOut__15(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::lpOut(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__16"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* lpOut__16(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::lpOut(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* lpOut__16(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* lpOut__16(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::lpOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__17"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* lpOut__17(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::lpOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::SX* >* lpOut__17(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::SX* >* lpOut__17(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::SX > ret = casadi::lpOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__18"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* lpOut__18(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::lpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::SX* >* lpOut__18(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::SX* >* lpOut__18(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::SX > ret = casadi::lpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpOut" ===============
// cppName: "casadi::lpOut"
// cWrapperName: "lpOut__19"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* lpOut__19(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::lpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::SX* >* lpOut__19(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::SX* >* lpOut__19(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::SX > ret = casadi::lpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpStruct" ===============
// cppName: "casadi::lpStruct"
// cWrapperName: "lpStruct__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* lpStruct__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::lpStruct(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* lpStruct__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* lpStruct__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::lpStruct(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lpStruct" ===============
// cppName: "casadi::lpStruct"
// cWrapperName: "lpStruct__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* lpStruct__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::lpStruct(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* lpStruct__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* lpStruct__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::lpStruct(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* lrdleIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::lrdleIn(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* lrdleIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* lrdleIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::lrdleIn(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* lrdleIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::lrdleIn(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* lrdleIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* lrdleIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::lrdleIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* lrdleIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::lrdleIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* lrdleIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* lrdleIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::lrdleIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* lrdleIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::lrdleIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::Sparsity* >* lrdleIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::Sparsity* >* lrdleIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::Sparsity > ret = casadi::lrdleIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* lrdleIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::lrdleIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::Sparsity* >* lrdleIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::Sparsity* >* lrdleIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::Sparsity > ret = casadi::lrdleIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* lrdleIn__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::lrdleIn(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* lrdleIn__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* lrdleIn__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::lrdleIn(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* lrdleIn__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::lrdleIn(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* lrdleIn__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* lrdleIn__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::lrdleIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* lrdleIn__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::lrdleIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::DMatrix* >* lrdleIn__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::DMatrix* >* lrdleIn__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::DMatrix > ret = casadi::lrdleIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__8"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* lrdleIn__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::lrdleIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::DMatrix* >* lrdleIn__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::DMatrix* >* lrdleIn__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::DMatrix > ret = casadi::lrdleIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__9"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* lrdleIn__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::lrdleIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::DMatrix* >* lrdleIn__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::DMatrix* >* lrdleIn__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::DMatrix > ret = casadi::lrdleIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__10"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* lrdleIn__10(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::lrdleIn(x0_)"
extern "C"
std::vector< casadi::MX* >* lrdleIn__10(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* lrdleIn__10(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::lrdleIn(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__11"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* lrdleIn__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::lrdleIn(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* lrdleIn__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* lrdleIn__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::lrdleIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__12"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* lrdleIn__12(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::lrdleIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >* lrdleIn__12(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::MX* >* lrdleIn__12(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::MX > ret = casadi::lrdleIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__13"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* lrdleIn__13(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::lrdleIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::MX* >* lrdleIn__13(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::MX* >* lrdleIn__13(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::MX > ret = casadi::lrdleIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__14"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* lrdleIn__14(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::lrdleIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::MX* >* lrdleIn__14(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::MX* >* lrdleIn__14(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::MX > ret = casadi::lrdleIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__15"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* lrdleIn__15(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::lrdleIn(x0_)"
extern "C"
std::vector< casadi::SX* >* lrdleIn__15(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* lrdleIn__15(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::lrdleIn(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__16"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* lrdleIn__16(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::lrdleIn(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* lrdleIn__16(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* lrdleIn__16(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::lrdleIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__17"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* lrdleIn__17(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::lrdleIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::SX* >* lrdleIn__17(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::SX* >* lrdleIn__17(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::SX > ret = casadi::lrdleIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__18"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* lrdleIn__18(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::lrdleIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::SX* >* lrdleIn__18(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::SX* >* lrdleIn__18(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::SX > ret = casadi::lrdleIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleIn" ===============
// cppName: "casadi::lrdleIn"
// cWrapperName: "lrdleIn__19"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* lrdleIn__19(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::lrdleIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::SX* >* lrdleIn__19(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::SX* >* lrdleIn__19(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::SX > ret = casadi::lrdleIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleOut" ===============
// cppName: "casadi::lrdleOut"
// cWrapperName: "lrdleOut__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* lrdleOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::lrdleOut(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* lrdleOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* lrdleOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::lrdleOut(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleOut" ===============
// cppName: "casadi::lrdleOut"
// cWrapperName: "lrdleOut__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* lrdleOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::lrdleOut(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* lrdleOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* lrdleOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::lrdleOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleOut" ===============
// cppName: "casadi::lrdleOut"
// cWrapperName: "lrdleOut__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* lrdleOut__2(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::lrdleOut(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* lrdleOut__2(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* lrdleOut__2(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::lrdleOut(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleOut" ===============
// cppName: "casadi::lrdleOut"
// cWrapperName: "lrdleOut__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* lrdleOut__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::lrdleOut(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* lrdleOut__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* lrdleOut__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::lrdleOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleOut" ===============
// cppName: "casadi::lrdleOut"
// cWrapperName: "lrdleOut__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* lrdleOut__4(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::lrdleOut(x0_)"
extern "C"
std::vector< casadi::MX* >* lrdleOut__4(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* lrdleOut__4(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::lrdleOut(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleOut" ===============
// cppName: "casadi::lrdleOut"
// cWrapperName: "lrdleOut__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* lrdleOut__5(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::lrdleOut(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* lrdleOut__5(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* lrdleOut__5(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::lrdleOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleOut" ===============
// cppName: "casadi::lrdleOut"
// cWrapperName: "lrdleOut__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* lrdleOut__6(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::lrdleOut(x0_)"
extern "C"
std::vector< casadi::SX* >* lrdleOut__6(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* lrdleOut__6(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::lrdleOut(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleOut" ===============
// cppName: "casadi::lrdleOut"
// cWrapperName: "lrdleOut__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* lrdleOut__7(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::lrdleOut(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* lrdleOut__7(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* lrdleOut__7(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::lrdleOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleStruct" ===============
// cppName: "casadi::lrdleStruct"
// cWrapperName: "lrdleStruct__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* lrdleStruct__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::lrdleStruct(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* lrdleStruct__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* lrdleStruct__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::lrdleStruct(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleStruct" ===============
// cppName: "casadi::lrdleStruct"
// cWrapperName: "lrdleStruct__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* lrdleStruct__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::lrdleStruct(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* lrdleStruct__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* lrdleStruct__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::lrdleStruct(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleStruct" ===============
// cppName: "casadi::lrdleStruct"
// cWrapperName: "lrdleStruct__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* lrdleStruct__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::lrdleStruct(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* lrdleStruct__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* lrdleStruct__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::lrdleStruct(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleStruct" ===============
// cppName: "casadi::lrdleStruct"
// cWrapperName: "lrdleStruct__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* lrdleStruct__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::lrdleStruct(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::Sparsity* >* lrdleStruct__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::Sparsity* >* lrdleStruct__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::Sparsity > ret = casadi::lrdleStruct(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdleStruct" ===============
// cppName: "casadi::lrdleStruct"
// cWrapperName: "lrdleStruct__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* lrdleStruct__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::lrdleStruct(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::Sparsity* >* lrdleStruct__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::Sparsity* >* lrdleStruct__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::Sparsity > ret = casadi::lrdleStruct(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* lrdpleIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::lrdpleIn(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* lrdpleIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* lrdpleIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::lrdpleIn(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* lrdpleIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::lrdpleIn(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* lrdpleIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* lrdpleIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::lrdpleIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* lrdpleIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::lrdpleIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* lrdpleIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* lrdpleIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::lrdpleIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* lrdpleIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::lrdpleIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::Sparsity* >* lrdpleIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::Sparsity* >* lrdpleIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::Sparsity > ret = casadi::lrdpleIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* lrdpleIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::lrdpleIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::Sparsity* >* lrdpleIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::Sparsity* >* lrdpleIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::Sparsity > ret = casadi::lrdpleIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* lrdpleIn__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::lrdpleIn(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* lrdpleIn__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* lrdpleIn__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::lrdpleIn(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* lrdpleIn__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::lrdpleIn(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* lrdpleIn__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* lrdpleIn__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::lrdpleIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* lrdpleIn__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::lrdpleIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::DMatrix* >* lrdpleIn__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::DMatrix* >* lrdpleIn__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::DMatrix > ret = casadi::lrdpleIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__8"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* lrdpleIn__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::lrdpleIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::DMatrix* >* lrdpleIn__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::DMatrix* >* lrdpleIn__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::DMatrix > ret = casadi::lrdpleIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__9"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* lrdpleIn__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::lrdpleIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::DMatrix* >* lrdpleIn__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::DMatrix* >* lrdpleIn__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::DMatrix > ret = casadi::lrdpleIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__10"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* lrdpleIn__10(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::lrdpleIn(x0_)"
extern "C"
std::vector< casadi::MX* >* lrdpleIn__10(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* lrdpleIn__10(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::lrdpleIn(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__11"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* lrdpleIn__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::lrdpleIn(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* lrdpleIn__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* lrdpleIn__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::lrdpleIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__12"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* lrdpleIn__12(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::lrdpleIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >* lrdpleIn__12(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::MX* >* lrdpleIn__12(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::MX > ret = casadi::lrdpleIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__13"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* lrdpleIn__13(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::lrdpleIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::MX* >* lrdpleIn__13(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::MX* >* lrdpleIn__13(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::MX > ret = casadi::lrdpleIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__14"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* lrdpleIn__14(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::lrdpleIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::MX* >* lrdpleIn__14(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::MX* >* lrdpleIn__14(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::MX > ret = casadi::lrdpleIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__15"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* lrdpleIn__15(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::lrdpleIn(x0_)"
extern "C"
std::vector< casadi::SX* >* lrdpleIn__15(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* lrdpleIn__15(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::lrdpleIn(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__16"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* lrdpleIn__16(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::lrdpleIn(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* lrdpleIn__16(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* lrdpleIn__16(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::lrdpleIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__17"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* lrdpleIn__17(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::lrdpleIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::SX* >* lrdpleIn__17(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::SX* >* lrdpleIn__17(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::SX > ret = casadi::lrdpleIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__18"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* lrdpleIn__18(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::lrdpleIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::SX* >* lrdpleIn__18(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::SX* >* lrdpleIn__18(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::SX > ret = casadi::lrdpleIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleIn" ===============
// cppName: "casadi::lrdpleIn"
// cWrapperName: "lrdpleIn__19"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* lrdpleIn__19(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::lrdpleIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::SX* >* lrdpleIn__19(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::SX* >* lrdpleIn__19(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::SX > ret = casadi::lrdpleIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleOut" ===============
// cppName: "casadi::lrdpleOut"
// cWrapperName: "lrdpleOut__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* lrdpleOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::lrdpleOut(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* lrdpleOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* lrdpleOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::lrdpleOut(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleOut" ===============
// cppName: "casadi::lrdpleOut"
// cWrapperName: "lrdpleOut__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* lrdpleOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::lrdpleOut(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* lrdpleOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* lrdpleOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::lrdpleOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleOut" ===============
// cppName: "casadi::lrdpleOut"
// cWrapperName: "lrdpleOut__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* lrdpleOut__2(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::lrdpleOut(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* lrdpleOut__2(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* lrdpleOut__2(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::lrdpleOut(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleOut" ===============
// cppName: "casadi::lrdpleOut"
// cWrapperName: "lrdpleOut__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* lrdpleOut__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::lrdpleOut(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* lrdpleOut__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* lrdpleOut__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::lrdpleOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleOut" ===============
// cppName: "casadi::lrdpleOut"
// cWrapperName: "lrdpleOut__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* lrdpleOut__4(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::lrdpleOut(x0_)"
extern "C"
std::vector< casadi::MX* >* lrdpleOut__4(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* lrdpleOut__4(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::lrdpleOut(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleOut" ===============
// cppName: "casadi::lrdpleOut"
// cWrapperName: "lrdpleOut__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* lrdpleOut__5(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::lrdpleOut(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* lrdpleOut__5(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* lrdpleOut__5(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::lrdpleOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleOut" ===============
// cppName: "casadi::lrdpleOut"
// cWrapperName: "lrdpleOut__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* lrdpleOut__6(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::lrdpleOut(x0_)"
extern "C"
std::vector< casadi::SX* >* lrdpleOut__6(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* lrdpleOut__6(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::lrdpleOut(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleOut" ===============
// cppName: "casadi::lrdpleOut"
// cWrapperName: "lrdpleOut__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* lrdpleOut__7(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::lrdpleOut(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* lrdpleOut__7(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* lrdpleOut__7(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::lrdpleOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleStruct" ===============
// cppName: "casadi::lrdpleStruct"
// cWrapperName: "lrdpleStruct__0"
// protoArgs: "(std::string ** err_msg, std::vector< std::vector< casadi::Sparsity* >* >* x0)"
// params: [Ref (Const (StdVec (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))))]
// retType: StdVec (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))
// args: "(x0_)"
// cWrapperRetType: "std::vector< std::vector< casadi::Sparsity* >* >*"
// proto: "std::vector< std::vector< casadi::Sparsity* >* >* lrdpleStruct__0(std::string ** err_msg, std::vector< std::vector< casadi::Sparsity* >* >* x0)"
// call: "casadi::lrdpleStruct(x0_)"
extern "C"
std::vector< std::vector< casadi::Sparsity* >* >* lrdpleStruct__0(std::string ** err_msg, std::vector< std::vector< casadi::Sparsity* >* >* x0);
std::vector< std::vector< casadi::Sparsity* >* >* lrdpleStruct__0(std::string ** err_msg, std::vector< std::vector< casadi::Sparsity* >* >* x0){
    try {
        std::vector< std::vector< casadi::Sparsity > > x0_ = Marshaling<std::vector< std::vector< casadi::Sparsity > >,std::vector< std::vector< casadi::Sparsity* >* >*>::marshal(x0);

        std::vector< std::vector< casadi::Sparsity > > ret = casadi::lrdpleStruct(x0_);
        return WrapReturn< std::vector< std::vector< casadi::Sparsity* >* >*, std::vector< std::vector< casadi::Sparsity > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleStruct" ===============
// cppName: "casadi::lrdpleStruct"
// cWrapperName: "lrdpleStruct__1"
// protoArgs: "(std::string ** err_msg, std::vector< std::vector< casadi::Sparsity* >* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))),Ref (Const StdString)]
// retType: StdVec (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< std::vector< casadi::Sparsity* >* >*"
// proto: "std::vector< std::vector< casadi::Sparsity* >* >* lrdpleStruct__1(std::string ** err_msg, std::vector< std::vector< casadi::Sparsity* >* >* x0, std::string* x1)"
// call: "casadi::lrdpleStruct(x0_, x1_)"
extern "C"
std::vector< std::vector< casadi::Sparsity* >* >* lrdpleStruct__1(std::string ** err_msg, std::vector< std::vector< casadi::Sparsity* >* >* x0, std::string* x1);
std::vector< std::vector< casadi::Sparsity* >* >* lrdpleStruct__1(std::string ** err_msg, std::vector< std::vector< casadi::Sparsity* >* >* x0, std::string* x1){
    try {
        std::vector< std::vector< casadi::Sparsity > > x0_ = Marshaling<std::vector< std::vector< casadi::Sparsity > >,std::vector< std::vector< casadi::Sparsity* >* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< std::vector< casadi::Sparsity > > ret = casadi::lrdpleStruct(x0_, x1_);
        return WrapReturn< std::vector< std::vector< casadi::Sparsity* >* >*, std::vector< std::vector< casadi::Sparsity > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleStruct" ===============
// cppName: "casadi::lrdpleStruct"
// cWrapperName: "lrdpleStruct__2"
// protoArgs: "(std::string ** err_msg, std::vector< std::vector< casadi::Sparsity* >* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< std::vector< casadi::Sparsity* >* >*"
// proto: "std::vector< std::vector< casadi::Sparsity* >* >* lrdpleStruct__2(std::string ** err_msg, std::vector< std::vector< casadi::Sparsity* >* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::lrdpleStruct(x0_, x1_, x2_)"
extern "C"
std::vector< std::vector< casadi::Sparsity* >* >* lrdpleStruct__2(std::string ** err_msg, std::vector< std::vector< casadi::Sparsity* >* >* x0, std::string* x1, std::string* x2);
std::vector< std::vector< casadi::Sparsity* >* >* lrdpleStruct__2(std::string ** err_msg, std::vector< std::vector< casadi::Sparsity* >* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< std::vector< casadi::Sparsity > > x0_ = Marshaling<std::vector< std::vector< casadi::Sparsity > >,std::vector< std::vector< casadi::Sparsity* >* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< std::vector< casadi::Sparsity > > ret = casadi::lrdpleStruct(x0_, x1_, x2_);
        return WrapReturn< std::vector< std::vector< casadi::Sparsity* >* >*, std::vector< std::vector< casadi::Sparsity > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleStruct" ===============
// cppName: "casadi::lrdpleStruct"
// cWrapperName: "lrdpleStruct__3"
// protoArgs: "(std::string ** err_msg, std::vector< std::vector< casadi::Sparsity* >* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< std::vector< casadi::Sparsity* >* >*"
// proto: "std::vector< std::vector< casadi::Sparsity* >* >* lrdpleStruct__3(std::string ** err_msg, std::vector< std::vector< casadi::Sparsity* >* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::lrdpleStruct(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< std::vector< casadi::Sparsity* >* >* lrdpleStruct__3(std::string ** err_msg, std::vector< std::vector< casadi::Sparsity* >* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< std::vector< casadi::Sparsity* >* >* lrdpleStruct__3(std::string ** err_msg, std::vector< std::vector< casadi::Sparsity* >* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< std::vector< casadi::Sparsity > > x0_ = Marshaling<std::vector< std::vector< casadi::Sparsity > >,std::vector< std::vector< casadi::Sparsity* >* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< std::vector< casadi::Sparsity > > ret = casadi::lrdpleStruct(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< std::vector< casadi::Sparsity* >* >*, std::vector< std::vector< casadi::Sparsity > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::lrdpleStruct" ===============
// cppName: "casadi::lrdpleStruct"
// cWrapperName: "lrdpleStruct__4"
// protoArgs: "(std::string ** err_msg, std::vector< std::vector< casadi::Sparsity* >* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< std::vector< casadi::Sparsity* >* >*"
// proto: "std::vector< std::vector< casadi::Sparsity* >* >* lrdpleStruct__4(std::string ** err_msg, std::vector< std::vector< casadi::Sparsity* >* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::lrdpleStruct(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< std::vector< casadi::Sparsity* >* >* lrdpleStruct__4(std::string ** err_msg, std::vector< std::vector< casadi::Sparsity* >* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< std::vector< casadi::Sparsity* >* >* lrdpleStruct__4(std::string ** err_msg, std::vector< std::vector< casadi::Sparsity* >* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< std::vector< casadi::Sparsity > > x0_ = Marshaling<std::vector< std::vector< casadi::Sparsity > >,std::vector< std::vector< casadi::Sparsity* >* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< std::vector< casadi::Sparsity > > ret = casadi::lrdpleStruct(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< std::vector< casadi::Sparsity* >* >*, std::vector< std::vector< casadi::Sparsity > > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::matrix_expand" ===============
// cppName: "casadi::matrix_expand"
// cWrapperName: "matrix_expand__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* matrix_expand__0(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::matrix_expand(x0_)"
extern "C"
std::vector< casadi::MX* >* matrix_expand__0(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* matrix_expand__0(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::matrix_expand(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::matrix_expand" ===============
// cppName: "casadi::matrix_expand"
// cWrapperName: "matrix_expand__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* matrix_expand__1(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1)"
// call: "casadi::matrix_expand(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* matrix_expand__1(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1);
std::vector< casadi::MX* >* matrix_expand__1(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::vector< casadi::MX > x1_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::matrix_expand(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::matrix_expand" ===============
// cppName: "casadi::matrix_expand"
// cWrapperName: "matrix_expand__2"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX* matrix_expand__2(std::string ** err_msg, casadi::MX* x0)"
// call: "casadi::matrix_expand(x0_)"
extern "C"
casadi::MX* matrix_expand__2(std::string ** err_msg, casadi::MX* x0);
casadi::MX* matrix_expand__2(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX x0_ = Marshaling<casadi::MX,casadi::MX*>::marshal(x0);

        casadi::MX ret = casadi::matrix_expand(x0_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::matrix_expand" ===============
// cppName: "casadi::matrix_expand"
// cWrapperName: "matrix_expand__3"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, std::vector< casadi::MX* >* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX* matrix_expand__3(std::string ** err_msg, casadi::MX* x0, std::vector< casadi::MX* >* x1)"
// call: "casadi::matrix_expand(x0_, x1_)"
extern "C"
casadi::MX* matrix_expand__3(std::string ** err_msg, casadi::MX* x0, std::vector< casadi::MX* >* x1);
casadi::MX* matrix_expand__3(std::string ** err_msg, casadi::MX* x0, std::vector< casadi::MX* >* x1){
    try {
        casadi::MX x0_ = Marshaling<casadi::MX,casadi::MX*>::marshal(x0);
        std::vector< casadi::MX > x1_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x1);

        casadi::MX ret = casadi::matrix_expand(x0_, x1_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::mtaylor" ===============
// cppName: "casadi::mtaylor"
// cWrapperName: "mtaylor__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, int x3, std::vector< int >* x4)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),CInt,Ref (Const (StdVec CInt))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX* mtaylor__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, int x3, std::vector< int >* x4)"
// call: "casadi::mtaylor(x0_, x1_, x2_, x3_, x4_)"
extern "C"
casadi::SX* mtaylor__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, int x3, std::vector< int >* x4);
casadi::SX* mtaylor__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, int x3, std::vector< int >* x4){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);
        casadi::SX x1_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x1);
        casadi::SX x2_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x2);
        int x3_ = Marshaling<int,int>::marshal(x3);
        std::vector< int > x4_ = Marshaling<std::vector< int >,std::vector< int >*>::marshal(x4);

        casadi::SX ret = casadi::mtaylor(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::mtaylor" ===============
// cppName: "casadi::mtaylor"
// cWrapperName: "mtaylor__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX* mtaylor__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2)"
// call: "casadi::mtaylor(x0_, x1_, x2_)"
extern "C"
casadi::SX* mtaylor__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2);
casadi::SX* mtaylor__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);
        casadi::SX x1_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x1);
        casadi::SX x2_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x2);

        casadi::SX ret = casadi::mtaylor(x0_, x1_, x2_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::mtaylor" ===============
// cppName: "casadi::mtaylor"
// cWrapperName: "mtaylor__2"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, int x3)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),CInt]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX* mtaylor__2(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, int x3)"
// call: "casadi::mtaylor(x0_, x1_, x2_, x3_)"
extern "C"
casadi::SX* mtaylor__2(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, int x3);
casadi::SX* mtaylor__2(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, int x3){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);
        casadi::SX x1_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x1);
        casadi::SX x2_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x2);
        int x3_ = Marshaling<int,int>::marshal(x3);

        casadi::SX ret = casadi::mtaylor(x0_, x1_, x2_, x3_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpIn" ===============
// cppName: "casadi::nlpIn"
// cWrapperName: "nlpIn__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* nlpIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::nlpIn(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* nlpIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* nlpIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::nlpIn(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpIn" ===============
// cppName: "casadi::nlpIn"
// cWrapperName: "nlpIn__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* nlpIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::nlpIn(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* nlpIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* nlpIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::nlpIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpIn" ===============
// cppName: "casadi::nlpIn"
// cWrapperName: "nlpIn__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* nlpIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::nlpIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* nlpIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* nlpIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::nlpIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpIn" ===============
// cppName: "casadi::nlpIn"
// cWrapperName: "nlpIn__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* nlpIn__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::nlpIn(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* nlpIn__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* nlpIn__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::nlpIn(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpIn" ===============
// cppName: "casadi::nlpIn"
// cWrapperName: "nlpIn__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* nlpIn__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::nlpIn(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* nlpIn__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* nlpIn__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::nlpIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpIn" ===============
// cppName: "casadi::nlpIn"
// cWrapperName: "nlpIn__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* nlpIn__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::nlpIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::DMatrix* >* nlpIn__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::DMatrix* >* nlpIn__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::DMatrix > ret = casadi::nlpIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpIn" ===============
// cppName: "casadi::nlpIn"
// cWrapperName: "nlpIn__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* nlpIn__6(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::nlpIn(x0_)"
extern "C"
std::vector< casadi::MX* >* nlpIn__6(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* nlpIn__6(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::nlpIn(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpIn" ===============
// cppName: "casadi::nlpIn"
// cWrapperName: "nlpIn__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* nlpIn__7(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::nlpIn(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* nlpIn__7(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* nlpIn__7(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::nlpIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpIn" ===============
// cppName: "casadi::nlpIn"
// cWrapperName: "nlpIn__8"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* nlpIn__8(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::nlpIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >* nlpIn__8(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::MX* >* nlpIn__8(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::MX > ret = casadi::nlpIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpIn" ===============
// cppName: "casadi::nlpIn"
// cWrapperName: "nlpIn__9"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* nlpIn__9(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::nlpIn(x0_)"
extern "C"
std::vector< casadi::SX* >* nlpIn__9(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* nlpIn__9(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::nlpIn(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpIn" ===============
// cppName: "casadi::nlpIn"
// cWrapperName: "nlpIn__10"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* nlpIn__10(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::nlpIn(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* nlpIn__10(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* nlpIn__10(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::nlpIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpIn" ===============
// cppName: "casadi::nlpIn"
// cWrapperName: "nlpIn__11"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* nlpIn__11(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::nlpIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::SX* >* nlpIn__11(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::SX* >* nlpIn__11(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::SX > ret = casadi::nlpIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpOut" ===============
// cppName: "casadi::nlpOut"
// cWrapperName: "nlpOut__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* nlpOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::nlpOut(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* nlpOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* nlpOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::nlpOut(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpOut" ===============
// cppName: "casadi::nlpOut"
// cWrapperName: "nlpOut__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* nlpOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::nlpOut(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* nlpOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* nlpOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::nlpOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpOut" ===============
// cppName: "casadi::nlpOut"
// cWrapperName: "nlpOut__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* nlpOut__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::nlpOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* nlpOut__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* nlpOut__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::nlpOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpOut" ===============
// cppName: "casadi::nlpOut"
// cWrapperName: "nlpOut__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* nlpOut__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::nlpOut(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* nlpOut__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* nlpOut__3(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::nlpOut(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpOut" ===============
// cppName: "casadi::nlpOut"
// cWrapperName: "nlpOut__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* nlpOut__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::nlpOut(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* nlpOut__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* nlpOut__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::nlpOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpOut" ===============
// cppName: "casadi::nlpOut"
// cWrapperName: "nlpOut__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* nlpOut__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::nlpOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::DMatrix* >* nlpOut__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::DMatrix* >* nlpOut__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::DMatrix > ret = casadi::nlpOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpOut" ===============
// cppName: "casadi::nlpOut"
// cWrapperName: "nlpOut__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* nlpOut__6(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::nlpOut(x0_)"
extern "C"
std::vector< casadi::MX* >* nlpOut__6(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* nlpOut__6(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::nlpOut(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpOut" ===============
// cppName: "casadi::nlpOut"
// cWrapperName: "nlpOut__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* nlpOut__7(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::nlpOut(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* nlpOut__7(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* nlpOut__7(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::nlpOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpOut" ===============
// cppName: "casadi::nlpOut"
// cWrapperName: "nlpOut__8"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* nlpOut__8(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::nlpOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >* nlpOut__8(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::MX* >* nlpOut__8(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::MX > ret = casadi::nlpOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpOut" ===============
// cppName: "casadi::nlpOut"
// cWrapperName: "nlpOut__9"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* nlpOut__9(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::nlpOut(x0_)"
extern "C"
std::vector< casadi::SX* >* nlpOut__9(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* nlpOut__9(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::nlpOut(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpOut" ===============
// cppName: "casadi::nlpOut"
// cWrapperName: "nlpOut__10"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* nlpOut__10(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::nlpOut(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* nlpOut__10(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* nlpOut__10(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::nlpOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpOut" ===============
// cppName: "casadi::nlpOut"
// cWrapperName: "nlpOut__11"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* nlpOut__11(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::nlpOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::SX* >* nlpOut__11(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::SX* >* nlpOut__11(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::SX > ret = casadi::nlpOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* nlpSolverIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::nlpSolverIn(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* nlpSolverIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* nlpSolverIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::nlpSolverIn(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* nlpSolverIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::nlpSolverIn(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* nlpSolverIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* nlpSolverIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::nlpSolverIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* nlpSolverIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* nlpSolverIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* nlpSolverIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::nlpSolverIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* nlpSolverIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::Sparsity* >* nlpSolverIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::Sparsity* >* nlpSolverIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::Sparsity > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* nlpSolverIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::Sparsity* >* nlpSolverIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::Sparsity* >* nlpSolverIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::Sparsity > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* nlpSolverIn__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::Sparsity* >* nlpSolverIn__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::Sparsity* >* nlpSolverIn__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::Sparsity > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* nlpSolverIn__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::Sparsity* >* nlpSolverIn__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::Sparsity* >* nlpSolverIn__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::Sparsity > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* nlpSolverIn__7(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::Sparsity* >* nlpSolverIn__7(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::Sparsity* >* nlpSolverIn__7(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::Sparsity > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__8"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* nlpSolverIn__8(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::vector< casadi::Sparsity* >* nlpSolverIn__8(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8);
std::vector< casadi::Sparsity* >* nlpSolverIn__8(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);

        std::vector< casadi::Sparsity > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__9"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* nlpSolverIn__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::nlpSolverIn(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* nlpSolverIn__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* nlpSolverIn__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::nlpSolverIn(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__10"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* nlpSolverIn__10(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::nlpSolverIn(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* nlpSolverIn__10(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* nlpSolverIn__10(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::nlpSolverIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__11"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* nlpSolverIn__11(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::DMatrix* >* nlpSolverIn__11(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::DMatrix* >* nlpSolverIn__11(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::DMatrix > ret = casadi::nlpSolverIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__12"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* nlpSolverIn__12(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::DMatrix* >* nlpSolverIn__12(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::DMatrix* >* nlpSolverIn__12(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::DMatrix > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__13"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* nlpSolverIn__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::DMatrix* >* nlpSolverIn__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::DMatrix* >* nlpSolverIn__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::DMatrix > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__14"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* nlpSolverIn__14(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::DMatrix* >* nlpSolverIn__14(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::DMatrix* >* nlpSolverIn__14(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::DMatrix > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__15"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* nlpSolverIn__15(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::DMatrix* >* nlpSolverIn__15(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::DMatrix* >* nlpSolverIn__15(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::DMatrix > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__16"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* nlpSolverIn__16(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::DMatrix* >* nlpSolverIn__16(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::DMatrix* >* nlpSolverIn__16(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::DMatrix > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__17"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* nlpSolverIn__17(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::vector< casadi::DMatrix* >* nlpSolverIn__17(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8);
std::vector< casadi::DMatrix* >* nlpSolverIn__17(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);

        std::vector< casadi::DMatrix > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__18"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* nlpSolverIn__18(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::nlpSolverIn(x0_)"
extern "C"
std::vector< casadi::MX* >* nlpSolverIn__18(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* nlpSolverIn__18(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::nlpSolverIn(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__19"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* nlpSolverIn__19(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::nlpSolverIn(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* nlpSolverIn__19(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* nlpSolverIn__19(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::nlpSolverIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__20"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* nlpSolverIn__20(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >* nlpSolverIn__20(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::MX* >* nlpSolverIn__20(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::MX > ret = casadi::nlpSolverIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__21"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* nlpSolverIn__21(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::MX* >* nlpSolverIn__21(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::MX* >* nlpSolverIn__21(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::MX > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__22"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* nlpSolverIn__22(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::MX* >* nlpSolverIn__22(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::MX* >* nlpSolverIn__22(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::MX > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__23"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* nlpSolverIn__23(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::MX* >* nlpSolverIn__23(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::MX* >* nlpSolverIn__23(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::MX > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__24"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* nlpSolverIn__24(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::MX* >* nlpSolverIn__24(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::MX* >* nlpSolverIn__24(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::MX > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__25"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* nlpSolverIn__25(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::MX* >* nlpSolverIn__25(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::MX* >* nlpSolverIn__25(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::MX > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__26"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* nlpSolverIn__26(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::vector< casadi::MX* >* nlpSolverIn__26(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8);
std::vector< casadi::MX* >* nlpSolverIn__26(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);

        std::vector< casadi::MX > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__27"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* nlpSolverIn__27(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::nlpSolverIn(x0_)"
extern "C"
std::vector< casadi::SX* >* nlpSolverIn__27(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* nlpSolverIn__27(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::nlpSolverIn(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__28"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* nlpSolverIn__28(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::nlpSolverIn(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* nlpSolverIn__28(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* nlpSolverIn__28(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::nlpSolverIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__29"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* nlpSolverIn__29(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::SX* >* nlpSolverIn__29(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::SX* >* nlpSolverIn__29(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::SX > ret = casadi::nlpSolverIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__30"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* nlpSolverIn__30(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::SX* >* nlpSolverIn__30(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::SX* >* nlpSolverIn__30(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::SX > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__31"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* nlpSolverIn__31(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::SX* >* nlpSolverIn__31(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::SX* >* nlpSolverIn__31(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::SX > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__32"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* nlpSolverIn__32(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::SX* >* nlpSolverIn__32(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::SX* >* nlpSolverIn__32(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::SX > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__33"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* nlpSolverIn__33(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::SX* >* nlpSolverIn__33(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::SX* >* nlpSolverIn__33(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::SX > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__34"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* nlpSolverIn__34(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::SX* >* nlpSolverIn__34(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::SX* >* nlpSolverIn__34(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::SX > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverIn" ===============
// cppName: "casadi::nlpSolverIn"
// cWrapperName: "nlpSolverIn__35"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* nlpSolverIn__35(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// call: "casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::vector< casadi::SX* >* nlpSolverIn__35(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8);
std::vector< casadi::SX* >* nlpSolverIn__35(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);

        std::vector< casadi::SX > ret = casadi::nlpSolverIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* nlpSolverOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::nlpSolverOut(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* nlpSolverOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* nlpSolverOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::nlpSolverOut(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* nlpSolverOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::nlpSolverOut(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* nlpSolverOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* nlpSolverOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::nlpSolverOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* nlpSolverOut__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* nlpSolverOut__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* nlpSolverOut__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::nlpSolverOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* nlpSolverOut__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::Sparsity* >* nlpSolverOut__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::Sparsity* >* nlpSolverOut__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::Sparsity > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* nlpSolverOut__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::Sparsity* >* nlpSolverOut__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::Sparsity* >* nlpSolverOut__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::Sparsity > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* nlpSolverOut__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::Sparsity* >* nlpSolverOut__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::Sparsity* >* nlpSolverOut__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::Sparsity > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* nlpSolverOut__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::Sparsity* >* nlpSolverOut__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::Sparsity* >* nlpSolverOut__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::Sparsity > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* nlpSolverOut__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::nlpSolverOut(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* nlpSolverOut__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* nlpSolverOut__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::nlpSolverOut(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__8"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* nlpSolverOut__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::nlpSolverOut(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* nlpSolverOut__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* nlpSolverOut__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::nlpSolverOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__9"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* nlpSolverOut__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::DMatrix* >* nlpSolverOut__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::DMatrix* >* nlpSolverOut__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::DMatrix > ret = casadi::nlpSolverOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__10"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* nlpSolverOut__10(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::DMatrix* >* nlpSolverOut__10(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::DMatrix* >* nlpSolverOut__10(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::DMatrix > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__11"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* nlpSolverOut__11(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::DMatrix* >* nlpSolverOut__11(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::DMatrix* >* nlpSolverOut__11(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::DMatrix > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__12"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* nlpSolverOut__12(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::DMatrix* >* nlpSolverOut__12(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::DMatrix* >* nlpSolverOut__12(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::DMatrix > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__13"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* nlpSolverOut__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::DMatrix* >* nlpSolverOut__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::DMatrix* >* nlpSolverOut__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::DMatrix > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__14"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* nlpSolverOut__14(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::nlpSolverOut(x0_)"
extern "C"
std::vector< casadi::MX* >* nlpSolverOut__14(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* nlpSolverOut__14(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::nlpSolverOut(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__15"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* nlpSolverOut__15(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::nlpSolverOut(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* nlpSolverOut__15(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* nlpSolverOut__15(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::nlpSolverOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__16"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* nlpSolverOut__16(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >* nlpSolverOut__16(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::MX* >* nlpSolverOut__16(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::MX > ret = casadi::nlpSolverOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__17"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* nlpSolverOut__17(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::MX* >* nlpSolverOut__17(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::MX* >* nlpSolverOut__17(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::MX > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__18"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* nlpSolverOut__18(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::MX* >* nlpSolverOut__18(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::MX* >* nlpSolverOut__18(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::MX > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__19"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* nlpSolverOut__19(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::MX* >* nlpSolverOut__19(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::MX* >* nlpSolverOut__19(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::MX > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__20"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* nlpSolverOut__20(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::MX* >* nlpSolverOut__20(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::MX* >* nlpSolverOut__20(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::MX > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__21"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* nlpSolverOut__21(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::nlpSolverOut(x0_)"
extern "C"
std::vector< casadi::SX* >* nlpSolverOut__21(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* nlpSolverOut__21(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::nlpSolverOut(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__22"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* nlpSolverOut__22(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::nlpSolverOut(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* nlpSolverOut__22(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* nlpSolverOut__22(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::nlpSolverOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__23"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* nlpSolverOut__23(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::SX* >* nlpSolverOut__23(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::SX* >* nlpSolverOut__23(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::SX > ret = casadi::nlpSolverOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__24"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* nlpSolverOut__24(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::SX* >* nlpSolverOut__24(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::SX* >* nlpSolverOut__24(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::SX > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__25"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* nlpSolverOut__25(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::SX* >* nlpSolverOut__25(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::SX* >* nlpSolverOut__25(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::SX > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__26"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* nlpSolverOut__26(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::SX* >* nlpSolverOut__26(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::SX* >* nlpSolverOut__26(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::SX > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::nlpSolverOut" ===============
// cppName: "casadi::nlpSolverOut"
// cWrapperName: "nlpSolverOut__27"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* nlpSolverOut__27(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::SX* >* nlpSolverOut__27(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::SX* >* nlpSolverOut__27(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::SX > ret = casadi::nlpSolverOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::pinv" ===============
// cppName: "casadi::pinv"
// cWrapperName: "pinv__0"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, std::string* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX* pinv__0(std::string ** err_msg, casadi::MX* x0, std::string* x1)"
// call: "casadi::pinv(x0_, x1_)"
extern "C"
casadi::MX* pinv__0(std::string ** err_msg, casadi::MX* x0, std::string* x1);
casadi::MX* pinv__0(std::string ** err_msg, casadi::MX* x0, std::string* x1){
    try {
        casadi::MX x0_ = Marshaling<casadi::MX,casadi::MX*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        casadi::MX ret = casadi::pinv(x0_, x1_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::pinv" ===============
// cppName: "casadi::pinv"
// cWrapperName: "pinv__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX* pinv__1(std::string ** err_msg, casadi::SX* x0)"
// call: "casadi::pinv(x0_)"
extern "C"
casadi::SX* pinv__1(std::string ** err_msg, casadi::SX* x0);
casadi::SX* pinv__1(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);

        casadi::SX ret = casadi::pinv(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::pinv" ===============
// cppName: "casadi::pinv"
// cWrapperName: "pinv__2"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix* pinv__2(std::string ** err_msg, casadi::DMatrix* x0)"
// call: "casadi::pinv(x0_)"
extern "C"
casadi::DMatrix* pinv__2(std::string ** err_msg, casadi::DMatrix* x0);
casadi::DMatrix* pinv__2(std::string ** err_msg, casadi::DMatrix* x0){
    try {
        casadi::DMatrix x0_ = Marshaling<casadi::DMatrix,casadi::DMatrix*>::marshal(x0);

        casadi::DMatrix ret = casadi::pinv(x0_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::pinv" ===============
// cppName: "casadi::pinv"
// cWrapperName: "pinv__3"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix* pinv__3(std::string ** err_msg, casadi::IMatrix* x0)"
// call: "casadi::pinv(x0_)"
extern "C"
casadi::IMatrix* pinv__3(std::string ** err_msg, casadi::IMatrix* x0);
casadi::IMatrix* pinv__3(std::string ** err_msg, casadi::IMatrix* x0){
    try {
        casadi::IMatrix x0_ = Marshaling<casadi::IMatrix,casadi::IMatrix*>::marshal(x0);

        casadi::IMatrix ret = casadi::pinv(x0_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::pinv" ===============
// cppName: "casadi::pinv"
// cWrapperName: "pinv__4"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, std::string* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix* pinv__4(std::string ** err_msg, casadi::DMatrix* x0, std::string* x1)"
// call: "casadi::pinv(x0_, x1_)"
extern "C"
casadi::DMatrix* pinv__4(std::string ** err_msg, casadi::DMatrix* x0, std::string* x1);
casadi::DMatrix* pinv__4(std::string ** err_msg, casadi::DMatrix* x0, std::string* x1){
    try {
        casadi::DMatrix x0_ = Marshaling<casadi::DMatrix,casadi::DMatrix*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        casadi::DMatrix ret = casadi::pinv(x0_, x1_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::poly_coeff" ===============
// cppName: "casadi::poly_coeff"
// cWrapperName: "poly_coeff"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX* poly_coeff(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// call: "casadi::poly_coeff(x0_, x1_)"
extern "C"
casadi::SX* poly_coeff(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX* poly_coeff(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);
        casadi::SX x1_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x1);

        casadi::SX ret = casadi::poly_coeff(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::poly_roots" ===============
// cppName: "casadi::poly_roots"
// cWrapperName: "poly_roots"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX* poly_roots(std::string ** err_msg, casadi::SX* x0)"
// call: "casadi::poly_roots(x0_)"
extern "C"
casadi::SX* poly_roots(std::string ** err_msg, casadi::SX* x0);
casadi::SX* poly_roots(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);

        casadi::SX ret = casadi::poly_roots(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::printCompact" ===============
// cppName: "casadi::printCompact"
// cWrapperName: "printCompact__0"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: CVoid
// args: "(x0_)"
// cWrapperRetType: "void"
// proto: "void printCompact__0(std::string ** err_msg, casadi::MX* x0)"
// call: "casadi::printCompact(x0_)"
extern "C"
void printCompact__0(std::string ** err_msg, casadi::MX* x0);
void printCompact__0(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX x0_ = Marshaling<casadi::MX,casadi::MX*>::marshal(x0);

        casadi::printCompact(x0_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::printCompact" ===============
// cppName: "casadi::printCompact"
// cWrapperName: "printCompact__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: CVoid
// args: "(x0_)"
// cWrapperRetType: "void"
// proto: "void printCompact__1(std::string ** err_msg, casadi::SX* x0)"
// call: "casadi::printCompact(x0_)"
extern "C"
void printCompact__1(std::string ** err_msg, casadi::SX* x0);
void printCompact__1(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);

        casadi::printCompact(x0_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::pw_const" ===============
// cppName: "casadi::pw_const"
// cWrapperName: "pw_const"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX* pw_const(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2)"
// call: "casadi::pw_const(x0_, x1_, x2_)"
extern "C"
casadi::SX* pw_const(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2);
casadi::SX* pw_const(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);
        casadi::SX x1_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x1);
        casadi::SX x2_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x2);

        casadi::SX ret = casadi::pw_const(x0_, x1_, x2_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::pw_lin" ===============
// cppName: "casadi::pw_lin"
// cWrapperName: "pw_lin"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX* pw_lin(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2)"
// call: "casadi::pw_lin(x0_, x1_, x2_)"
extern "C"
casadi::SX* pw_lin(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2);
casadi::SX* pw_lin(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);
        casadi::SX x1_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x1);
        casadi::SX x2_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x2);

        casadi::SX ret = casadi::pw_lin(x0_, x1_, x2_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* qcqpIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::qcqpIn(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* qcqpIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* qcqpIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::qcqpIn(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* qcqpIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::qcqpIn(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* qcqpIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* qcqpIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::qcqpIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* qcqpIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::qcqpIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* qcqpIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* qcqpIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::qcqpIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* qcqpIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::Sparsity* >* qcqpIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::Sparsity* >* qcqpIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::Sparsity > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* qcqpIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::Sparsity* >* qcqpIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::Sparsity* >* qcqpIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::Sparsity > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* qcqpIn__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::Sparsity* >* qcqpIn__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::Sparsity* >* qcqpIn__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::Sparsity > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* qcqpIn__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::Sparsity* >* qcqpIn__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::Sparsity* >* qcqpIn__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::Sparsity > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* qcqpIn__7(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::Sparsity* >* qcqpIn__7(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::Sparsity* >* qcqpIn__7(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::Sparsity > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__8"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* qcqpIn__8(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::vector< casadi::Sparsity* >* qcqpIn__8(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8);
std::vector< casadi::Sparsity* >* qcqpIn__8(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);

        std::vector< casadi::Sparsity > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__9"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* qcqpIn__9(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::vector< casadi::Sparsity* >* qcqpIn__9(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9);
std::vector< casadi::Sparsity* >* qcqpIn__9(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);

        std::vector< casadi::Sparsity > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__10"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* qcqpIn__10(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10)"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::vector< casadi::Sparsity* >* qcqpIn__10(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10);
std::vector< casadi::Sparsity* >* qcqpIn__10(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);
        std::string x10_ = Marshaling<std::string,std::string*>::marshal(x10);

        std::vector< casadi::Sparsity > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__11"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* qcqpIn__11(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11)"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::vector< casadi::Sparsity* >* qcqpIn__11(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11);
std::vector< casadi::Sparsity* >* qcqpIn__11(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);
        std::string x10_ = Marshaling<std::string,std::string*>::marshal(x10);
        std::string x11_ = Marshaling<std::string,std::string*>::marshal(x11);

        std::vector< casadi::Sparsity > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__12"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* qcqpIn__12(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12)"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::vector< casadi::Sparsity* >* qcqpIn__12(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12);
std::vector< casadi::Sparsity* >* qcqpIn__12(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);
        std::string x10_ = Marshaling<std::string,std::string*>::marshal(x10);
        std::string x11_ = Marshaling<std::string,std::string*>::marshal(x11);
        std::string x12_ = Marshaling<std::string,std::string*>::marshal(x12);

        std::vector< casadi::Sparsity > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__13"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* qcqpIn__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::qcqpIn(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* qcqpIn__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* qcqpIn__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::qcqpIn(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__14"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* qcqpIn__14(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::qcqpIn(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* qcqpIn__14(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* qcqpIn__14(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::qcqpIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__15"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* qcqpIn__15(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::qcqpIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::DMatrix* >* qcqpIn__15(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::DMatrix* >* qcqpIn__15(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::DMatrix > ret = casadi::qcqpIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__16"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* qcqpIn__16(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::DMatrix* >* qcqpIn__16(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::DMatrix* >* qcqpIn__16(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::DMatrix > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__17"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* qcqpIn__17(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::DMatrix* >* qcqpIn__17(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::DMatrix* >* qcqpIn__17(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::DMatrix > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__18"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* qcqpIn__18(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::DMatrix* >* qcqpIn__18(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::DMatrix* >* qcqpIn__18(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::DMatrix > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__19"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* qcqpIn__19(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::DMatrix* >* qcqpIn__19(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::DMatrix* >* qcqpIn__19(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::DMatrix > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__20"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* qcqpIn__20(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::DMatrix* >* qcqpIn__20(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::DMatrix* >* qcqpIn__20(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::DMatrix > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__21"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* qcqpIn__21(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::vector< casadi::DMatrix* >* qcqpIn__21(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8);
std::vector< casadi::DMatrix* >* qcqpIn__21(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);

        std::vector< casadi::DMatrix > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__22"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* qcqpIn__22(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::vector< casadi::DMatrix* >* qcqpIn__22(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9);
std::vector< casadi::DMatrix* >* qcqpIn__22(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);

        std::vector< casadi::DMatrix > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__23"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* qcqpIn__23(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10)"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::vector< casadi::DMatrix* >* qcqpIn__23(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10);
std::vector< casadi::DMatrix* >* qcqpIn__23(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);
        std::string x10_ = Marshaling<std::string,std::string*>::marshal(x10);

        std::vector< casadi::DMatrix > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__24"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* qcqpIn__24(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11)"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::vector< casadi::DMatrix* >* qcqpIn__24(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11);
std::vector< casadi::DMatrix* >* qcqpIn__24(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);
        std::string x10_ = Marshaling<std::string,std::string*>::marshal(x10);
        std::string x11_ = Marshaling<std::string,std::string*>::marshal(x11);

        std::vector< casadi::DMatrix > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__25"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* qcqpIn__25(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12)"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::vector< casadi::DMatrix* >* qcqpIn__25(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12);
std::vector< casadi::DMatrix* >* qcqpIn__25(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);
        std::string x10_ = Marshaling<std::string,std::string*>::marshal(x10);
        std::string x11_ = Marshaling<std::string,std::string*>::marshal(x11);
        std::string x12_ = Marshaling<std::string,std::string*>::marshal(x12);

        std::vector< casadi::DMatrix > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__26"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* qcqpIn__26(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::qcqpIn(x0_)"
extern "C"
std::vector< casadi::MX* >* qcqpIn__26(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* qcqpIn__26(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::qcqpIn(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__27"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* qcqpIn__27(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::qcqpIn(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* qcqpIn__27(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* qcqpIn__27(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::qcqpIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__28"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* qcqpIn__28(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::qcqpIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >* qcqpIn__28(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::MX* >* qcqpIn__28(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::MX > ret = casadi::qcqpIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__29"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* qcqpIn__29(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::MX* >* qcqpIn__29(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::MX* >* qcqpIn__29(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::MX > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__30"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* qcqpIn__30(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::MX* >* qcqpIn__30(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::MX* >* qcqpIn__30(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::MX > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__31"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* qcqpIn__31(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::MX* >* qcqpIn__31(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::MX* >* qcqpIn__31(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::MX > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__32"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* qcqpIn__32(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::MX* >* qcqpIn__32(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::MX* >* qcqpIn__32(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::MX > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__33"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* qcqpIn__33(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::MX* >* qcqpIn__33(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::MX* >* qcqpIn__33(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::MX > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__34"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* qcqpIn__34(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::vector< casadi::MX* >* qcqpIn__34(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8);
std::vector< casadi::MX* >* qcqpIn__34(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);

        std::vector< casadi::MX > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__35"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* qcqpIn__35(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::vector< casadi::MX* >* qcqpIn__35(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9);
std::vector< casadi::MX* >* qcqpIn__35(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);

        std::vector< casadi::MX > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__36"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* qcqpIn__36(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10)"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::vector< casadi::MX* >* qcqpIn__36(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10);
std::vector< casadi::MX* >* qcqpIn__36(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);
        std::string x10_ = Marshaling<std::string,std::string*>::marshal(x10);

        std::vector< casadi::MX > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__37"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* qcqpIn__37(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11)"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::vector< casadi::MX* >* qcqpIn__37(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11);
std::vector< casadi::MX* >* qcqpIn__37(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);
        std::string x10_ = Marshaling<std::string,std::string*>::marshal(x10);
        std::string x11_ = Marshaling<std::string,std::string*>::marshal(x11);

        std::vector< casadi::MX > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__38"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* qcqpIn__38(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12)"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::vector< casadi::MX* >* qcqpIn__38(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12);
std::vector< casadi::MX* >* qcqpIn__38(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);
        std::string x10_ = Marshaling<std::string,std::string*>::marshal(x10);
        std::string x11_ = Marshaling<std::string,std::string*>::marshal(x11);
        std::string x12_ = Marshaling<std::string,std::string*>::marshal(x12);

        std::vector< casadi::MX > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__39"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* qcqpIn__39(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::qcqpIn(x0_)"
extern "C"
std::vector< casadi::SX* >* qcqpIn__39(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* qcqpIn__39(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::qcqpIn(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__40"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* qcqpIn__40(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::qcqpIn(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* qcqpIn__40(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* qcqpIn__40(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::qcqpIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__41"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* qcqpIn__41(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::qcqpIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::SX* >* qcqpIn__41(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::SX* >* qcqpIn__41(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::SX > ret = casadi::qcqpIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__42"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* qcqpIn__42(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::SX* >* qcqpIn__42(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::SX* >* qcqpIn__42(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::SX > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__43"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* qcqpIn__43(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::SX* >* qcqpIn__43(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::SX* >* qcqpIn__43(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::SX > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__44"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* qcqpIn__44(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::SX* >* qcqpIn__44(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::SX* >* qcqpIn__44(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::SX > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__45"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* qcqpIn__45(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::SX* >* qcqpIn__45(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::SX* >* qcqpIn__45(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::SX > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__46"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* qcqpIn__46(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::SX* >* qcqpIn__46(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::SX* >* qcqpIn__46(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::SX > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__47"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* qcqpIn__47(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::vector< casadi::SX* >* qcqpIn__47(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8);
std::vector< casadi::SX* >* qcqpIn__47(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);

        std::vector< casadi::SX > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__48"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* qcqpIn__48(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::vector< casadi::SX* >* qcqpIn__48(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9);
std::vector< casadi::SX* >* qcqpIn__48(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);

        std::vector< casadi::SX > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__49"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* qcqpIn__49(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10)"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::vector< casadi::SX* >* qcqpIn__49(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10);
std::vector< casadi::SX* >* qcqpIn__49(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);
        std::string x10_ = Marshaling<std::string,std::string*>::marshal(x10);

        std::vector< casadi::SX > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__50"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* qcqpIn__50(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11)"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::vector< casadi::SX* >* qcqpIn__50(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11);
std::vector< casadi::SX* >* qcqpIn__50(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);
        std::string x10_ = Marshaling<std::string,std::string*>::marshal(x10);
        std::string x11_ = Marshaling<std::string,std::string*>::marshal(x11);

        std::vector< casadi::SX > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpIn" ===============
// cppName: "casadi::qcqpIn"
// cWrapperName: "qcqpIn__51"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* qcqpIn__51(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12)"
// call: "casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::vector< casadi::SX* >* qcqpIn__51(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12);
std::vector< casadi::SX* >* qcqpIn__51(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);
        std::string x10_ = Marshaling<std::string,std::string*>::marshal(x10);
        std::string x11_ = Marshaling<std::string,std::string*>::marshal(x11);
        std::string x12_ = Marshaling<std::string,std::string*>::marshal(x12);

        std::vector< casadi::SX > ret = casadi::qcqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* qcqpOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::qcqpOut(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* qcqpOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* qcqpOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::qcqpOut(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* qcqpOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::qcqpOut(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* qcqpOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* qcqpOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::qcqpOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* qcqpOut__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::qcqpOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* qcqpOut__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* qcqpOut__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::qcqpOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* qcqpOut__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::qcqpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::Sparsity* >* qcqpOut__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::Sparsity* >* qcqpOut__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::Sparsity > ret = casadi::qcqpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* qcqpOut__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::qcqpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::Sparsity* >* qcqpOut__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::Sparsity* >* qcqpOut__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::Sparsity > ret = casadi::qcqpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* qcqpOut__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::qcqpOut(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* qcqpOut__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* qcqpOut__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::qcqpOut(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* qcqpOut__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::qcqpOut(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* qcqpOut__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* qcqpOut__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::qcqpOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* qcqpOut__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::qcqpOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::DMatrix* >* qcqpOut__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::DMatrix* >* qcqpOut__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::DMatrix > ret = casadi::qcqpOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__8"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* qcqpOut__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::qcqpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::DMatrix* >* qcqpOut__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::DMatrix* >* qcqpOut__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::DMatrix > ret = casadi::qcqpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__9"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* qcqpOut__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::qcqpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::DMatrix* >* qcqpOut__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::DMatrix* >* qcqpOut__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::DMatrix > ret = casadi::qcqpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__10"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* qcqpOut__10(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::qcqpOut(x0_)"
extern "C"
std::vector< casadi::MX* >* qcqpOut__10(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* qcqpOut__10(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::qcqpOut(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__11"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* qcqpOut__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::qcqpOut(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* qcqpOut__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* qcqpOut__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::qcqpOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__12"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* qcqpOut__12(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::qcqpOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >* qcqpOut__12(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::MX* >* qcqpOut__12(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::MX > ret = casadi::qcqpOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__13"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* qcqpOut__13(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::qcqpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::MX* >* qcqpOut__13(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::MX* >* qcqpOut__13(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::MX > ret = casadi::qcqpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__14"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* qcqpOut__14(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::qcqpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::MX* >* qcqpOut__14(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::MX* >* qcqpOut__14(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::MX > ret = casadi::qcqpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__15"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* qcqpOut__15(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::qcqpOut(x0_)"
extern "C"
std::vector< casadi::SX* >* qcqpOut__15(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* qcqpOut__15(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::qcqpOut(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__16"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* qcqpOut__16(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::qcqpOut(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* qcqpOut__16(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* qcqpOut__16(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::qcqpOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__17"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* qcqpOut__17(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::qcqpOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::SX* >* qcqpOut__17(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::SX* >* qcqpOut__17(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::SX > ret = casadi::qcqpOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__18"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* qcqpOut__18(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::qcqpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::SX* >* qcqpOut__18(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::SX* >* qcqpOut__18(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::SX > ret = casadi::qcqpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpOut" ===============
// cppName: "casadi::qcqpOut"
// cWrapperName: "qcqpOut__19"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* qcqpOut__19(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::qcqpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::SX* >* qcqpOut__19(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::SX* >* qcqpOut__19(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::SX > ret = casadi::qcqpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpStruct" ===============
// cppName: "casadi::qcqpStruct"
// cWrapperName: "qcqpStruct__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* qcqpStruct__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::qcqpStruct(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* qcqpStruct__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* qcqpStruct__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::qcqpStruct(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpStruct" ===============
// cppName: "casadi::qcqpStruct"
// cWrapperName: "qcqpStruct__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* qcqpStruct__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::qcqpStruct(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* qcqpStruct__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* qcqpStruct__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::qcqpStruct(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpStruct" ===============
// cppName: "casadi::qcqpStruct"
// cWrapperName: "qcqpStruct__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* qcqpStruct__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::qcqpStruct(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* qcqpStruct__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* qcqpStruct__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::qcqpStruct(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qcqpStruct" ===============
// cppName: "casadi::qcqpStruct"
// cWrapperName: "qcqpStruct__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* qcqpStruct__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::qcqpStruct(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::Sparsity* >* qcqpStruct__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::Sparsity* >* qcqpStruct__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::Sparsity > ret = casadi::qcqpStruct(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* qpIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::qpIn(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* qpIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* qpIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::qpIn(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* qpIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::qpIn(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* qpIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* qpIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::qpIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* qpIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::qpIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* qpIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* qpIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::qpIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* qpIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::Sparsity* >* qpIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::Sparsity* >* qpIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::Sparsity > ret = casadi::qpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* qpIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::Sparsity* >* qpIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::Sparsity* >* qpIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::Sparsity > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* qpIn__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::Sparsity* >* qpIn__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::Sparsity* >* qpIn__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::Sparsity > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* qpIn__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::Sparsity* >* qpIn__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::Sparsity* >* qpIn__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::Sparsity > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* qpIn__7(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::Sparsity* >* qpIn__7(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::Sparsity* >* qpIn__7(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::Sparsity > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__8"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* qpIn__8(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::vector< casadi::Sparsity* >* qpIn__8(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8);
std::vector< casadi::Sparsity* >* qpIn__8(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);

        std::vector< casadi::Sparsity > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__9"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* qpIn__9(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::vector< casadi::Sparsity* >* qpIn__9(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9);
std::vector< casadi::Sparsity* >* qpIn__9(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);

        std::vector< casadi::Sparsity > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__10"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* qpIn__10(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::qpIn(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* qpIn__10(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* qpIn__10(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::qpIn(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__11"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* qpIn__11(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::qpIn(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* qpIn__11(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* qpIn__11(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::qpIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__12"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* qpIn__12(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::qpIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::DMatrix* >* qpIn__12(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::DMatrix* >* qpIn__12(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::DMatrix > ret = casadi::qpIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__13"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* qpIn__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::DMatrix* >* qpIn__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::DMatrix* >* qpIn__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::DMatrix > ret = casadi::qpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__14"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* qpIn__14(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::DMatrix* >* qpIn__14(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::DMatrix* >* qpIn__14(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::DMatrix > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__15"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* qpIn__15(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::DMatrix* >* qpIn__15(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::DMatrix* >* qpIn__15(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::DMatrix > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__16"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* qpIn__16(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::DMatrix* >* qpIn__16(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::DMatrix* >* qpIn__16(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::DMatrix > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__17"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* qpIn__17(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::DMatrix* >* qpIn__17(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::DMatrix* >* qpIn__17(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::DMatrix > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__18"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* qpIn__18(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::vector< casadi::DMatrix* >* qpIn__18(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8);
std::vector< casadi::DMatrix* >* qpIn__18(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);

        std::vector< casadi::DMatrix > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__19"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* qpIn__19(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::vector< casadi::DMatrix* >* qpIn__19(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9);
std::vector< casadi::DMatrix* >* qpIn__19(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);

        std::vector< casadi::DMatrix > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__20"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* qpIn__20(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::qpIn(x0_)"
extern "C"
std::vector< casadi::MX* >* qpIn__20(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* qpIn__20(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::qpIn(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__21"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* qpIn__21(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::qpIn(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* qpIn__21(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* qpIn__21(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::qpIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__22"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* qpIn__22(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::qpIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >* qpIn__22(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::MX* >* qpIn__22(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::MX > ret = casadi::qpIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__23"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* qpIn__23(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::MX* >* qpIn__23(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::MX* >* qpIn__23(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::MX > ret = casadi::qpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__24"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* qpIn__24(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::MX* >* qpIn__24(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::MX* >* qpIn__24(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::MX > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__25"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* qpIn__25(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::MX* >* qpIn__25(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::MX* >* qpIn__25(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::MX > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__26"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* qpIn__26(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::MX* >* qpIn__26(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::MX* >* qpIn__26(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::MX > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__27"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* qpIn__27(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::MX* >* qpIn__27(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::MX* >* qpIn__27(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::MX > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__28"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* qpIn__28(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::vector< casadi::MX* >* qpIn__28(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8);
std::vector< casadi::MX* >* qpIn__28(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);

        std::vector< casadi::MX > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__29"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* qpIn__29(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::vector< casadi::MX* >* qpIn__29(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9);
std::vector< casadi::MX* >* qpIn__29(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);

        std::vector< casadi::MX > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__30"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* qpIn__30(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::qpIn(x0_)"
extern "C"
std::vector< casadi::SX* >* qpIn__30(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* qpIn__30(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::qpIn(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__31"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* qpIn__31(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::qpIn(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* qpIn__31(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* qpIn__31(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::qpIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__32"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* qpIn__32(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::qpIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::SX* >* qpIn__32(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::SX* >* qpIn__32(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::SX > ret = casadi::qpIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__33"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* qpIn__33(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::SX* >* qpIn__33(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::SX* >* qpIn__33(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::SX > ret = casadi::qpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__34"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* qpIn__34(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::SX* >* qpIn__34(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::SX* >* qpIn__34(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::SX > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__35"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* qpIn__35(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::SX* >* qpIn__35(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::SX* >* qpIn__35(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::SX > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__36"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* qpIn__36(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::SX* >* qpIn__36(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::SX* >* qpIn__36(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::SX > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__37"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* qpIn__37(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::SX* >* qpIn__37(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::SX* >* qpIn__37(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::SX > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__38"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* qpIn__38(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::vector< casadi::SX* >* qpIn__38(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8);
std::vector< casadi::SX* >* qpIn__38(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);

        std::vector< casadi::SX > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpIn" ===============
// cppName: "casadi::qpIn"
// cWrapperName: "qpIn__39"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* qpIn__39(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// call: "casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::vector< casadi::SX* >* qpIn__39(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9);
std::vector< casadi::SX* >* qpIn__39(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);

        std::vector< casadi::SX > ret = casadi::qpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* qpOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::qpOut(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* qpOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* qpOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::qpOut(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* qpOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::qpOut(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* qpOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* qpOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::qpOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* qpOut__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::qpOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* qpOut__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* qpOut__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::qpOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* qpOut__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::qpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::Sparsity* >* qpOut__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::Sparsity* >* qpOut__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::Sparsity > ret = casadi::qpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* qpOut__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::qpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::Sparsity* >* qpOut__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::Sparsity* >* qpOut__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::Sparsity > ret = casadi::qpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* qpOut__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::qpOut(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* qpOut__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* qpOut__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::qpOut(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* qpOut__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::qpOut(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* qpOut__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* qpOut__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::qpOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* qpOut__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::qpOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::DMatrix* >* qpOut__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::DMatrix* >* qpOut__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::DMatrix > ret = casadi::qpOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__8"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* qpOut__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::qpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::DMatrix* >* qpOut__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::DMatrix* >* qpOut__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::DMatrix > ret = casadi::qpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__9"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* qpOut__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::qpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::DMatrix* >* qpOut__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::DMatrix* >* qpOut__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::DMatrix > ret = casadi::qpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__10"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* qpOut__10(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::qpOut(x0_)"
extern "C"
std::vector< casadi::MX* >* qpOut__10(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* qpOut__10(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::qpOut(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__11"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* qpOut__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::qpOut(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* qpOut__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* qpOut__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::qpOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__12"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* qpOut__12(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::qpOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >* qpOut__12(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::MX* >* qpOut__12(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::MX > ret = casadi::qpOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__13"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* qpOut__13(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::qpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::MX* >* qpOut__13(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::MX* >* qpOut__13(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::MX > ret = casadi::qpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__14"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* qpOut__14(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::qpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::MX* >* qpOut__14(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::MX* >* qpOut__14(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::MX > ret = casadi::qpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__15"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* qpOut__15(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::qpOut(x0_)"
extern "C"
std::vector< casadi::SX* >* qpOut__15(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* qpOut__15(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::qpOut(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__16"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* qpOut__16(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::qpOut(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* qpOut__16(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* qpOut__16(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::qpOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__17"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* qpOut__17(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::qpOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::SX* >* qpOut__17(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::SX* >* qpOut__17(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::SX > ret = casadi::qpOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__18"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* qpOut__18(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::qpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::SX* >* qpOut__18(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::SX* >* qpOut__18(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::SX > ret = casadi::qpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpOut" ===============
// cppName: "casadi::qpOut"
// cWrapperName: "qpOut__19"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* qpOut__19(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::qpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::SX* >* qpOut__19(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::SX* >* qpOut__19(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::SX > ret = casadi::qpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpStruct" ===============
// cppName: "casadi::qpStruct"
// cWrapperName: "qpStruct__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* qpStruct__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::qpStruct(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* qpStruct__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* qpStruct__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::qpStruct(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpStruct" ===============
// cppName: "casadi::qpStruct"
// cWrapperName: "qpStruct__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* qpStruct__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::qpStruct(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* qpStruct__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* qpStruct__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::qpStruct(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::qpStruct" ===============
// cppName: "casadi::qpStruct"
// cWrapperName: "qpStruct__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* qpStruct__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::qpStruct(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* qpStruct__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* qpStruct__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::qpStruct(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::ramp" ===============
// cppName: "casadi::ramp"
// cWrapperName: "ramp"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX* ramp(std::string ** err_msg, casadi::SX* x0)"
// call: "casadi::ramp(x0_)"
extern "C"
casadi::SX* ramp(std::string ** err_msg, casadi::SX* x0);
casadi::SX* ramp(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);

        casadi::SX ret = casadi::ramp(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* rdaeIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::rdaeIn(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* rdaeIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* rdaeIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::rdaeIn(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* rdaeIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::rdaeIn(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* rdaeIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* rdaeIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::rdaeIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* rdaeIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::rdaeIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* rdaeIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* rdaeIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::rdaeIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* rdaeIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::Sparsity* >* rdaeIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::Sparsity* >* rdaeIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::Sparsity > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* rdaeIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::Sparsity* >* rdaeIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::Sparsity* >* rdaeIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::Sparsity > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* rdaeIn__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::Sparsity* >* rdaeIn__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::Sparsity* >* rdaeIn__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::Sparsity > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* rdaeIn__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::Sparsity* >* rdaeIn__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::Sparsity* >* rdaeIn__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::Sparsity > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* rdaeIn__7(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::Sparsity* >* rdaeIn__7(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::Sparsity* >* rdaeIn__7(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::Sparsity > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__8"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* rdaeIn__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::rdaeIn(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* rdaeIn__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* rdaeIn__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::rdaeIn(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__9"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* rdaeIn__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::rdaeIn(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* rdaeIn__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* rdaeIn__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::rdaeIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__10"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* rdaeIn__10(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::rdaeIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::DMatrix* >* rdaeIn__10(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::DMatrix* >* rdaeIn__10(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::DMatrix > ret = casadi::rdaeIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__11"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* rdaeIn__11(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::DMatrix* >* rdaeIn__11(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::DMatrix* >* rdaeIn__11(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::DMatrix > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__12"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* rdaeIn__12(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::DMatrix* >* rdaeIn__12(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::DMatrix* >* rdaeIn__12(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::DMatrix > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__13"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* rdaeIn__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::DMatrix* >* rdaeIn__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::DMatrix* >* rdaeIn__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::DMatrix > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__14"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* rdaeIn__14(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::DMatrix* >* rdaeIn__14(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::DMatrix* >* rdaeIn__14(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::DMatrix > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__15"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* rdaeIn__15(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::DMatrix* >* rdaeIn__15(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::DMatrix* >* rdaeIn__15(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::DMatrix > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__16"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* rdaeIn__16(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::rdaeIn(x0_)"
extern "C"
std::vector< casadi::MX* >* rdaeIn__16(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* rdaeIn__16(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::rdaeIn(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__17"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* rdaeIn__17(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::rdaeIn(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* rdaeIn__17(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* rdaeIn__17(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::rdaeIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__18"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* rdaeIn__18(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::rdaeIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >* rdaeIn__18(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::MX* >* rdaeIn__18(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::MX > ret = casadi::rdaeIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__19"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* rdaeIn__19(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::MX* >* rdaeIn__19(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::MX* >* rdaeIn__19(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::MX > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__20"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* rdaeIn__20(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::MX* >* rdaeIn__20(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::MX* >* rdaeIn__20(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::MX > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__21"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* rdaeIn__21(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::MX* >* rdaeIn__21(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::MX* >* rdaeIn__21(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::MX > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__22"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* rdaeIn__22(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::MX* >* rdaeIn__22(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::MX* >* rdaeIn__22(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::MX > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__23"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* rdaeIn__23(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::MX* >* rdaeIn__23(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::MX* >* rdaeIn__23(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::MX > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__24"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* rdaeIn__24(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::rdaeIn(x0_)"
extern "C"
std::vector< casadi::SX* >* rdaeIn__24(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* rdaeIn__24(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::rdaeIn(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__25"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* rdaeIn__25(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::rdaeIn(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* rdaeIn__25(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* rdaeIn__25(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::rdaeIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__26"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* rdaeIn__26(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::rdaeIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::SX* >* rdaeIn__26(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::SX* >* rdaeIn__26(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::SX > ret = casadi::rdaeIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__27"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* rdaeIn__27(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::SX* >* rdaeIn__27(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::SX* >* rdaeIn__27(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::SX > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__28"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* rdaeIn__28(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::SX* >* rdaeIn__28(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::SX* >* rdaeIn__28(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::SX > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__29"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* rdaeIn__29(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::SX* >* rdaeIn__29(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::SX* >* rdaeIn__29(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::SX > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__30"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* rdaeIn__30(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::SX* >* rdaeIn__30(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::SX* >* rdaeIn__30(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::SX > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeIn" ===============
// cppName: "casadi::rdaeIn"
// cWrapperName: "rdaeIn__31"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* rdaeIn__31(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::SX* >* rdaeIn__31(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::SX* >* rdaeIn__31(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::SX > ret = casadi::rdaeIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeOut" ===============
// cppName: "casadi::rdaeOut"
// cWrapperName: "rdaeOut__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* rdaeOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::rdaeOut(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* rdaeOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* rdaeOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::rdaeOut(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeOut" ===============
// cppName: "casadi::rdaeOut"
// cWrapperName: "rdaeOut__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* rdaeOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::rdaeOut(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* rdaeOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* rdaeOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::rdaeOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeOut" ===============
// cppName: "casadi::rdaeOut"
// cWrapperName: "rdaeOut__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* rdaeOut__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::rdaeOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* rdaeOut__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* rdaeOut__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::rdaeOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeOut" ===============
// cppName: "casadi::rdaeOut"
// cWrapperName: "rdaeOut__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* rdaeOut__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::rdaeOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::Sparsity* >* rdaeOut__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::Sparsity* >* rdaeOut__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::Sparsity > ret = casadi::rdaeOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeOut" ===============
// cppName: "casadi::rdaeOut"
// cWrapperName: "rdaeOut__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* rdaeOut__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::rdaeOut(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* rdaeOut__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* rdaeOut__4(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::rdaeOut(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeOut" ===============
// cppName: "casadi::rdaeOut"
// cWrapperName: "rdaeOut__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* rdaeOut__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::rdaeOut(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* rdaeOut__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* rdaeOut__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::rdaeOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeOut" ===============
// cppName: "casadi::rdaeOut"
// cWrapperName: "rdaeOut__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* rdaeOut__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::rdaeOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::DMatrix* >* rdaeOut__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::DMatrix* >* rdaeOut__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::DMatrix > ret = casadi::rdaeOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeOut" ===============
// cppName: "casadi::rdaeOut"
// cWrapperName: "rdaeOut__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* rdaeOut__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::rdaeOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::DMatrix* >* rdaeOut__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::DMatrix* >* rdaeOut__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::DMatrix > ret = casadi::rdaeOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeOut" ===============
// cppName: "casadi::rdaeOut"
// cWrapperName: "rdaeOut__8"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* rdaeOut__8(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::rdaeOut(x0_)"
extern "C"
std::vector< casadi::MX* >* rdaeOut__8(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* rdaeOut__8(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::rdaeOut(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeOut" ===============
// cppName: "casadi::rdaeOut"
// cWrapperName: "rdaeOut__9"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* rdaeOut__9(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::rdaeOut(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* rdaeOut__9(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* rdaeOut__9(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::rdaeOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeOut" ===============
// cppName: "casadi::rdaeOut"
// cWrapperName: "rdaeOut__10"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* rdaeOut__10(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::rdaeOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >* rdaeOut__10(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::MX* >* rdaeOut__10(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::MX > ret = casadi::rdaeOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeOut" ===============
// cppName: "casadi::rdaeOut"
// cWrapperName: "rdaeOut__11"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* rdaeOut__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::rdaeOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::MX* >* rdaeOut__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::MX* >* rdaeOut__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::MX > ret = casadi::rdaeOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeOut" ===============
// cppName: "casadi::rdaeOut"
// cWrapperName: "rdaeOut__12"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* rdaeOut__12(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::rdaeOut(x0_)"
extern "C"
std::vector< casadi::SX* >* rdaeOut__12(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* rdaeOut__12(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::rdaeOut(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeOut" ===============
// cppName: "casadi::rdaeOut"
// cWrapperName: "rdaeOut__13"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* rdaeOut__13(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::rdaeOut(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* rdaeOut__13(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* rdaeOut__13(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::rdaeOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeOut" ===============
// cppName: "casadi::rdaeOut"
// cWrapperName: "rdaeOut__14"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* rdaeOut__14(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::rdaeOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::SX* >* rdaeOut__14(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::SX* >* rdaeOut__14(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::SX > ret = casadi::rdaeOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rdaeOut" ===============
// cppName: "casadi::rdaeOut"
// cWrapperName: "rdaeOut__15"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* rdaeOut__15(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::rdaeOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::SX* >* rdaeOut__15(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::SX* >* rdaeOut__15(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::SX > ret = casadi::rdaeOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::rectangle" ===============
// cppName: "casadi::rectangle"
// cWrapperName: "rectangle"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX* rectangle(std::string ** err_msg, casadi::SX* x0)"
// call: "casadi::rectangle(x0_)"
extern "C"
casadi::SX* rectangle(std::string ** err_msg, casadi::SX* x0);
casadi::SX* rectangle(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);

        casadi::SX ret = casadi::rectangle(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdpIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::sdpIn(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* sdpIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* sdpIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::sdpIn(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdpIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::sdpIn(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* sdpIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* sdpIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::sdpIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdpIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::sdpIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* sdpIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* sdpIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::sdpIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdpIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::Sparsity* >* sdpIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::Sparsity* >* sdpIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::Sparsity > ret = casadi::sdpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdpIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::Sparsity* >* sdpIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::Sparsity* >* sdpIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::Sparsity > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdpIn__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::Sparsity* >* sdpIn__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::Sparsity* >* sdpIn__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::Sparsity > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdpIn__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::Sparsity* >* sdpIn__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::Sparsity* >* sdpIn__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::Sparsity > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdpIn__7(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::Sparsity* >* sdpIn__7(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::Sparsity* >* sdpIn__7(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::Sparsity > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__8"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdpIn__8(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::vector< casadi::Sparsity* >* sdpIn__8(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8);
std::vector< casadi::Sparsity* >* sdpIn__8(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);

        std::vector< casadi::Sparsity > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__9"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* sdpIn__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::sdpIn(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* sdpIn__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* sdpIn__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::sdpIn(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__10"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* sdpIn__10(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::sdpIn(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* sdpIn__10(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* sdpIn__10(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::sdpIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__11"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* sdpIn__11(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::sdpIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::DMatrix* >* sdpIn__11(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::DMatrix* >* sdpIn__11(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::DMatrix > ret = casadi::sdpIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__12"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* sdpIn__12(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::DMatrix* >* sdpIn__12(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::DMatrix* >* sdpIn__12(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::DMatrix > ret = casadi::sdpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__13"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* sdpIn__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::DMatrix* >* sdpIn__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::DMatrix* >* sdpIn__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::DMatrix > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__14"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* sdpIn__14(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::DMatrix* >* sdpIn__14(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::DMatrix* >* sdpIn__14(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::DMatrix > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__15"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* sdpIn__15(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::DMatrix* >* sdpIn__15(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::DMatrix* >* sdpIn__15(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::DMatrix > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__16"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* sdpIn__16(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::DMatrix* >* sdpIn__16(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::DMatrix* >* sdpIn__16(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::DMatrix > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__17"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* sdpIn__17(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::vector< casadi::DMatrix* >* sdpIn__17(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8);
std::vector< casadi::DMatrix* >* sdpIn__17(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);

        std::vector< casadi::DMatrix > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__18"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* sdpIn__18(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::sdpIn(x0_)"
extern "C"
std::vector< casadi::MX* >* sdpIn__18(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* sdpIn__18(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::sdpIn(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__19"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* sdpIn__19(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::sdpIn(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* sdpIn__19(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* sdpIn__19(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::sdpIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__20"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* sdpIn__20(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::sdpIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >* sdpIn__20(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::MX* >* sdpIn__20(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::MX > ret = casadi::sdpIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__21"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* sdpIn__21(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::MX* >* sdpIn__21(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::MX* >* sdpIn__21(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::MX > ret = casadi::sdpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__22"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* sdpIn__22(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::MX* >* sdpIn__22(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::MX* >* sdpIn__22(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::MX > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__23"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* sdpIn__23(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::MX* >* sdpIn__23(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::MX* >* sdpIn__23(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::MX > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__24"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* sdpIn__24(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::MX* >* sdpIn__24(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::MX* >* sdpIn__24(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::MX > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__25"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* sdpIn__25(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::MX* >* sdpIn__25(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::MX* >* sdpIn__25(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::MX > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__26"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* sdpIn__26(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::vector< casadi::MX* >* sdpIn__26(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8);
std::vector< casadi::MX* >* sdpIn__26(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);

        std::vector< casadi::MX > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__27"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* sdpIn__27(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::sdpIn(x0_)"
extern "C"
std::vector< casadi::SX* >* sdpIn__27(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* sdpIn__27(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::sdpIn(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__28"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* sdpIn__28(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::sdpIn(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* sdpIn__28(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* sdpIn__28(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::sdpIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__29"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* sdpIn__29(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::sdpIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::SX* >* sdpIn__29(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::SX* >* sdpIn__29(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::SX > ret = casadi::sdpIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__30"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* sdpIn__30(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::SX* >* sdpIn__30(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::SX* >* sdpIn__30(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::SX > ret = casadi::sdpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__31"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* sdpIn__31(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::SX* >* sdpIn__31(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::SX* >* sdpIn__31(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::SX > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__32"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* sdpIn__32(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::SX* >* sdpIn__32(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::SX* >* sdpIn__32(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::SX > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__33"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* sdpIn__33(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::SX* >* sdpIn__33(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::SX* >* sdpIn__33(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::SX > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__34"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* sdpIn__34(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::SX* >* sdpIn__34(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::SX* >* sdpIn__34(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::SX > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpIn" ===============
// cppName: "casadi::sdpIn"
// cWrapperName: "sdpIn__35"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* sdpIn__35(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// call: "casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::vector< casadi::SX* >* sdpIn__35(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8);
std::vector< casadi::SX* >* sdpIn__35(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);

        std::vector< casadi::SX > ret = casadi::sdpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdpOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::sdpOut(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* sdpOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* sdpOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::sdpOut(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdpOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::sdpOut(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* sdpOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* sdpOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::sdpOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdpOut__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::sdpOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* sdpOut__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* sdpOut__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::sdpOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdpOut__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::Sparsity* >* sdpOut__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::Sparsity* >* sdpOut__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::Sparsity > ret = casadi::sdpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdpOut__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::Sparsity* >* sdpOut__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::Sparsity* >* sdpOut__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::Sparsity > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdpOut__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::Sparsity* >* sdpOut__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::Sparsity* >* sdpOut__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::Sparsity > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdpOut__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::Sparsity* >* sdpOut__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::Sparsity* >* sdpOut__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::Sparsity > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdpOut__7(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::Sparsity* >* sdpOut__7(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::Sparsity* >* sdpOut__7(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::Sparsity > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__8"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* sdpOut__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::sdpOut(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* sdpOut__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* sdpOut__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::sdpOut(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__9"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* sdpOut__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::sdpOut(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* sdpOut__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* sdpOut__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::sdpOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__10"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* sdpOut__10(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::sdpOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::DMatrix* >* sdpOut__10(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::DMatrix* >* sdpOut__10(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::DMatrix > ret = casadi::sdpOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__11"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* sdpOut__11(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::DMatrix* >* sdpOut__11(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::DMatrix* >* sdpOut__11(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::DMatrix > ret = casadi::sdpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__12"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* sdpOut__12(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::DMatrix* >* sdpOut__12(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::DMatrix* >* sdpOut__12(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::DMatrix > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__13"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* sdpOut__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::DMatrix* >* sdpOut__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::DMatrix* >* sdpOut__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::DMatrix > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__14"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* sdpOut__14(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::DMatrix* >* sdpOut__14(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::DMatrix* >* sdpOut__14(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::DMatrix > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__15"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* sdpOut__15(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::DMatrix* >* sdpOut__15(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::DMatrix* >* sdpOut__15(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::DMatrix > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__16"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* sdpOut__16(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::sdpOut(x0_)"
extern "C"
std::vector< casadi::MX* >* sdpOut__16(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* sdpOut__16(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::sdpOut(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__17"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* sdpOut__17(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::sdpOut(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* sdpOut__17(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* sdpOut__17(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::sdpOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__18"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* sdpOut__18(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::sdpOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >* sdpOut__18(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::MX* >* sdpOut__18(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::MX > ret = casadi::sdpOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__19"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* sdpOut__19(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::MX* >* sdpOut__19(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::MX* >* sdpOut__19(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::MX > ret = casadi::sdpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__20"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* sdpOut__20(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::MX* >* sdpOut__20(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::MX* >* sdpOut__20(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::MX > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__21"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* sdpOut__21(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::MX* >* sdpOut__21(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::MX* >* sdpOut__21(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::MX > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__22"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* sdpOut__22(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::MX* >* sdpOut__22(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::MX* >* sdpOut__22(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::MX > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__23"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* sdpOut__23(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::MX* >* sdpOut__23(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::MX* >* sdpOut__23(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::MX > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__24"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* sdpOut__24(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::sdpOut(x0_)"
extern "C"
std::vector< casadi::SX* >* sdpOut__24(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* sdpOut__24(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::sdpOut(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__25"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* sdpOut__25(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::sdpOut(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* sdpOut__25(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* sdpOut__25(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::sdpOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__26"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* sdpOut__26(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::sdpOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::SX* >* sdpOut__26(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::SX* >* sdpOut__26(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::SX > ret = casadi::sdpOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__27"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* sdpOut__27(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::SX* >* sdpOut__27(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::SX* >* sdpOut__27(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::SX > ret = casadi::sdpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__28"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* sdpOut__28(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::SX* >* sdpOut__28(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::SX* >* sdpOut__28(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::SX > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__29"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* sdpOut__29(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::SX* >* sdpOut__29(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::SX* >* sdpOut__29(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::SX > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__30"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* sdpOut__30(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::SX* >* sdpOut__30(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::SX* >* sdpOut__30(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::SX > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpOut" ===============
// cppName: "casadi::sdpOut"
// cWrapperName: "sdpOut__31"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* sdpOut__31(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::SX* >* sdpOut__31(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::SX* >* sdpOut__31(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::SX > ret = casadi::sdpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpStruct" ===============
// cppName: "casadi::sdpStruct"
// cWrapperName: "sdpStruct__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdpStruct__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::sdpStruct(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* sdpStruct__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* sdpStruct__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::sdpStruct(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpStruct" ===============
// cppName: "casadi::sdpStruct"
// cWrapperName: "sdpStruct__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdpStruct__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::sdpStruct(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* sdpStruct__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* sdpStruct__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::sdpStruct(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpStruct" ===============
// cppName: "casadi::sdpStruct"
// cWrapperName: "sdpStruct__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdpStruct__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::sdpStruct(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* sdpStruct__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* sdpStruct__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::sdpStruct(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdpStruct" ===============
// cppName: "casadi::sdpStruct"
// cWrapperName: "sdpStruct__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdpStruct__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::sdpStruct(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::Sparsity* >* sdpStruct__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::Sparsity* >* sdpStruct__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::Sparsity > ret = casadi::sdpStruct(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdqpIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::sdqpIn(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* sdqpIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* sdqpIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::sdqpIn(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdqpIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::sdqpIn(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* sdqpIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* sdqpIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::sdqpIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdqpIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::sdqpIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* sdqpIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* sdqpIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::sdqpIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdqpIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::Sparsity* >* sdqpIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::Sparsity* >* sdqpIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::Sparsity > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdqpIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::Sparsity* >* sdqpIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::Sparsity* >* sdqpIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::Sparsity > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdqpIn__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::Sparsity* >* sdqpIn__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::Sparsity* >* sdqpIn__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::Sparsity > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdqpIn__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::Sparsity* >* sdqpIn__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::Sparsity* >* sdqpIn__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::Sparsity > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdqpIn__7(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::Sparsity* >* sdqpIn__7(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::Sparsity* >* sdqpIn__7(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::Sparsity > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__8"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdqpIn__8(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::vector< casadi::Sparsity* >* sdqpIn__8(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8);
std::vector< casadi::Sparsity* >* sdqpIn__8(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);

        std::vector< casadi::Sparsity > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__9"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdqpIn__9(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::vector< casadi::Sparsity* >* sdqpIn__9(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9);
std::vector< casadi::Sparsity* >* sdqpIn__9(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);

        std::vector< casadi::Sparsity > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__10"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* sdqpIn__10(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::sdqpIn(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* sdqpIn__10(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* sdqpIn__10(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::sdqpIn(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__11"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* sdqpIn__11(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::sdqpIn(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* sdqpIn__11(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* sdqpIn__11(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::sdqpIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__12"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* sdqpIn__12(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::sdqpIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::DMatrix* >* sdqpIn__12(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::DMatrix* >* sdqpIn__12(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::DMatrix > ret = casadi::sdqpIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__13"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* sdqpIn__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::DMatrix* >* sdqpIn__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::DMatrix* >* sdqpIn__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::DMatrix > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__14"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* sdqpIn__14(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::DMatrix* >* sdqpIn__14(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::DMatrix* >* sdqpIn__14(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::DMatrix > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__15"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* sdqpIn__15(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::DMatrix* >* sdqpIn__15(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::DMatrix* >* sdqpIn__15(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::DMatrix > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__16"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* sdqpIn__16(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::DMatrix* >* sdqpIn__16(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::DMatrix* >* sdqpIn__16(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::DMatrix > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__17"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* sdqpIn__17(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::DMatrix* >* sdqpIn__17(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::DMatrix* >* sdqpIn__17(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::DMatrix > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__18"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* sdqpIn__18(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::vector< casadi::DMatrix* >* sdqpIn__18(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8);
std::vector< casadi::DMatrix* >* sdqpIn__18(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);

        std::vector< casadi::DMatrix > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__19"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* sdqpIn__19(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::vector< casadi::DMatrix* >* sdqpIn__19(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9);
std::vector< casadi::DMatrix* >* sdqpIn__19(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);

        std::vector< casadi::DMatrix > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__20"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* sdqpIn__20(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::sdqpIn(x0_)"
extern "C"
std::vector< casadi::MX* >* sdqpIn__20(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* sdqpIn__20(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::sdqpIn(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__21"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* sdqpIn__21(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::sdqpIn(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* sdqpIn__21(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* sdqpIn__21(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::sdqpIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__22"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* sdqpIn__22(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::sdqpIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >* sdqpIn__22(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::MX* >* sdqpIn__22(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::MX > ret = casadi::sdqpIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__23"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* sdqpIn__23(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::MX* >* sdqpIn__23(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::MX* >* sdqpIn__23(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::MX > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__24"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* sdqpIn__24(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::MX* >* sdqpIn__24(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::MX* >* sdqpIn__24(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::MX > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__25"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* sdqpIn__25(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::MX* >* sdqpIn__25(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::MX* >* sdqpIn__25(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::MX > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__26"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* sdqpIn__26(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::MX* >* sdqpIn__26(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::MX* >* sdqpIn__26(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::MX > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__27"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* sdqpIn__27(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::MX* >* sdqpIn__27(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::MX* >* sdqpIn__27(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::MX > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__28"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* sdqpIn__28(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::vector< casadi::MX* >* sdqpIn__28(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8);
std::vector< casadi::MX* >* sdqpIn__28(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);

        std::vector< casadi::MX > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__29"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* sdqpIn__29(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::vector< casadi::MX* >* sdqpIn__29(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9);
std::vector< casadi::MX* >* sdqpIn__29(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);

        std::vector< casadi::MX > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__30"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* sdqpIn__30(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::sdqpIn(x0_)"
extern "C"
std::vector< casadi::SX* >* sdqpIn__30(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* sdqpIn__30(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::sdqpIn(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__31"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* sdqpIn__31(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::sdqpIn(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* sdqpIn__31(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* sdqpIn__31(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::sdqpIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__32"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* sdqpIn__32(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::sdqpIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::SX* >* sdqpIn__32(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::SX* >* sdqpIn__32(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::SX > ret = casadi::sdqpIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__33"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* sdqpIn__33(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::SX* >* sdqpIn__33(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::SX* >* sdqpIn__33(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::SX > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__34"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* sdqpIn__34(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::SX* >* sdqpIn__34(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::SX* >* sdqpIn__34(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::SX > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__35"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* sdqpIn__35(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::SX* >* sdqpIn__35(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::SX* >* sdqpIn__35(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::SX > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__36"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* sdqpIn__36(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::SX* >* sdqpIn__36(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::SX* >* sdqpIn__36(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::SX > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__37"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* sdqpIn__37(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::SX* >* sdqpIn__37(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::SX* >* sdqpIn__37(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::SX > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__38"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* sdqpIn__38(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::vector< casadi::SX* >* sdqpIn__38(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8);
std::vector< casadi::SX* >* sdqpIn__38(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);

        std::vector< casadi::SX > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpIn" ===============
// cppName: "casadi::sdqpIn"
// cWrapperName: "sdqpIn__39"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* sdqpIn__39(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// call: "casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::vector< casadi::SX* >* sdqpIn__39(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9);
std::vector< casadi::SX* >* sdqpIn__39(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);

        std::vector< casadi::SX > ret = casadi::sdqpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdqpOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::sdqpOut(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* sdqpOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* sdqpOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::sdqpOut(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdqpOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::sdqpOut(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* sdqpOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* sdqpOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::sdqpOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdqpOut__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::sdqpOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* sdqpOut__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* sdqpOut__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::sdqpOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdqpOut__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::Sparsity* >* sdqpOut__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::Sparsity* >* sdqpOut__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::Sparsity > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdqpOut__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::Sparsity* >* sdqpOut__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::Sparsity* >* sdqpOut__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::Sparsity > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdqpOut__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::Sparsity* >* sdqpOut__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::Sparsity* >* sdqpOut__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::Sparsity > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdqpOut__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::Sparsity* >* sdqpOut__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::Sparsity* >* sdqpOut__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::Sparsity > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdqpOut__7(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::Sparsity* >* sdqpOut__7(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::Sparsity* >* sdqpOut__7(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::Sparsity > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__8"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* sdqpOut__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::sdqpOut(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* sdqpOut__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* sdqpOut__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::sdqpOut(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__9"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* sdqpOut__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::sdqpOut(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* sdqpOut__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* sdqpOut__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::sdqpOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__10"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* sdqpOut__10(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::sdqpOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::DMatrix* >* sdqpOut__10(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::DMatrix* >* sdqpOut__10(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::DMatrix > ret = casadi::sdqpOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__11"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* sdqpOut__11(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::DMatrix* >* sdqpOut__11(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::DMatrix* >* sdqpOut__11(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::DMatrix > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__12"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* sdqpOut__12(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::DMatrix* >* sdqpOut__12(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::DMatrix* >* sdqpOut__12(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::DMatrix > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__13"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* sdqpOut__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::DMatrix* >* sdqpOut__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::DMatrix* >* sdqpOut__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::DMatrix > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__14"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* sdqpOut__14(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::DMatrix* >* sdqpOut__14(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::DMatrix* >* sdqpOut__14(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::DMatrix > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__15"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* sdqpOut__15(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::DMatrix* >* sdqpOut__15(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::DMatrix* >* sdqpOut__15(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::DMatrix > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__16"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* sdqpOut__16(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::sdqpOut(x0_)"
extern "C"
std::vector< casadi::MX* >* sdqpOut__16(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* sdqpOut__16(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::sdqpOut(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__17"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* sdqpOut__17(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::sdqpOut(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* sdqpOut__17(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* sdqpOut__17(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::sdqpOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__18"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* sdqpOut__18(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::sdqpOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >* sdqpOut__18(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::MX* >* sdqpOut__18(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::MX > ret = casadi::sdqpOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__19"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* sdqpOut__19(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::MX* >* sdqpOut__19(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::MX* >* sdqpOut__19(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::MX > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__20"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* sdqpOut__20(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::MX* >* sdqpOut__20(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::MX* >* sdqpOut__20(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::MX > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__21"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* sdqpOut__21(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::MX* >* sdqpOut__21(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::MX* >* sdqpOut__21(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::MX > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__22"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* sdqpOut__22(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::MX* >* sdqpOut__22(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::MX* >* sdqpOut__22(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::MX > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__23"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* sdqpOut__23(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::MX* >* sdqpOut__23(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::MX* >* sdqpOut__23(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::MX > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__24"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* sdqpOut__24(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::sdqpOut(x0_)"
extern "C"
std::vector< casadi::SX* >* sdqpOut__24(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* sdqpOut__24(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::sdqpOut(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__25"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* sdqpOut__25(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::sdqpOut(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* sdqpOut__25(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* sdqpOut__25(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::sdqpOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__26"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* sdqpOut__26(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::sdqpOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::SX* >* sdqpOut__26(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::SX* >* sdqpOut__26(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::SX > ret = casadi::sdqpOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__27"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* sdqpOut__27(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::SX* >* sdqpOut__27(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::SX* >* sdqpOut__27(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::SX > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__28"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* sdqpOut__28(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::SX* >* sdqpOut__28(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::SX* >* sdqpOut__28(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::SX > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__29"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* sdqpOut__29(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::SX* >* sdqpOut__29(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::SX* >* sdqpOut__29(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::SX > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__30"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* sdqpOut__30(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::SX* >* sdqpOut__30(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::SX* >* sdqpOut__30(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::SX > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpOut" ===============
// cppName: "casadi::sdqpOut"
// cWrapperName: "sdqpOut__31"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* sdqpOut__31(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::SX* >* sdqpOut__31(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::SX* >* sdqpOut__31(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::SX > ret = casadi::sdqpOut(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpStruct" ===============
// cppName: "casadi::sdqpStruct"
// cWrapperName: "sdqpStruct__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdqpStruct__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::sdqpStruct(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* sdqpStruct__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* sdqpStruct__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::sdqpStruct(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpStruct" ===============
// cppName: "casadi::sdqpStruct"
// cWrapperName: "sdqpStruct__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdqpStruct__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::sdqpStruct(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* sdqpStruct__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* sdqpStruct__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::sdqpStruct(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpStruct" ===============
// cppName: "casadi::sdqpStruct"
// cWrapperName: "sdqpStruct__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdqpStruct__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::sdqpStruct(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* sdqpStruct__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* sdqpStruct__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::sdqpStruct(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpStruct" ===============
// cppName: "casadi::sdqpStruct"
// cWrapperName: "sdqpStruct__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdqpStruct__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::sdqpStruct(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::Sparsity* >* sdqpStruct__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::Sparsity* >* sdqpStruct__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::Sparsity > ret = casadi::sdqpStruct(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::sdqpStruct" ===============
// cppName: "casadi::sdqpStruct"
// cWrapperName: "sdqpStruct__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* sdqpStruct__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::sdqpStruct(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::Sparsity* >* sdqpStruct__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::Sparsity* >* sdqpStruct__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::Sparsity > ret = casadi::sdqpStruct(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::simplify" ===============
// cppName: "casadi::simplify"
// cWrapperName: "simplify__0"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0)"
// params: [Ref (UserType (Namespace ["casadi"]) (Name "MX"))]
// retType: CVoid
// args: "(x0_)"
// cWrapperRetType: "void"
// proto: "void simplify__0(std::string ** err_msg, casadi::MX* x0)"
// call: "casadi::simplify(x0_)"
extern "C"
void simplify__0(std::string ** err_msg, casadi::MX* x0);
void simplify__0(std::string ** err_msg, casadi::MX* x0){
    try {
        casadi::MX x0_ = Marshaling<casadi::MX,casadi::MX*>::marshal(x0);

        casadi::simplify(x0_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::simplify" ===============
// cppName: "casadi::simplify"
// cWrapperName: "simplify__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (UserType (Namespace ["casadi"]) (Name "SX"))]
// retType: CVoid
// args: "(x0_)"
// cWrapperRetType: "void"
// proto: "void simplify__1(std::string ** err_msg, casadi::SX* x0)"
// call: "casadi::simplify(x0_)"
extern "C"
void simplify__1(std::string ** err_msg, casadi::SX* x0);
void simplify__1(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);

        casadi::simplify(x0_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* socpIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::socpIn(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* socpIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* socpIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::socpIn(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* socpIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::socpIn(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* socpIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* socpIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::socpIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* socpIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::socpIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* socpIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* socpIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::socpIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* socpIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::Sparsity* >* socpIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::Sparsity* >* socpIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::Sparsity > ret = casadi::socpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* socpIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::Sparsity* >* socpIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::Sparsity* >* socpIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::Sparsity > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* socpIn__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::Sparsity* >* socpIn__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::Sparsity* >* socpIn__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::Sparsity > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* socpIn__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::Sparsity* >* socpIn__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::Sparsity* >* socpIn__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::Sparsity > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* socpIn__7(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::Sparsity* >* socpIn__7(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::Sparsity* >* socpIn__7(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::Sparsity > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__8"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* socpIn__8(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::vector< casadi::Sparsity* >* socpIn__8(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8);
std::vector< casadi::Sparsity* >* socpIn__8(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);

        std::vector< casadi::Sparsity > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__9"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* socpIn__9(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::vector< casadi::Sparsity* >* socpIn__9(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9);
std::vector< casadi::Sparsity* >* socpIn__9(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);

        std::vector< casadi::Sparsity > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__10"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* socpIn__10(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10)"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::vector< casadi::Sparsity* >* socpIn__10(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10);
std::vector< casadi::Sparsity* >* socpIn__10(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);
        std::string x10_ = Marshaling<std::string,std::string*>::marshal(x10);

        std::vector< casadi::Sparsity > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__11"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* socpIn__11(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::socpIn(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* socpIn__11(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* socpIn__11(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::socpIn(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__12"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* socpIn__12(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::socpIn(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* socpIn__12(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* socpIn__12(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::socpIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__13"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* socpIn__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::socpIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::DMatrix* >* socpIn__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::DMatrix* >* socpIn__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::DMatrix > ret = casadi::socpIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__14"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* socpIn__14(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::DMatrix* >* socpIn__14(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::DMatrix* >* socpIn__14(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::DMatrix > ret = casadi::socpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__15"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* socpIn__15(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::DMatrix* >* socpIn__15(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::DMatrix* >* socpIn__15(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::DMatrix > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__16"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* socpIn__16(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::DMatrix* >* socpIn__16(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::DMatrix* >* socpIn__16(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::DMatrix > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__17"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* socpIn__17(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::DMatrix* >* socpIn__17(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::DMatrix* >* socpIn__17(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::DMatrix > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__18"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* socpIn__18(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::DMatrix* >* socpIn__18(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::DMatrix* >* socpIn__18(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::DMatrix > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__19"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* socpIn__19(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::vector< casadi::DMatrix* >* socpIn__19(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8);
std::vector< casadi::DMatrix* >* socpIn__19(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);

        std::vector< casadi::DMatrix > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__20"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* socpIn__20(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::vector< casadi::DMatrix* >* socpIn__20(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9);
std::vector< casadi::DMatrix* >* socpIn__20(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);

        std::vector< casadi::DMatrix > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__21"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* socpIn__21(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10)"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::vector< casadi::DMatrix* >* socpIn__21(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10);
std::vector< casadi::DMatrix* >* socpIn__21(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);
        std::string x10_ = Marshaling<std::string,std::string*>::marshal(x10);

        std::vector< casadi::DMatrix > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__22"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* socpIn__22(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::socpIn(x0_)"
extern "C"
std::vector< casadi::MX* >* socpIn__22(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* socpIn__22(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::socpIn(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__23"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* socpIn__23(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::socpIn(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* socpIn__23(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* socpIn__23(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::socpIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__24"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* socpIn__24(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::socpIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >* socpIn__24(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::MX* >* socpIn__24(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::MX > ret = casadi::socpIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__25"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* socpIn__25(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::MX* >* socpIn__25(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::MX* >* socpIn__25(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::MX > ret = casadi::socpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__26"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* socpIn__26(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::MX* >* socpIn__26(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::MX* >* socpIn__26(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::MX > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__27"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* socpIn__27(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::MX* >* socpIn__27(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::MX* >* socpIn__27(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::MX > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__28"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* socpIn__28(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::MX* >* socpIn__28(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::MX* >* socpIn__28(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::MX > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__29"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* socpIn__29(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::MX* >* socpIn__29(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::MX* >* socpIn__29(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::MX > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__30"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* socpIn__30(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::vector< casadi::MX* >* socpIn__30(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8);
std::vector< casadi::MX* >* socpIn__30(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);

        std::vector< casadi::MX > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__31"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* socpIn__31(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::vector< casadi::MX* >* socpIn__31(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9);
std::vector< casadi::MX* >* socpIn__31(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);

        std::vector< casadi::MX > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__32"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* socpIn__32(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10)"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::vector< casadi::MX* >* socpIn__32(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10);
std::vector< casadi::MX* >* socpIn__32(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);
        std::string x10_ = Marshaling<std::string,std::string*>::marshal(x10);

        std::vector< casadi::MX > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__33"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* socpIn__33(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::socpIn(x0_)"
extern "C"
std::vector< casadi::SX* >* socpIn__33(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* socpIn__33(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::socpIn(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__34"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* socpIn__34(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::socpIn(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* socpIn__34(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* socpIn__34(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::socpIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__35"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* socpIn__35(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::socpIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::SX* >* socpIn__35(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::SX* >* socpIn__35(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::SX > ret = casadi::socpIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__36"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* socpIn__36(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::SX* >* socpIn__36(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::SX* >* socpIn__36(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::SX > ret = casadi::socpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__37"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* socpIn__37(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::SX* >* socpIn__37(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::SX* >* socpIn__37(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::SX > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__38"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* socpIn__38(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::SX* >* socpIn__38(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::SX* >* socpIn__38(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::SX > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__39"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* socpIn__39(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::SX* >* socpIn__39(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::SX* >* socpIn__39(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::SX > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__40"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* socpIn__40(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::SX* >* socpIn__40(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::SX* >* socpIn__40(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::SX > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__41"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* socpIn__41(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::vector< casadi::SX* >* socpIn__41(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8);
std::vector< casadi::SX* >* socpIn__41(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);

        std::vector< casadi::SX > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__42"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* socpIn__42(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::vector< casadi::SX* >* socpIn__42(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9);
std::vector< casadi::SX* >* socpIn__42(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);

        std::vector< casadi::SX > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpIn" ===============
// cppName: "casadi::socpIn"
// cWrapperName: "socpIn__43"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* socpIn__43(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10)"
// call: "casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::vector< casadi::SX* >* socpIn__43(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10);
std::vector< casadi::SX* >* socpIn__43(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);
        std::string x10_ = Marshaling<std::string,std::string*>::marshal(x10);

        std::vector< casadi::SX > ret = casadi::socpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* socpOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::socpOut(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* socpOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* socpOut__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::socpOut(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* socpOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::socpOut(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* socpOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* socpOut__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::socpOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* socpOut__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::socpOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* socpOut__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* socpOut__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::socpOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* socpOut__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::Sparsity* >* socpOut__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::Sparsity* >* socpOut__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::Sparsity > ret = casadi::socpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* socpOut__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::Sparsity* >* socpOut__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::Sparsity* >* socpOut__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::Sparsity > ret = casadi::socpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* socpOut__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::socpOut(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* socpOut__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* socpOut__5(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::socpOut(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* socpOut__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::socpOut(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* socpOut__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* socpOut__6(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::socpOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* socpOut__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::socpOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::DMatrix* >* socpOut__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::DMatrix* >* socpOut__7(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::DMatrix > ret = casadi::socpOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__8"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* socpOut__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::DMatrix* >* socpOut__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::DMatrix* >* socpOut__8(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::DMatrix > ret = casadi::socpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__9"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* socpOut__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::DMatrix* >* socpOut__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::DMatrix* >* socpOut__9(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::DMatrix > ret = casadi::socpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__10"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* socpOut__10(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::socpOut(x0_)"
extern "C"
std::vector< casadi::MX* >* socpOut__10(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* socpOut__10(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::socpOut(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__11"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* socpOut__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::socpOut(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* socpOut__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* socpOut__11(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::socpOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__12"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* socpOut__12(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::socpOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >* socpOut__12(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::MX* >* socpOut__12(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::MX > ret = casadi::socpOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__13"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* socpOut__13(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::MX* >* socpOut__13(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::MX* >* socpOut__13(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::MX > ret = casadi::socpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__14"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* socpOut__14(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::MX* >* socpOut__14(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::MX* >* socpOut__14(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::MX > ret = casadi::socpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__15"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* socpOut__15(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::socpOut(x0_)"
extern "C"
std::vector< casadi::SX* >* socpOut__15(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* socpOut__15(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::socpOut(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__16"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* socpOut__16(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::socpOut(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* socpOut__16(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* socpOut__16(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::socpOut(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__17"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* socpOut__17(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::socpOut(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::SX* >* socpOut__17(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::SX* >* socpOut__17(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::SX > ret = casadi::socpOut(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__18"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* socpOut__18(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::SX* >* socpOut__18(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::SX* >* socpOut__18(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::SX > ret = casadi::socpOut(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpOut" ===============
// cppName: "casadi::socpOut"
// cWrapperName: "socpOut__19"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* socpOut__19(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::socpOut(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::SX* >* socpOut__19(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::SX* >* socpOut__19(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::SX > ret = casadi::socpOut(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpStruct" ===============
// cppName: "casadi::socpStruct"
// cWrapperName: "socpStruct__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* socpStruct__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::socpStruct(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* socpStruct__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* socpStruct__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::socpStruct(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpStruct" ===============
// cppName: "casadi::socpStruct"
// cWrapperName: "socpStruct__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* socpStruct__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::socpStruct(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* socpStruct__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* socpStruct__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::socpStruct(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::socpStruct" ===============
// cppName: "casadi::socpStruct"
// cWrapperName: "socpStruct__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* socpStruct__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::socpStruct(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* socpStruct__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* socpStruct__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::socpStruct(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::solve" ===============
// cppName: "casadi::solve"
// cWrapperName: "solve__0"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX* solve__0(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// call: "casadi::solve(x0_, x1_)"
extern "C"
casadi::MX* solve__0(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
casadi::MX* solve__0(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX x0_ = Marshaling<casadi::MX,casadi::MX*>::marshal(x0);
        casadi::MX x1_ = Marshaling<casadi::MX,casadi::MX*>::marshal(x1);

        casadi::MX ret = casadi::solve(x0_, x1_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::solve" ===============
// cppName: "casadi::solve"
// cWrapperName: "solve__1"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, std::string* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const StdString)]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX* solve__1(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, std::string* x2)"
// call: "casadi::solve(x0_, x1_, x2_)"
extern "C"
casadi::MX* solve__1(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, std::string* x2);
casadi::MX* solve__1(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, std::string* x2){
    try {
        casadi::MX x0_ = Marshaling<casadi::MX,casadi::MX*>::marshal(x0);
        casadi::MX x1_ = Marshaling<casadi::MX,casadi::MX*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        casadi::MX ret = casadi::solve(x0_, x1_, x2_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::solve" ===============
// cppName: "casadi::solve"
// cWrapperName: "solve__2"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX* solve__2(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// call: "casadi::solve(x0_, x1_)"
extern "C"
casadi::SX* solve__2(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX* solve__2(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);
        casadi::SX x1_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x1);

        casadi::SX ret = casadi::solve(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::solve" ===============
// cppName: "casadi::solve"
// cWrapperName: "solve__3"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix* solve__3(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1)"
// call: "casadi::solve(x0_, x1_)"
extern "C"
casadi::DMatrix* solve__3(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1);
casadi::DMatrix* solve__3(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1){
    try {
        casadi::DMatrix x0_ = Marshaling<casadi::DMatrix,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix x1_ = Marshaling<casadi::DMatrix,casadi::DMatrix*>::marshal(x1);

        casadi::DMatrix ret = casadi::solve(x0_, x1_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::solve" ===============
// cppName: "casadi::solve"
// cWrapperName: "solve__4"
// protoArgs: "(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "IMatrix")))]
// retType: UserType (Namespace ["casadi"]) (Name "IMatrix")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::IMatrix*"
// proto: "casadi::IMatrix* solve__4(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1)"
// call: "casadi::solve(x0_, x1_)"
extern "C"
casadi::IMatrix* solve__4(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1);
casadi::IMatrix* solve__4(std::string ** err_msg, casadi::IMatrix* x0, casadi::IMatrix* x1){
    try {
        casadi::IMatrix x0_ = Marshaling<casadi::IMatrix,casadi::IMatrix*>::marshal(x0);
        casadi::IMatrix x1_ = Marshaling<casadi::IMatrix,casadi::IMatrix*>::marshal(x1);

        casadi::IMatrix ret = casadi::solve(x0_, x1_);
        return WrapReturn< casadi::IMatrix*, casadi::IMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::solve" ===============
// cppName: "casadi::solve"
// cWrapperName: "solve__5"
// protoArgs: "(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, std::string* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "DMatrix"))),Ref (Const StdString)]
// retType: UserType (Namespace ["casadi"]) (Name "DMatrix")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::DMatrix*"
// proto: "casadi::DMatrix* solve__5(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, std::string* x2)"
// call: "casadi::solve(x0_, x1_, x2_)"
extern "C"
casadi::DMatrix* solve__5(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, std::string* x2);
casadi::DMatrix* solve__5(std::string ** err_msg, casadi::DMatrix* x0, casadi::DMatrix* x1, std::string* x2){
    try {
        casadi::DMatrix x0_ = Marshaling<casadi::DMatrix,casadi::DMatrix*>::marshal(x0);
        casadi::DMatrix x1_ = Marshaling<casadi::DMatrix,casadi::DMatrix*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        casadi::DMatrix ret = casadi::solve(x0_, x1_, x2_);
        return WrapReturn< casadi::DMatrix*, casadi::DMatrix >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::spy" ===============
// cppName: "casadi::spy"
// cWrapperName: "spy"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX* spy(std::string ** err_msg, casadi::SX* x0)"
// call: "casadi::spy(x0_)"
extern "C"
casadi::SX* spy(std::string ** err_msg, casadi::SX* x0);
casadi::SX* spy(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);

        casadi::SX ret = casadi::spy(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* stabilizedQpIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0)"
// call: "casadi::stabilizedQpIn(x0_)"
extern "C"
std::vector< casadi::Sparsity* >* stabilizedQpIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0);
std::vector< casadi::Sparsity* >* stabilizedQpIn__0(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);

        std::vector< casadi::Sparsity > ret = casadi::stabilizedQpIn(x0_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* stabilizedQpIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1)"
// call: "casadi::stabilizedQpIn(x0_, x1_)"
extern "C"
std::vector< casadi::Sparsity* >* stabilizedQpIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1);
std::vector< casadi::Sparsity* >* stabilizedQpIn__1(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::Sparsity > ret = casadi::stabilizedQpIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* stabilizedQpIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::Sparsity* >* stabilizedQpIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::Sparsity* >* stabilizedQpIn__2(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::Sparsity > ret = casadi::stabilizedQpIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* stabilizedQpIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::Sparsity* >* stabilizedQpIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::Sparsity* >* stabilizedQpIn__3(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::Sparsity > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__4"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* stabilizedQpIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::Sparsity* >* stabilizedQpIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::Sparsity* >* stabilizedQpIn__4(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::Sparsity > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__5"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* stabilizedQpIn__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::Sparsity* >* stabilizedQpIn__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::Sparsity* >* stabilizedQpIn__5(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::Sparsity > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__6"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* stabilizedQpIn__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::Sparsity* >* stabilizedQpIn__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::Sparsity* >* stabilizedQpIn__6(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::Sparsity > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__7"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* stabilizedQpIn__7(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::Sparsity* >* stabilizedQpIn__7(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::Sparsity* >* stabilizedQpIn__7(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::Sparsity > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__8"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* stabilizedQpIn__8(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::vector< casadi::Sparsity* >* stabilizedQpIn__8(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8);
std::vector< casadi::Sparsity* >* stabilizedQpIn__8(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);

        std::vector< casadi::Sparsity > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__9"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* stabilizedQpIn__9(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::vector< casadi::Sparsity* >* stabilizedQpIn__9(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9);
std::vector< casadi::Sparsity* >* stabilizedQpIn__9(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);

        std::vector< casadi::Sparsity > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__10"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* stabilizedQpIn__10(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::vector< casadi::Sparsity* >* stabilizedQpIn__10(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10);
std::vector< casadi::Sparsity* >* stabilizedQpIn__10(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);
        std::string x10_ = Marshaling<std::string,std::string*>::marshal(x10);

        std::vector< casadi::Sparsity > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__11"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* stabilizedQpIn__11(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::vector< casadi::Sparsity* >* stabilizedQpIn__11(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11);
std::vector< casadi::Sparsity* >* stabilizedQpIn__11(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);
        std::string x10_ = Marshaling<std::string,std::string*>::marshal(x10);
        std::string x11_ = Marshaling<std::string,std::string*>::marshal(x11);

        std::vector< casadi::Sparsity > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__12"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "Sparsity"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::vector< casadi::Sparsity* >*"
// proto: "std::vector< casadi::Sparsity* >* stabilizedQpIn__12(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::vector< casadi::Sparsity* >* stabilizedQpIn__12(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12);
std::vector< casadi::Sparsity* >* stabilizedQpIn__12(std::string ** err_msg, std::vector< casadi::Sparsity* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12){
    try {
        std::vector< casadi::Sparsity > x0_ = Marshaling<std::vector< casadi::Sparsity >,std::vector< casadi::Sparsity* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);
        std::string x10_ = Marshaling<std::string,std::string*>::marshal(x10);
        std::string x11_ = Marshaling<std::string,std::string*>::marshal(x11);
        std::string x12_ = Marshaling<std::string,std::string*>::marshal(x12);

        std::vector< casadi::Sparsity > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::vector< casadi::Sparsity* >*, std::vector< casadi::Sparsity > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__13"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* stabilizedQpIn__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0)"
// call: "casadi::stabilizedQpIn(x0_)"
extern "C"
std::vector< casadi::DMatrix* >* stabilizedQpIn__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0);
std::vector< casadi::DMatrix* >* stabilizedQpIn__13(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);

        std::vector< casadi::DMatrix > ret = casadi::stabilizedQpIn(x0_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__14"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* stabilizedQpIn__14(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1)"
// call: "casadi::stabilizedQpIn(x0_, x1_)"
extern "C"
std::vector< casadi::DMatrix* >* stabilizedQpIn__14(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1);
std::vector< casadi::DMatrix* >* stabilizedQpIn__14(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::DMatrix > ret = casadi::stabilizedQpIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__15"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* stabilizedQpIn__15(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::DMatrix* >* stabilizedQpIn__15(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::DMatrix* >* stabilizedQpIn__15(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::DMatrix > ret = casadi::stabilizedQpIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__16"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* stabilizedQpIn__16(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::DMatrix* >* stabilizedQpIn__16(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::DMatrix* >* stabilizedQpIn__16(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::DMatrix > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__17"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* stabilizedQpIn__17(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::DMatrix* >* stabilizedQpIn__17(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::DMatrix* >* stabilizedQpIn__17(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::DMatrix > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__18"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* stabilizedQpIn__18(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::DMatrix* >* stabilizedQpIn__18(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::DMatrix* >* stabilizedQpIn__18(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::DMatrix > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__19"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* stabilizedQpIn__19(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::DMatrix* >* stabilizedQpIn__19(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::DMatrix* >* stabilizedQpIn__19(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::DMatrix > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__20"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* stabilizedQpIn__20(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::DMatrix* >* stabilizedQpIn__20(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::DMatrix* >* stabilizedQpIn__20(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::DMatrix > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__21"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* stabilizedQpIn__21(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::vector< casadi::DMatrix* >* stabilizedQpIn__21(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8);
std::vector< casadi::DMatrix* >* stabilizedQpIn__21(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);

        std::vector< casadi::DMatrix > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__22"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* stabilizedQpIn__22(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::vector< casadi::DMatrix* >* stabilizedQpIn__22(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9);
std::vector< casadi::DMatrix* >* stabilizedQpIn__22(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);

        std::vector< casadi::DMatrix > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__23"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* stabilizedQpIn__23(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::vector< casadi::DMatrix* >* stabilizedQpIn__23(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10);
std::vector< casadi::DMatrix* >* stabilizedQpIn__23(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);
        std::string x10_ = Marshaling<std::string,std::string*>::marshal(x10);

        std::vector< casadi::DMatrix > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__24"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* stabilizedQpIn__24(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::vector< casadi::DMatrix* >* stabilizedQpIn__24(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11);
std::vector< casadi::DMatrix* >* stabilizedQpIn__24(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);
        std::string x10_ = Marshaling<std::string,std::string*>::marshal(x10);
        std::string x11_ = Marshaling<std::string,std::string*>::marshal(x11);

        std::vector< casadi::DMatrix > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__25"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "DMatrix"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::vector< casadi::DMatrix* >*"
// proto: "std::vector< casadi::DMatrix* >* stabilizedQpIn__25(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::vector< casadi::DMatrix* >* stabilizedQpIn__25(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12);
std::vector< casadi::DMatrix* >* stabilizedQpIn__25(std::string ** err_msg, std::vector< casadi::DMatrix* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12){
    try {
        std::vector< casadi::DMatrix > x0_ = Marshaling<std::vector< casadi::DMatrix >,std::vector< casadi::DMatrix* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);
        std::string x10_ = Marshaling<std::string,std::string*>::marshal(x10);
        std::string x11_ = Marshaling<std::string,std::string*>::marshal(x11);
        std::string x12_ = Marshaling<std::string,std::string*>::marshal(x12);

        std::vector< casadi::DMatrix > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::vector< casadi::DMatrix* >*, std::vector< casadi::DMatrix > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__26"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* stabilizedQpIn__26(std::string ** err_msg, std::vector< casadi::MX* >* x0)"
// call: "casadi::stabilizedQpIn(x0_)"
extern "C"
std::vector< casadi::MX* >* stabilizedQpIn__26(std::string ** err_msg, std::vector< casadi::MX* >* x0);
std::vector< casadi::MX* >* stabilizedQpIn__26(std::string ** err_msg, std::vector< casadi::MX* >* x0){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);

        std::vector< casadi::MX > ret = casadi::stabilizedQpIn(x0_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__27"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* stabilizedQpIn__27(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1)"
// call: "casadi::stabilizedQpIn(x0_, x1_)"
extern "C"
std::vector< casadi::MX* >* stabilizedQpIn__27(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1);
std::vector< casadi::MX* >* stabilizedQpIn__27(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::MX > ret = casadi::stabilizedQpIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__28"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* stabilizedQpIn__28(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >* stabilizedQpIn__28(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::MX* >* stabilizedQpIn__28(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::MX > ret = casadi::stabilizedQpIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__29"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* stabilizedQpIn__29(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::MX* >* stabilizedQpIn__29(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::MX* >* stabilizedQpIn__29(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::MX > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__30"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* stabilizedQpIn__30(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::MX* >* stabilizedQpIn__30(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::MX* >* stabilizedQpIn__30(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::MX > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__31"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* stabilizedQpIn__31(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::MX* >* stabilizedQpIn__31(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::MX* >* stabilizedQpIn__31(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::MX > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__32"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* stabilizedQpIn__32(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::MX* >* stabilizedQpIn__32(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::MX* >* stabilizedQpIn__32(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::MX > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__33"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* stabilizedQpIn__33(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::MX* >* stabilizedQpIn__33(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::MX* >* stabilizedQpIn__33(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::MX > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__34"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* stabilizedQpIn__34(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::vector< casadi::MX* >* stabilizedQpIn__34(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8);
std::vector< casadi::MX* >* stabilizedQpIn__34(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);

        std::vector< casadi::MX > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__35"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* stabilizedQpIn__35(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::vector< casadi::MX* >* stabilizedQpIn__35(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9);
std::vector< casadi::MX* >* stabilizedQpIn__35(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);

        std::vector< casadi::MX > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__36"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* stabilizedQpIn__36(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::vector< casadi::MX* >* stabilizedQpIn__36(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10);
std::vector< casadi::MX* >* stabilizedQpIn__36(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);
        std::string x10_ = Marshaling<std::string,std::string*>::marshal(x10);

        std::vector< casadi::MX > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__37"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* stabilizedQpIn__37(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::vector< casadi::MX* >* stabilizedQpIn__37(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11);
std::vector< casadi::MX* >* stabilizedQpIn__37(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);
        std::string x10_ = Marshaling<std::string,std::string*>::marshal(x10);
        std::string x11_ = Marshaling<std::string,std::string*>::marshal(x11);

        std::vector< casadi::MX > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__38"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* stabilizedQpIn__38(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::vector< casadi::MX* >* stabilizedQpIn__38(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12);
std::vector< casadi::MX* >* stabilizedQpIn__38(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);
        std::string x10_ = Marshaling<std::string,std::string*>::marshal(x10);
        std::string x11_ = Marshaling<std::string,std::string*>::marshal(x11);
        std::string x12_ = Marshaling<std::string,std::string*>::marshal(x12);

        std::vector< casadi::MX > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__39"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* stabilizedQpIn__39(std::string ** err_msg, std::vector< casadi::SX* >* x0)"
// call: "casadi::stabilizedQpIn(x0_)"
extern "C"
std::vector< casadi::SX* >* stabilizedQpIn__39(std::string ** err_msg, std::vector< casadi::SX* >* x0);
std::vector< casadi::SX* >* stabilizedQpIn__39(std::string ** err_msg, std::vector< casadi::SX* >* x0){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);

        std::vector< casadi::SX > ret = casadi::stabilizedQpIn(x0_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__40"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* stabilizedQpIn__40(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1)"
// call: "casadi::stabilizedQpIn(x0_, x1_)"
extern "C"
std::vector< casadi::SX* >* stabilizedQpIn__40(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1);
std::vector< casadi::SX* >* stabilizedQpIn__40(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);

        std::vector< casadi::SX > ret = casadi::stabilizedQpIn(x0_, x1_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__41"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* stabilizedQpIn__41(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::SX* >* stabilizedQpIn__41(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2);
std::vector< casadi::SX* >* stabilizedQpIn__41(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);

        std::vector< casadi::SX > ret = casadi::stabilizedQpIn(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__42"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* stabilizedQpIn__42(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_)"
extern "C"
std::vector< casadi::SX* >* stabilizedQpIn__42(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3);
std::vector< casadi::SX* >* stabilizedQpIn__42(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);

        std::vector< casadi::SX > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__43"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* stabilizedQpIn__43(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_)"
extern "C"
std::vector< casadi::SX* >* stabilizedQpIn__43(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4);
std::vector< casadi::SX* >* stabilizedQpIn__43(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);

        std::vector< casadi::SX > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__44"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* stabilizedQpIn__44(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_)"
extern "C"
std::vector< casadi::SX* >* stabilizedQpIn__44(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5);
std::vector< casadi::SX* >* stabilizedQpIn__44(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);

        std::vector< casadi::SX > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__45"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* stabilizedQpIn__45(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_)"
extern "C"
std::vector< casadi::SX* >* stabilizedQpIn__45(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6);
std::vector< casadi::SX* >* stabilizedQpIn__45(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);

        std::vector< casadi::SX > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__46"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* stabilizedQpIn__46(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_)"
extern "C"
std::vector< casadi::SX* >* stabilizedQpIn__46(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7);
std::vector< casadi::SX* >* stabilizedQpIn__46(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);

        std::vector< casadi::SX > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__47"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* stabilizedQpIn__47(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_)"
extern "C"
std::vector< casadi::SX* >* stabilizedQpIn__47(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8);
std::vector< casadi::SX* >* stabilizedQpIn__47(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);

        std::vector< casadi::SX > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__48"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* stabilizedQpIn__48(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_)"
extern "C"
std::vector< casadi::SX* >* stabilizedQpIn__48(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9);
std::vector< casadi::SX* >* stabilizedQpIn__48(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);

        std::vector< casadi::SX > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__49"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* stabilizedQpIn__49(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_)"
extern "C"
std::vector< casadi::SX* >* stabilizedQpIn__49(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10);
std::vector< casadi::SX* >* stabilizedQpIn__49(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);
        std::string x10_ = Marshaling<std::string,std::string*>::marshal(x10);

        std::vector< casadi::SX > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__50"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* stabilizedQpIn__50(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_)"
extern "C"
std::vector< casadi::SX* >* stabilizedQpIn__50(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11);
std::vector< casadi::SX* >* stabilizedQpIn__50(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);
        std::string x10_ = Marshaling<std::string,std::string*>::marshal(x10);
        std::string x11_ = Marshaling<std::string,std::string*>::marshal(x11);

        std::vector< casadi::SX > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::stabilizedQpIn" ===============
// cppName: "casadi::stabilizedQpIn"
// cWrapperName: "stabilizedQpIn__51"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString),Ref (Const StdString)]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* stabilizedQpIn__51(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12)"
// call: "casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_)"
extern "C"
std::vector< casadi::SX* >* stabilizedQpIn__51(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12);
std::vector< casadi::SX* >* stabilizedQpIn__51(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::string* x1, std::string* x2, std::string* x3, std::string* x4, std::string* x5, std::string* x6, std::string* x7, std::string* x8, std::string* x9, std::string* x10, std::string* x11, std::string* x12){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::string x1_ = Marshaling<std::string,std::string*>::marshal(x1);
        std::string x2_ = Marshaling<std::string,std::string*>::marshal(x2);
        std::string x3_ = Marshaling<std::string,std::string*>::marshal(x3);
        std::string x4_ = Marshaling<std::string,std::string*>::marshal(x4);
        std::string x5_ = Marshaling<std::string,std::string*>::marshal(x5);
        std::string x6_ = Marshaling<std::string,std::string*>::marshal(x6);
        std::string x7_ = Marshaling<std::string,std::string*>::marshal(x7);
        std::string x8_ = Marshaling<std::string,std::string*>::marshal(x8);
        std::string x9_ = Marshaling<std::string,std::string*>::marshal(x9);
        std::string x10_ = Marshaling<std::string,std::string*>::marshal(x10);
        std::string x11_ = Marshaling<std::string,std::string*>::marshal(x11);
        std::string x12_ = Marshaling<std::string,std::string*>::marshal(x12);

        std::vector< casadi::SX > ret = casadi::stabilizedQpIn(x0_, x1_, x2_, x3_, x4_, x5_, x6_, x7_, x8_, x9_, x10_, x11_, x12_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::substitute" ===============
// cppName: "casadi::substitute"
// cWrapperName: "substitute__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "MX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::MX* >*"
// proto: "std::vector< casadi::MX* >* substitute__0(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2)"
// call: "casadi::substitute(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::MX* >* substitute__0(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2);
std::vector< casadi::MX* >* substitute__0(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::vector< casadi::MX > x1_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x1);
        std::vector< casadi::MX > x2_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x2);

        std::vector< casadi::MX > ret = casadi::substitute(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::MX* >*, std::vector< casadi::MX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::substitute" ===============
// cppName: "casadi::substitute"
// cWrapperName: "substitute__1"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, casadi::MX* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX* substitute__1(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, casadi::MX* x2)"
// call: "casadi::substitute(x0_, x1_, x2_)"
extern "C"
casadi::MX* substitute__1(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, casadi::MX* x2);
casadi::MX* substitute__1(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1, casadi::MX* x2){
    try {
        casadi::MX x0_ = Marshaling<casadi::MX,casadi::MX*>::marshal(x0);
        casadi::MX x1_ = Marshaling<casadi::MX,casadi::MX*>::marshal(x1);
        casadi::MX x2_ = Marshaling<casadi::MX,casadi::MX*>::marshal(x2);

        casadi::MX ret = casadi::substitute(x0_, x1_, x2_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::substitute" ===============
// cppName: "casadi::substitute"
// cWrapperName: "substitute__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))))]
// retType: StdVec (UserType (Namespace ["casadi"]) (Name "SX"))
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "std::vector< casadi::SX* >*"
// proto: "std::vector< casadi::SX* >* substitute__2(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2)"
// call: "casadi::substitute(x0_, x1_, x2_)"
extern "C"
std::vector< casadi::SX* >* substitute__2(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2);
std::vector< casadi::SX* >* substitute__2(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::vector< casadi::SX > x1_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x1);
        std::vector< casadi::SX > x2_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x2);

        std::vector< casadi::SX > ret = casadi::substitute(x0_, x1_, x2_);
        return WrapReturn< std::vector< casadi::SX* >*, std::vector< casadi::SX > >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::substitute" ===============
// cppName: "casadi::substitute"
// cWrapperName: "substitute__3"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX* substitute__3(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2)"
// call: "casadi::substitute(x0_, x1_, x2_)"
extern "C"
casadi::SX* substitute__3(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2);
casadi::SX* substitute__3(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);
        casadi::SX x1_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x1);
        casadi::SX x2_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x2);

        casadi::SX ret = casadi::substitute(x0_, x1_, x2_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::substituteInPlace" ===============
// cppName: "casadi::substituteInPlace"
// cWrapperName: "substituteInPlace__0"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: CVoid
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "void"
// proto: "void substituteInPlace__0(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2)"
// call: "casadi::substituteInPlace(x0_, x1_, x2_)"
extern "C"
void substituteInPlace__0(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2);
void substituteInPlace__0(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::vector< casadi::MX > x1_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x1);
        std::vector< casadi::MX > x2_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x2);

        casadi::substituteInPlace(x0_, x1_, x2_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::substituteInPlace" ===============
// cppName: "casadi::substituteInPlace"
// cWrapperName: "substituteInPlace__1"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2, int x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))),CBool]
// retType: CVoid
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "void"
// proto: "void substituteInPlace__1(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2, int x3)"
// call: "casadi::substituteInPlace(x0_, x1_, x2_, x3_)"
extern "C"
void substituteInPlace__1(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2, int x3);
void substituteInPlace__1(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, std::vector< casadi::MX* >* x2, int x3){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::vector< casadi::MX > x1_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x1);
        std::vector< casadi::MX > x2_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x2);
        bool x3_ = Marshaling<bool,int>::marshal(x3);

        casadi::substituteInPlace(x0_, x1_, x2_, x3_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::substituteInPlace" ===============
// cppName: "casadi::substituteInPlace"
// cWrapperName: "substituteInPlace__2"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: CVoid
// args: "(x0_, x1_)"
// cWrapperRetType: "void"
// proto: "void substituteInPlace__2(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1)"
// call: "casadi::substituteInPlace(x0_, x1_)"
extern "C"
void substituteInPlace__2(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1);
void substituteInPlace__2(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::vector< casadi::MX > x1_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x1);

        casadi::substituteInPlace(x0_, x1_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::substituteInPlace" ===============
// cppName: "casadi::substituteInPlace"
// cWrapperName: "substituteInPlace__3"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, int x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "MX")))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "MX"))),CBool]
// retType: CVoid
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "void"
// proto: "void substituteInPlace__3(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, int x2)"
// call: "casadi::substituteInPlace(x0_, x1_, x2_)"
extern "C"
void substituteInPlace__3(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, int x2);
void substituteInPlace__3(std::string ** err_msg, std::vector< casadi::MX* >* x0, std::vector< casadi::MX* >* x1, int x2){
    try {
        std::vector< casadi::MX > x0_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x0);
        std::vector< casadi::MX > x1_ = Marshaling<std::vector< casadi::MX >,std::vector< casadi::MX* >*>::marshal(x1);
        bool x2_ = Marshaling<bool,int>::marshal(x2);

        casadi::substituteInPlace(x0_, x1_, x2_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::substituteInPlace" ===============
// cppName: "casadi::substituteInPlace"
// cWrapperName: "substituteInPlace__4"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (UserType (Namespace ["casadi"]) (Name "SX"))]
// retType: CVoid
// args: "(x0_, x1_)"
// cWrapperRetType: "void"
// proto: "void substituteInPlace__4(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// call: "casadi::substituteInPlace(x0_, x1_)"
extern "C"
void substituteInPlace__4(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
void substituteInPlace__4(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);
        casadi::SX x1_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x1);

        casadi::substituteInPlace(x0_, x1_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::substituteInPlace" ===============
// cppName: "casadi::substituteInPlace"
// cWrapperName: "substituteInPlace__5"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, int x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (UserType (Namespace ["casadi"]) (Name "SX")),CBool]
// retType: CVoid
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "void"
// proto: "void substituteInPlace__5(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, int x2)"
// call: "casadi::substituteInPlace(x0_, x1_, x2_)"
extern "C"
void substituteInPlace__5(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, int x2);
void substituteInPlace__5(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, int x2){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);
        casadi::SX x1_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x1);
        bool x2_ = Marshaling<bool,int>::marshal(x2);

        casadi::substituteInPlace(x0_, x1_, x2_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::substituteInPlace" ===============
// cppName: "casadi::substituteInPlace"
// cWrapperName: "substituteInPlace__6"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, std::vector< casadi::SX* >* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (UserType (Namespace ["casadi"]) (Name "SX")),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: CVoid
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "void"
// proto: "void substituteInPlace__6(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, std::vector< casadi::SX* >* x2)"
// call: "casadi::substituteInPlace(x0_, x1_, x2_)"
extern "C"
void substituteInPlace__6(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, std::vector< casadi::SX* >* x2);
void substituteInPlace__6(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, std::vector< casadi::SX* >* x2){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);
        casadi::SX x1_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x1);
        std::vector< casadi::SX > x2_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x2);

        casadi::substituteInPlace(x0_, x1_, x2_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::substituteInPlace" ===============
// cppName: "casadi::substituteInPlace"
// cWrapperName: "substituteInPlace__7"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, std::vector< casadi::SX* >* x2, int x3)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (UserType (Namespace ["casadi"]) (Name "SX")),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))),CBool]
// retType: CVoid
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "void"
// proto: "void substituteInPlace__7(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, std::vector< casadi::SX* >* x2, int x3)"
// call: "casadi::substituteInPlace(x0_, x1_, x2_, x3_)"
extern "C"
void substituteInPlace__7(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, std::vector< casadi::SX* >* x2, int x3);
void substituteInPlace__7(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, std::vector< casadi::SX* >* x2, int x3){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);
        casadi::SX x1_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x1);
        std::vector< casadi::SX > x2_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x2);
        bool x3_ = Marshaling<bool,int>::marshal(x3);

        casadi::substituteInPlace(x0_, x1_, x2_, x3_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::substituteInPlace" ===============
// cppName: "casadi::substituteInPlace"
// cWrapperName: "substituteInPlace__8"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: CVoid
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "void"
// proto: "void substituteInPlace__8(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2)"
// call: "casadi::substituteInPlace(x0_, x1_, x2_)"
extern "C"
void substituteInPlace__8(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2);
void substituteInPlace__8(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::vector< casadi::SX > x1_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x1);
        std::vector< casadi::SX > x2_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x2);

        casadi::substituteInPlace(x0_, x1_, x2_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::substituteInPlace" ===============
// cppName: "casadi::substituteInPlace"
// cWrapperName: "substituteInPlace__9"
// protoArgs: "(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2, int x3)"
// params: [Ref (Const (StdVec (UserType (Namespace ["casadi"]) (Name "SX")))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (StdVec (UserType (Namespace ["casadi"]) (Name "SX"))),CBool]
// retType: CVoid
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "void"
// proto: "void substituteInPlace__9(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2, int x3)"
// call: "casadi::substituteInPlace(x0_, x1_, x2_, x3_)"
extern "C"
void substituteInPlace__9(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2, int x3);
void substituteInPlace__9(std::string ** err_msg, std::vector< casadi::SX* >* x0, std::vector< casadi::SX* >* x1, std::vector< casadi::SX* >* x2, int x3){
    try {
        std::vector< casadi::SX > x0_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x0);
        std::vector< casadi::SX > x1_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x1);
        std::vector< casadi::SX > x2_ = Marshaling<std::vector< casadi::SX >,std::vector< casadi::SX* >*>::marshal(x2);
        bool x3_ = Marshaling<bool,int>::marshal(x3);

        casadi::substituteInPlace(x0_, x1_, x2_, x3_);
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return;
    }
}


// ================== function "casadi::tangent" ===============
// cppName: "casadi::tangent"
// cWrapperName: "tangent__0"
// protoArgs: "(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "MX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "MX")))]
// retType: UserType (Namespace ["casadi"]) (Name "MX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::MX*"
// proto: "casadi::MX* tangent__0(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1)"
// call: "casadi::tangent(x0_, x1_)"
extern "C"
casadi::MX* tangent__0(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1);
casadi::MX* tangent__0(std::string ** err_msg, casadi::MX* x0, casadi::MX* x1){
    try {
        casadi::MX x0_ = Marshaling<casadi::MX,casadi::MX*>::marshal(x0);
        casadi::MX x1_ = Marshaling<casadi::MX,casadi::MX*>::marshal(x1);

        casadi::MX ret = casadi::tangent(x0_, x1_);
        return WrapReturn< casadi::MX*, casadi::MX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::tangent" ===============
// cppName: "casadi::tangent"
// cWrapperName: "tangent__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX* tangent__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// call: "casadi::tangent(x0_, x1_)"
extern "C"
casadi::SX* tangent__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX* tangent__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);
        casadi::SX x1_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x1);

        casadi::SX ret = casadi::tangent(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::taylor" ===============
// cppName: "casadi::taylor"
// cWrapperName: "taylor__0"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX* taylor__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1)"
// call: "casadi::taylor(x0_, x1_)"
extern "C"
casadi::SX* taylor__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1);
casadi::SX* taylor__0(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);
        casadi::SX x1_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x1);

        casadi::SX ret = casadi::taylor(x0_, x1_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::taylor" ===============
// cppName: "casadi::taylor"
// cWrapperName: "taylor__1"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX* taylor__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2)"
// call: "casadi::taylor(x0_, x1_, x2_)"
extern "C"
casadi::SX* taylor__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2);
casadi::SX* taylor__1(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);
        casadi::SX x1_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x1);
        casadi::SX x2_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x2);

        casadi::SX ret = casadi::taylor(x0_, x1_, x2_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::taylor" ===============
// cppName: "casadi::taylor"
// cWrapperName: "taylor__2"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, int x3)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),Ref (Const (UserType (Namespace ["casadi"]) (Name "SX"))),CInt]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_, x1_, x2_, x3_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX* taylor__2(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, int x3)"
// call: "casadi::taylor(x0_, x1_, x2_, x3_)"
extern "C"
casadi::SX* taylor__2(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, int x3);
casadi::SX* taylor__2(std::string ** err_msg, casadi::SX* x0, casadi::SX* x1, casadi::SX* x2, int x3){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);
        casadi::SX x1_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x1);
        casadi::SX x2_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x2);
        int x3_ = Marshaling<int,int>::marshal(x3);

        casadi::SX ret = casadi::taylor(x0_, x1_, x2_, x3_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


// ================== function "casadi::triangle" ===============
// cppName: "casadi::triangle"
// cWrapperName: "triangle"
// protoArgs: "(std::string ** err_msg, casadi::SX* x0)"
// params: [Ref (Const (UserType (Namespace ["casadi"]) (Name "SX")))]
// retType: UserType (Namespace ["casadi"]) (Name "SX")
// args: "(x0_)"
// cWrapperRetType: "casadi::SX*"
// proto: "casadi::SX* triangle(std::string ** err_msg, casadi::SX* x0)"
// call: "casadi::triangle(x0_)"
extern "C"
casadi::SX* triangle(std::string ** err_msg, casadi::SX* x0);
casadi::SX* triangle(std::string ** err_msg, casadi::SX* x0){
    try {
        casadi::SX x0_ = Marshaling<casadi::SX,casadi::SX*>::marshal(x0);

        casadi::SX ret = casadi::triangle(x0_);
        return WrapReturn< casadi::SX*, casadi::SX >::wrapReturn( ret );
    } catch (std::exception& ex) {
         *err_msg = new std::string(ex.what());
         return 0;
    }
}


